"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.CandlestickChartOptions = exports.CandlestickCandlestick = exports.TimelineOptions = exports.TimelineTimeline = exports.LabelStyle = exports.TableOptions = exports.CssClassNames = exports.TreeMapOptions = exports.BubbleChartOptions = exports.ChartBubble = exports.PieChartOptions = exports.SteppedAreaChartOptions = exports.AnnotationChartOptions = exports.AreaChartOptions = exports.HistogramOptions = exports.HistogramHistogram = exports.BarChartOptions = exports.LineChartOptions = exports.ColumnChartOptions = exports.ScatterChartOptions = exports.Trendline = exports.GroupWidth = exports.ChartBoundingBox = exports.ChartAxis = exports.ChartViewWindow = exports.ChartGridlines = exports.TransitionAnimation = exports.ChartArea = exports.ChartStroke = exports.ChartExplorer = exports.ChartCrosshair = exports.ChartCrosshairSelected = exports.ChartCrosshairFocused = exports.ChartAnnotations = exports.ChartBoxStyle = exports.ChartBoxStyleGradient = exports.GeoChartOptions = exports.GeoChartMagnifyingGlass = exports.ChartColorAxis = exports.ChartLegend = exports.ChartTooltip = exports.ChartTextStyle = exports.ChartSizeAxis = undefined;

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _Symbol2 = require("fable-core/umd/Symbol");

var _Symbol3 = _interopRequireDefault(_Symbol2);

var _Util = require("fable-core/umd/Util");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ChartSizeAxis = exports.ChartSizeAxis = function () {
    function ChartSizeAxis(maxSize, maxValue, minSize, minValue) {
        (0, _classCallCheck3.default)(this, ChartSizeAxis);
        this.maxSize = maxSize;
        this.maxValue = maxValue;
        this.minSize = minSize;
        this.minValue = minValue;
    }

    (0, _createClass3.default)(ChartSizeAxis, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.ChartSizeAxis",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    maxSize: "number",
                    maxValue: "number",
                    minSize: "number",
                    minValue: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return (0, _Util.compareRecords)(this, other);
        }
    }]);
    return ChartSizeAxis;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.ChartSizeAxis", ChartSizeAxis);

var ChartTextStyle = exports.ChartTextStyle = function () {
    function ChartTextStyle(fontName, fontSize, bold, italic, color, auraColor, opacity) {
        (0, _classCallCheck3.default)(this, ChartTextStyle);
        this.fontName = fontName;
        this.fontSize = fontSize;
        this.bold = bold;
        this.italic = italic;
        this.color = color;
        this.auraColor = auraColor;
        this.opacity = opacity;
    }

    (0, _createClass3.default)(ChartTextStyle, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.ChartTextStyle",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    fontName: "string",
                    fontSize: "number",
                    bold: "boolean",
                    italic: "boolean",
                    color: "string",
                    auraColor: "string",
                    opacity: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return (0, _Util.compareRecords)(this, other);
        }
    }]);
    return ChartTextStyle;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.ChartTextStyle", ChartTextStyle);

var ChartTooltip = exports.ChartTooltip = function () {
    function ChartTooltip(isHtml, showColorCode, textStyle, trigger) {
        (0, _classCallCheck3.default)(this, ChartTooltip);
        this.isHtml = isHtml;
        this.showColorCode = showColorCode;
        this.textStyle = textStyle;
        this.trigger = trigger;
    }

    (0, _createClass3.default)(ChartTooltip, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.ChartTooltip",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    isHtml: "boolean",
                    showColorCode: "boolean",
                    textStyle: ChartTextStyle,
                    trigger: "string"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return (0, _Util.compareRecords)(this, other);
        }
    }]);
    return ChartTooltip;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.ChartTooltip", ChartTooltip);

var ChartLegend = exports.ChartLegend = function () {
    function ChartLegend(alignment, maxLines, position, textStyle, numberFormat) {
        (0, _classCallCheck3.default)(this, ChartLegend);
        this.alignment = alignment;
        this.maxLines = maxLines;
        this.position = position;
        this.textStyle = textStyle;
        this.numberFormat = numberFormat;
    }

    (0, _createClass3.default)(ChartLegend, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.ChartLegend",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    alignment: "string",
                    maxLines: "number",
                    position: "string",
                    textStyle: ChartTextStyle,
                    numberFormat: "string"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return (0, _Util.compareRecords)(this, other);
        }
    }]);
    return ChartLegend;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.ChartLegend", ChartLegend);

var ChartColorAxis = exports.ChartColorAxis = function () {
    function ChartColorAxis(minValue, maxValue, values, colors, legend) {
        (0, _classCallCheck3.default)(this, ChartColorAxis);
        this.minValue = minValue;
        this.maxValue = maxValue;
        this.values = values;
        this.colors = colors;
        this.legend = legend;
    }

    (0, _createClass3.default)(ChartColorAxis, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.ChartColorAxis",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    minValue: "number",
                    maxValue: "number",
                    values: (0, _Util.Array)(Float64Array, true),
                    colors: (0, _Util.Array)("string"),
                    legend: ChartLegend
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return (0, _Util.compareRecords)(this, other);
        }
    }]);
    return ChartColorAxis;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.ChartColorAxis", ChartColorAxis);

var GeoChartMagnifyingGlass = exports.GeoChartMagnifyingGlass = function () {
    function GeoChartMagnifyingGlass(enable, zoomFactor) {
        (0, _classCallCheck3.default)(this, GeoChartMagnifyingGlass);
        this.enable = enable;
        this.zoomFactor = zoomFactor;
    }

    (0, _createClass3.default)(GeoChartMagnifyingGlass, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.GeoChartMagnifyingGlass",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    enable: "boolean",
                    zoomFactor: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return (0, _Util.compareRecords)(this, other);
        }
    }]);
    return GeoChartMagnifyingGlass;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.GeoChartMagnifyingGlass", GeoChartMagnifyingGlass);

var GeoChartOptions = exports.GeoChartOptions = function () {
    function GeoChartOptions(backgroundColor, colorAxis, datalessRegionColor, displayMode, enableRegionInteractivity, height, keepAspectRatio, legend, region, magnifyingGlass, markerOpacity, resolution, sizeAxis, tooltip, width) {
        (0, _classCallCheck3.default)(this, GeoChartOptions);
        this.backgroundColor = backgroundColor;
        this.colorAxis = colorAxis;
        this.datalessRegionColor = datalessRegionColor;
        this.displayMode = displayMode;
        this.enableRegionInteractivity = enableRegionInteractivity;
        this.height = height;
        this.keepAspectRatio = keepAspectRatio;
        this.legend = legend;
        this.region = region;
        this.magnifyingGlass = magnifyingGlass;
        this.markerOpacity = markerOpacity;
        this.resolution = resolution;
        this.sizeAxis = sizeAxis;
        this.tooltip = tooltip;
        this.width = width;
    }

    (0, _createClass3.default)(GeoChartOptions, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.GeoChartOptions",
                interfaces: ["FSharpRecord", "System.IEquatable"],
                properties: {
                    backgroundColor: _Util.Any,
                    colorAxis: ChartColorAxis,
                    datalessRegionColor: "string",
                    displayMode: "string",
                    enableRegionInteractivity: "boolean",
                    height: "number",
                    keepAspectRatio: "boolean",
                    legend: ChartLegend,
                    region: "string",
                    magnifyingGlass: GeoChartMagnifyingGlass,
                    markerOpacity: "number",
                    resolution: "string",
                    sizeAxis: ChartSizeAxis,
                    tooltip: ChartTooltip,
                    width: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }]);
    return GeoChartOptions;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.GeoChartOptions", GeoChartOptions);

var ChartBoxStyleGradient = exports.ChartBoxStyleGradient = function () {
    function ChartBoxStyleGradient(color1, color2, x1, y1, x2, y2, useObjectBoundingBoxUnits) {
        (0, _classCallCheck3.default)(this, ChartBoxStyleGradient);
        this.color1 = color1;
        this.color2 = color2;
        this.x1 = x1;
        this.y1 = y1;
        this.x2 = x2;
        this.y2 = y2;
        this.useObjectBoundingBoxUnits = useObjectBoundingBoxUnits;
    }

    (0, _createClass3.default)(ChartBoxStyleGradient, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.ChartBoxStyleGradient",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    color1: "string",
                    color2: "string",
                    x1: "string",
                    y1: "string",
                    x2: "string",
                    y2: "string",
                    useObjectBoundingBoxUnits: "boolean"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return (0, _Util.compareRecords)(this, other);
        }
    }]);
    return ChartBoxStyleGradient;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.ChartBoxStyleGradient", ChartBoxStyleGradient);

var ChartBoxStyle = exports.ChartBoxStyle = function () {
    function ChartBoxStyle(stroke, strokeWidth, rx, ry, gradient) {
        (0, _classCallCheck3.default)(this, ChartBoxStyle);
        this.stroke = stroke;
        this.strokeWidth = strokeWidth;
        this.rx = rx;
        this.ry = ry;
        this.gradient = gradient;
    }

    (0, _createClass3.default)(ChartBoxStyle, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.ChartBoxStyle",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    stroke: "string",
                    strokeWidth: "number",
                    rx: "number",
                    ry: "number",
                    gradient: ChartBoxStyleGradient
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return (0, _Util.compareRecords)(this, other);
        }
    }]);
    return ChartBoxStyle;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.ChartBoxStyle", ChartBoxStyle);

var ChartAnnotations = exports.ChartAnnotations = function () {
    function ChartAnnotations(boxStyle, textStyle) {
        (0, _classCallCheck3.default)(this, ChartAnnotations);
        this.boxStyle = boxStyle;
        this.textStyle = textStyle;
    }

    (0, _createClass3.default)(ChartAnnotations, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.ChartAnnotations",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    boxStyle: ChartBoxStyle,
                    textStyle: ChartTextStyle
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return (0, _Util.compareRecords)(this, other);
        }
    }]);
    return ChartAnnotations;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.ChartAnnotations", ChartAnnotations);

var ChartCrosshairFocused = exports.ChartCrosshairFocused = function () {
    function ChartCrosshairFocused(color, opacity) {
        (0, _classCallCheck3.default)(this, ChartCrosshairFocused);
        this.color = color;
        this.opacity = opacity;
    }

    (0, _createClass3.default)(ChartCrosshairFocused, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.ChartCrosshairFocused",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    color: "string",
                    opacity: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return (0, _Util.compareRecords)(this, other);
        }
    }]);
    return ChartCrosshairFocused;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.ChartCrosshairFocused", ChartCrosshairFocused);

var ChartCrosshairSelected = exports.ChartCrosshairSelected = function () {
    function ChartCrosshairSelected(color, opacity) {
        (0, _classCallCheck3.default)(this, ChartCrosshairSelected);
        this.color = color;
        this.opacity = opacity;
    }

    (0, _createClass3.default)(ChartCrosshairSelected, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.ChartCrosshairSelected",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    color: "string",
                    opacity: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return (0, _Util.compareRecords)(this, other);
        }
    }]);
    return ChartCrosshairSelected;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.ChartCrosshairSelected", ChartCrosshairSelected);

var ChartCrosshair = exports.ChartCrosshair = function () {
    function ChartCrosshair(color, focused, opacity, orientation, selected, trigger) {
        (0, _classCallCheck3.default)(this, ChartCrosshair);
        this.color = color;
        this.focused = focused;
        this.opacity = opacity;
        this.orientation = orientation;
        this.selected = selected;
        this.trigger = trigger;
    }

    (0, _createClass3.default)(ChartCrosshair, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.ChartCrosshair",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    color: "string",
                    focused: ChartCrosshairFocused,
                    opacity: "number",
                    orientation: "string",
                    selected: ChartCrosshairSelected,
                    trigger: "string"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return (0, _Util.compareRecords)(this, other);
        }
    }]);
    return ChartCrosshair;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.ChartCrosshair", ChartCrosshair);

var ChartExplorer = exports.ChartExplorer = function () {
    function ChartExplorer(actions, axis, keepInBounds, maxZoomIn, maxZoomOut, zoomDelta) {
        (0, _classCallCheck3.default)(this, ChartExplorer);
        this.actions = actions;
        this.axis = axis;
        this.keepInBounds = keepInBounds;
        this.maxZoomIn = maxZoomIn;
        this.maxZoomOut = maxZoomOut;
        this.zoomDelta = zoomDelta;
    }

    (0, _createClass3.default)(ChartExplorer, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.ChartExplorer",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    actions: (0, _Util.Array)("string"),
                    axis: "string",
                    keepInBounds: "boolean",
                    maxZoomIn: "number",
                    maxZoomOut: "number",
                    zoomDelta: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return (0, _Util.compareRecords)(this, other);
        }
    }]);
    return ChartExplorer;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.ChartExplorer", ChartExplorer);

var ChartStroke = exports.ChartStroke = function () {
    function ChartStroke(stroke, strokeWidth, fill) {
        (0, _classCallCheck3.default)(this, ChartStroke);
        this.stroke = stroke;
        this.strokeWidth = strokeWidth;
        this.fill = fill;
    }

    (0, _createClass3.default)(ChartStroke, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.ChartStroke",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    stroke: "string",
                    strokeWidth: "number",
                    fill: "string"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return (0, _Util.compareRecords)(this, other);
        }
    }]);
    return ChartStroke;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.ChartStroke", ChartStroke);

var ChartArea = exports.ChartArea = function () {
    function ChartArea(top, left, width, height) {
        (0, _classCallCheck3.default)(this, ChartArea);
        this.top = top;
        this.left = left;
        this.width = width;
        this.height = height;
    }

    (0, _createClass3.default)(ChartArea, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.ChartArea",
                interfaces: ["FSharpRecord", "System.IEquatable"],
                properties: {
                    top: _Util.Any,
                    left: _Util.Any,
                    width: _Util.Any,
                    height: _Util.Any
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }]);
    return ChartArea;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.ChartArea", ChartArea);

var TransitionAnimation = exports.TransitionAnimation = function () {
    function TransitionAnimation(duration, easing) {
        (0, _classCallCheck3.default)(this, TransitionAnimation);
        this.duration = duration;
        this.easing = easing;
    }

    (0, _createClass3.default)(TransitionAnimation, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.TransitionAnimation",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    duration: "number",
                    easing: "string"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return (0, _Util.compareRecords)(this, other);
        }
    }]);
    return TransitionAnimation;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.TransitionAnimation", TransitionAnimation);

var ChartGridlines = exports.ChartGridlines = function () {
    function ChartGridlines(color, count) {
        (0, _classCallCheck3.default)(this, ChartGridlines);
        this.color = color;
        this.count = count;
    }

    (0, _createClass3.default)(ChartGridlines, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.ChartGridlines",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    color: "string",
                    count: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return (0, _Util.compareRecords)(this, other);
        }
    }]);
    return ChartGridlines;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.ChartGridlines", ChartGridlines);

var ChartViewWindow = exports.ChartViewWindow = function () {
    function ChartViewWindow(max, min) {
        (0, _classCallCheck3.default)(this, ChartViewWindow);
        this.max = max;
        this.min = min;
    }

    (0, _createClass3.default)(ChartViewWindow, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.ChartViewWindow",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    max: "number",
                    min: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return (0, _Util.compareRecords)(this, other);
        }
    }]);
    return ChartViewWindow;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.ChartViewWindow", ChartViewWindow);

var ChartAxis = exports.ChartAxis = function () {
    function ChartAxis(baseline, baselineColor, direction, format, gridlines, minorGridlines, logScale, textPosition, textStyle, ticks, title, titleTextStyle, allowContainerBoundaryTextCufoff, slantedText, slantedTextAngle, maxAlternation, maxTextLines, minTextSpacing, showTextEvery, maxValue, minValue, viewWindowMode, viewWindow) {
        (0, _classCallCheck3.default)(this, ChartAxis);
        this.baseline = baseline;
        this.baselineColor = baselineColor;
        this.direction = direction;
        this.format = format;
        this.gridlines = gridlines;
        this.minorGridlines = minorGridlines;
        this.logScale = logScale;
        this.textPosition = textPosition;
        this.textStyle = textStyle;
        this.ticks = ticks;
        this.title = title;
        this.titleTextStyle = titleTextStyle;
        this.allowContainerBoundaryTextCufoff = allowContainerBoundaryTextCufoff;
        this.slantedText = slantedText;
        this.slantedTextAngle = slantedTextAngle;
        this.maxAlternation = maxAlternation;
        this.maxTextLines = maxTextLines;
        this.minTextSpacing = minTextSpacing;
        this.showTextEvery = showTextEvery;
        this.maxValue = maxValue;
        this.minValue = minValue;
        this.viewWindowMode = viewWindowMode;
        this.viewWindow = viewWindow;
    }

    (0, _createClass3.default)(ChartAxis, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.ChartAxis",
                interfaces: ["FSharpRecord", "System.IEquatable"],
                properties: {
                    baseline: "number",
                    baselineColor: "string",
                    direction: "number",
                    format: "string",
                    gridlines: ChartGridlines,
                    minorGridlines: ChartGridlines,
                    logScale: "boolean",
                    textPosition: "string",
                    textStyle: ChartTextStyle,
                    ticks: (0, _Util.Array)(_Util.Any),
                    title: "string",
                    titleTextStyle: ChartTextStyle,
                    allowContainerBoundaryTextCufoff: "boolean",
                    slantedText: "boolean",
                    slantedTextAngle: "number",
                    maxAlternation: "number",
                    maxTextLines: "number",
                    minTextSpacing: "number",
                    showTextEvery: "number",
                    maxValue: "number",
                    minValue: "number",
                    viewWindowMode: "string",
                    viewWindow: ChartViewWindow
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }]);
    return ChartAxis;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.ChartAxis", ChartAxis);

var ChartBoundingBox = exports.ChartBoundingBox = function () {
    function ChartBoundingBox(left, top, width, height) {
        (0, _classCallCheck3.default)(this, ChartBoundingBox);
        this.left = left;
        this.top = top;
        this.width = width;
        this.height = height;
    }

    (0, _createClass3.default)(ChartBoundingBox, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.ChartBoundingBox",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    left: "number",
                    top: "number",
                    width: "number",
                    height: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return (0, _Util.compareRecords)(this, other);
        }
    }]);
    return ChartBoundingBox;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.ChartBoundingBox", ChartBoundingBox);

var GroupWidth = exports.GroupWidth = function () {
    function GroupWidth(groupWidth) {
        (0, _classCallCheck3.default)(this, GroupWidth);
        this.groupWidth = groupWidth;
    }

    (0, _createClass3.default)(GroupWidth, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.GroupWidth",
                interfaces: ["FSharpRecord", "System.IEquatable"],
                properties: {
                    groupWidth: _Util.Any
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }]);
    return GroupWidth;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.GroupWidth", GroupWidth);

var Trendline = exports.Trendline = function () {
    function Trendline(color, lineWidth, labelInLegend, opacity, pointSize, pointsVisible, showR2, type, visibleInLegend) {
        (0, _classCallCheck3.default)(this, Trendline);
        this.color = color;
        this.lineWidth = lineWidth;
        this.labelInLegend = labelInLegend;
        this.opacity = opacity;
        this.pointSize = pointSize;
        this.pointsVisible = pointsVisible;
        this.showR2 = showR2;
        this.type = type;
        this.visibleInLegend = visibleInLegend;
    }

    (0, _createClass3.default)(Trendline, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.Trendline",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    color: "string",
                    lineWidth: "number",
                    labelInLegend: "string",
                    opacity: "number",
                    pointSize: "number",
                    pointsVisible: "boolean",
                    showR2: "boolean",
                    type: "string",
                    visibleInLegend: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return (0, _Util.compareRecords)(this, other);
        }
    }]);
    return Trendline;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.Trendline", Trendline);

var ScatterChartOptions = exports.ScatterChartOptions = function () {
    function ScatterChartOptions(aggregationTarget, animation, annotations, axisTitlesPosition, backgroundColor, chartArea, colors, crosshair, curveType, dataOpacity, enableInteractivity, explorer, fontSize, fontName, forceIFrame, hAxis, height, legend, lineWidth, pointSize, selectionMode, series, theme, title, titlePosition, titleTextStyle, tooltip, trendlines, vAxis, width) {
        (0, _classCallCheck3.default)(this, ScatterChartOptions);
        this.aggregationTarget = aggregationTarget;
        this.animation = animation;
        this.annotations = annotations;
        this.axisTitlesPosition = axisTitlesPosition;
        this.backgroundColor = backgroundColor;
        this.chartArea = chartArea;
        this.colors = colors;
        this.crosshair = crosshair;
        this.curveType = curveType;
        this.dataOpacity = dataOpacity;
        this.enableInteractivity = enableInteractivity;
        this.explorer = explorer;
        this.fontSize = fontSize;
        this.fontName = fontName;
        this.forceIFrame = forceIFrame;
        this.hAxis = hAxis;
        this.height = height;
        this.legend = legend;
        this.lineWidth = lineWidth;
        this.pointSize = pointSize;
        this.selectionMode = selectionMode;
        this.series = series;
        this.theme = theme;
        this.title = title;
        this.titlePosition = titlePosition;
        this.titleTextStyle = titleTextStyle;
        this.tooltip = tooltip;
        this.trendlines = trendlines;
        this.vAxis = vAxis;
        this.width = width;
    }

    (0, _createClass3.default)(ScatterChartOptions, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.ScatterChartOptions",
                interfaces: ["FSharpRecord", "System.IEquatable"],
                properties: {
                    aggregationTarget: "string",
                    animation: TransitionAnimation,
                    annotations: ChartAnnotations,
                    axisTitlesPosition: "string",
                    backgroundColor: _Util.Any,
                    chartArea: ChartArea,
                    colors: (0, _Util.Array)("string"),
                    crosshair: ChartCrosshair,
                    curveType: "string",
                    dataOpacity: "number",
                    enableInteractivity: "boolean",
                    explorer: ChartExplorer,
                    fontSize: "number",
                    fontName: "string",
                    forceIFrame: "boolean",
                    hAxis: ChartAxis,
                    height: "number",
                    legend: ChartLegend,
                    lineWidth: "number",
                    pointSize: "number",
                    selectionMode: "string",
                    series: _Util.Any,
                    theme: "string",
                    title: "string",
                    titlePosition: "string",
                    titleTextStyle: ChartTextStyle,
                    tooltip: ChartTooltip,
                    trendlines: (0, _Util.Array)(Trendline),
                    vAxis: ChartAxis,
                    width: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }]);
    return ScatterChartOptions;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.ScatterChartOptions", ScatterChartOptions);

var ColumnChartOptions = exports.ColumnChartOptions = function () {
    function ColumnChartOptions(aggregationTarget, animation, annotations, axisTitlesPosition, backgroundColor, bar, chartArea, colors, enableInteractivity, focusTarget, fontSize, fontName, hAxis, height, isStacked, legend, reverseCategories, selectionMode, series, theme, title, titlePosition, titleTextStyle, tooltip, vAxes, vAxis, width) {
        (0, _classCallCheck3.default)(this, ColumnChartOptions);
        this.aggregationTarget = aggregationTarget;
        this.animation = animation;
        this.annotations = annotations;
        this.axisTitlesPosition = axisTitlesPosition;
        this.backgroundColor = backgroundColor;
        this.bar = bar;
        this.chartArea = chartArea;
        this.colors = colors;
        this.enableInteractivity = enableInteractivity;
        this.focusTarget = focusTarget;
        this.fontSize = fontSize;
        this.fontName = fontName;
        this.hAxis = hAxis;
        this.height = height;
        this.isStacked = isStacked;
        this.legend = legend;
        this.reverseCategories = reverseCategories;
        this.selectionMode = selectionMode;
        this.series = series;
        this.theme = theme;
        this.title = title;
        this.titlePosition = titlePosition;
        this.titleTextStyle = titleTextStyle;
        this.tooltip = tooltip;
        this.vAxes = vAxes;
        this.vAxis = vAxis;
        this.width = width;
    }

    (0, _createClass3.default)(ColumnChartOptions, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.ColumnChartOptions",
                interfaces: ["FSharpRecord", "System.IEquatable"],
                properties: {
                    aggregationTarget: "string",
                    animation: TransitionAnimation,
                    annotations: ChartAnnotations,
                    axisTitlesPosition: "string",
                    backgroundColor: _Util.Any,
                    bar: GroupWidth,
                    chartArea: ChartArea,
                    colors: (0, _Util.Array)("string"),
                    enableInteractivity: "boolean",
                    focusTarget: "string",
                    fontSize: "number",
                    fontName: "string",
                    hAxis: ChartAxis,
                    height: "number",
                    isStacked: "boolean",
                    legend: ChartLegend,
                    reverseCategories: "boolean",
                    selectionMode: "string",
                    series: _Util.Any,
                    theme: "string",
                    title: "string",
                    titlePosition: "string",
                    titleTextStyle: ChartTextStyle,
                    tooltip: ChartTooltip,
                    vAxes: _Util.Any,
                    vAxis: ChartAxis,
                    width: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }]);
    return ColumnChartOptions;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.ColumnChartOptions", ColumnChartOptions);

var LineChartOptions = exports.LineChartOptions = function () {
    function LineChartOptions(aggregationTarget, animation, annotations, axisTitlesPosition, backgroundColor, chartArea, colors, crosshair, curveType, dataOpacity, enableInteractivity, explorer, focusTarget, fontSize, fontName, hAxis, height, interpolateNulls, legend, lineWidth, orientation, pointSize, reverseCategories, selectionMode, series, theme, title, titlePosition, titleTextStyle, tooltip, vAxes, vAxis, width) {
        (0, _classCallCheck3.default)(this, LineChartOptions);
        this.aggregationTarget = aggregationTarget;
        this.animation = animation;
        this.annotations = annotations;
        this.axisTitlesPosition = axisTitlesPosition;
        this.backgroundColor = backgroundColor;
        this.chartArea = chartArea;
        this.colors = colors;
        this.crosshair = crosshair;
        this.curveType = curveType;
        this.dataOpacity = dataOpacity;
        this.enableInteractivity = enableInteractivity;
        this.explorer = explorer;
        this.focusTarget = focusTarget;
        this.fontSize = fontSize;
        this.fontName = fontName;
        this.hAxis = hAxis;
        this.height = height;
        this.interpolateNulls = interpolateNulls;
        this.legend = legend;
        this.lineWidth = lineWidth;
        this.orientation = orientation;
        this.pointSize = pointSize;
        this.reverseCategories = reverseCategories;
        this.selectionMode = selectionMode;
        this.series = series;
        this.theme = theme;
        this.title = title;
        this.titlePosition = titlePosition;
        this.titleTextStyle = titleTextStyle;
        this.tooltip = tooltip;
        this.vAxes = vAxes;
        this.vAxis = vAxis;
        this.width = width;
    }

    (0, _createClass3.default)(LineChartOptions, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.LineChartOptions",
                interfaces: ["FSharpRecord", "System.IEquatable"],
                properties: {
                    aggregationTarget: "string",
                    animation: TransitionAnimation,
                    annotations: ChartAnnotations,
                    axisTitlesPosition: "string",
                    backgroundColor: _Util.Any,
                    chartArea: ChartArea,
                    colors: (0, _Util.Array)("string"),
                    crosshair: ChartCrosshair,
                    curveType: "string",
                    dataOpacity: "number",
                    enableInteractivity: "boolean",
                    explorer: ChartExplorer,
                    focusTarget: "string",
                    fontSize: "number",
                    fontName: "string",
                    hAxis: ChartAxis,
                    height: "number",
                    interpolateNulls: "boolean",
                    legend: ChartLegend,
                    lineWidth: "number",
                    orientation: "string",
                    pointSize: "number",
                    reverseCategories: "boolean",
                    selectionMode: "string",
                    series: _Util.Any,
                    theme: "string",
                    title: "string",
                    titlePosition: "string",
                    titleTextStyle: ChartTextStyle,
                    tooltip: ChartTooltip,
                    vAxes: _Util.Any,
                    vAxis: ChartAxis,
                    width: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }]);
    return LineChartOptions;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.LineChartOptions", LineChartOptions);

var BarChartOptions = exports.BarChartOptions = function () {
    function BarChartOptions(aggregationTarget, animation, annotations, axisTitlesPosition, backgroundColor, bar, chartArea, colors, dataOpacity, enableInteractivity, focusTarget, fontSize, fontName, hAxes, hAxis, height, isStacked, legend, reverseCategories, series, theme, title, titlePosition, titleTextStyle, tooltip, vAxes, vAxis, width) {
        (0, _classCallCheck3.default)(this, BarChartOptions);
        this.aggregationTarget = aggregationTarget;
        this.animation = animation;
        this.annotations = annotations;
        this.axisTitlesPosition = axisTitlesPosition;
        this.backgroundColor = backgroundColor;
        this.bar = bar;
        this.chartArea = chartArea;
        this.colors = colors;
        this.dataOpacity = dataOpacity;
        this.enableInteractivity = enableInteractivity;
        this.focusTarget = focusTarget;
        this.fontSize = fontSize;
        this.fontName = fontName;
        this.hAxes = hAxes;
        this.hAxis = hAxis;
        this.height = height;
        this.isStacked = isStacked;
        this.legend = legend;
        this.reverseCategories = reverseCategories;
        this.series = series;
        this.theme = theme;
        this.title = title;
        this.titlePosition = titlePosition;
        this.titleTextStyle = titleTextStyle;
        this.tooltip = tooltip;
        this.vAxes = vAxes;
        this.vAxis = vAxis;
        this.width = width;
    }

    (0, _createClass3.default)(BarChartOptions, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.BarChartOptions",
                interfaces: ["FSharpRecord", "System.IEquatable"],
                properties: {
                    aggregationTarget: "string",
                    animation: TransitionAnimation,
                    annotations: ChartAnnotations,
                    axisTitlesPosition: "string",
                    backgroundColor: _Util.Any,
                    bar: GroupWidth,
                    chartArea: ChartArea,
                    colors: (0, _Util.Array)("string"),
                    dataOpacity: "number",
                    enableInteractivity: "boolean",
                    focusTarget: "string",
                    fontSize: "number",
                    fontName: "string",
                    hAxes: _Util.Any,
                    hAxis: ChartAxis,
                    height: "number",
                    isStacked: "boolean",
                    legend: ChartLegend,
                    reverseCategories: "boolean",
                    series: _Util.Any,
                    theme: "string",
                    title: "string",
                    titlePosition: "string",
                    titleTextStyle: ChartTextStyle,
                    tooltip: ChartTooltip,
                    vAxes: _Util.Any,
                    vAxis: ChartAxis,
                    width: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }]);
    return BarChartOptions;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.BarChartOptions", BarChartOptions);

var HistogramHistogram = exports.HistogramHistogram = function () {
    function HistogramHistogram(bucketSize, hideBucketItems, lastBucketPercentile) {
        (0, _classCallCheck3.default)(this, HistogramHistogram);
        this.bucketSize = bucketSize;
        this.hideBucketItems = hideBucketItems;
        this.lastBucketPercentile = lastBucketPercentile;
    }

    (0, _createClass3.default)(HistogramHistogram, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.HistogramHistogram",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    bucketSize: "number",
                    hideBucketItems: "boolean",
                    lastBucketPercentile: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return (0, _Util.compareRecords)(this, other);
        }
    }]);
    return HistogramHistogram;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.HistogramHistogram", HistogramHistogram);

var HistogramOptions = exports.HistogramOptions = function () {
    function HistogramOptions(animation, axisTitlesPosition, backgroundColor, bar, chartArea, colors, dataOpacity, enableInteractivity, focusTarget, fontSize, fontName, hAxis, histogram, height, interpolateNulls, isStacked, legend, orientation, reverseCategories, series, theme, title, titlePosition, titleTextStyle, tooltip, vAxes, vAxis, width) {
        (0, _classCallCheck3.default)(this, HistogramOptions);
        this.animation = animation;
        this.axisTitlesPosition = axisTitlesPosition;
        this.backgroundColor = backgroundColor;
        this.bar = bar;
        this.chartArea = chartArea;
        this.colors = colors;
        this.dataOpacity = dataOpacity;
        this.enableInteractivity = enableInteractivity;
        this.focusTarget = focusTarget;
        this.fontSize = fontSize;
        this.fontName = fontName;
        this.hAxis = hAxis;
        this.histogram = histogram;
        this.height = height;
        this.interpolateNulls = interpolateNulls;
        this.isStacked = isStacked;
        this.legend = legend;
        this.orientation = orientation;
        this.reverseCategories = reverseCategories;
        this.series = series;
        this.theme = theme;
        this.title = title;
        this.titlePosition = titlePosition;
        this.titleTextStyle = titleTextStyle;
        this.tooltip = tooltip;
        this.vAxes = vAxes;
        this.vAxis = vAxis;
        this.width = width;
    }

    (0, _createClass3.default)(HistogramOptions, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.HistogramOptions",
                interfaces: ["FSharpRecord", "System.IEquatable"],
                properties: {
                    animation: TransitionAnimation,
                    axisTitlesPosition: "string",
                    backgroundColor: _Util.Any,
                    bar: GroupWidth,
                    chartArea: ChartArea,
                    colors: (0, _Util.Array)("string"),
                    dataOpacity: "number",
                    enableInteractivity: "boolean",
                    focusTarget: "string",
                    fontSize: "number",
                    fontName: "string",
                    hAxis: ChartAxis,
                    histogram: HistogramHistogram,
                    height: "number",
                    interpolateNulls: "boolean",
                    isStacked: "boolean",
                    legend: ChartLegend,
                    orientation: "string",
                    reverseCategories: "boolean",
                    series: _Util.Any,
                    theme: "string",
                    title: "string",
                    titlePosition: "string",
                    titleTextStyle: ChartTextStyle,
                    tooltip: ChartTooltip,
                    vAxes: _Util.Any,
                    vAxis: ChartAxis,
                    width: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }]);
    return HistogramOptions;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.HistogramOptions", HistogramOptions);

var AreaChartOptions = exports.AreaChartOptions = function () {
    function AreaChartOptions(aggregationTarget, animation, areaOpacity, axisTitlesPosition, backgroundColor, chartArea, colors, crosshair, dataOpacity, enableInteractivity, explorer, focusTarget, fontSize, fontName, hAxis, height, interpolateNulls, isStacked, legend, lineWidth, orientation, pointSize, reverseCategories, selectionMode, series, theme, title, titlePosition, titleTextStyle, tooltip, vAxes, vAxis, width) {
        (0, _classCallCheck3.default)(this, AreaChartOptions);
        this.aggregationTarget = aggregationTarget;
        this.animation = animation;
        this.areaOpacity = areaOpacity;
        this.axisTitlesPosition = axisTitlesPosition;
        this.backgroundColor = backgroundColor;
        this.chartArea = chartArea;
        this.colors = colors;
        this.crosshair = crosshair;
        this.dataOpacity = dataOpacity;
        this.enableInteractivity = enableInteractivity;
        this.explorer = explorer;
        this.focusTarget = focusTarget;
        this.fontSize = fontSize;
        this.fontName = fontName;
        this.hAxis = hAxis;
        this.height = height;
        this.interpolateNulls = interpolateNulls;
        this.isStacked = isStacked;
        this.legend = legend;
        this.lineWidth = lineWidth;
        this.orientation = orientation;
        this.pointSize = pointSize;
        this.reverseCategories = reverseCategories;
        this.selectionMode = selectionMode;
        this.series = series;
        this.theme = theme;
        this.title = title;
        this.titlePosition = titlePosition;
        this.titleTextStyle = titleTextStyle;
        this.tooltip = tooltip;
        this.vAxes = vAxes;
        this.vAxis = vAxis;
        this.width = width;
    }

    (0, _createClass3.default)(AreaChartOptions, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.AreaChartOptions",
                interfaces: ["FSharpRecord", "System.IEquatable"],
                properties: {
                    aggregationTarget: "string",
                    animation: TransitionAnimation,
                    areaOpacity: "number",
                    axisTitlesPosition: "string",
                    backgroundColor: _Util.Any,
                    chartArea: ChartArea,
                    colors: (0, _Util.Array)("string"),
                    crosshair: ChartCrosshair,
                    dataOpacity: "number",
                    enableInteractivity: "boolean",
                    explorer: ChartExplorer,
                    focusTarget: "string",
                    fontSize: "number",
                    fontName: "string",
                    hAxis: ChartAxis,
                    height: "number",
                    interpolateNulls: "boolean",
                    isStacked: "boolean",
                    legend: ChartLegend,
                    lineWidth: "number",
                    orientation: "string",
                    pointSize: "number",
                    reverseCategories: "boolean",
                    selectionMode: "string",
                    series: _Util.Any,
                    theme: "string",
                    title: "string",
                    titlePosition: "string",
                    titleTextStyle: ChartTextStyle,
                    tooltip: ChartTooltip,
                    vAxes: _Util.Any,
                    vAxis: ChartAxis,
                    width: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }]);
    return AreaChartOptions;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.AreaChartOptions", AreaChartOptions);

var AnnotationChartOptions = exports.AnnotationChartOptions = function () {
    function AnnotationChartOptions(allowHtml, allValuesSuffix, annotationsWidth, colors, dateFormat, displayAnnotations, displayAnnotationsFilter, displayDateTimeBarSeparator, displayExactValues, displayLegendDots, displayLegendValues, displayRangeSelector, displayZoomButtons, fill, legendPosition, max, min, numberFormats, scaleColumns, scaleFormat, scaleType, thickness, zoomEndTime, zoomStartTime) {
        (0, _classCallCheck3.default)(this, AnnotationChartOptions);
        this.allowHtml = allowHtml;
        this.allValuesSuffix = allValuesSuffix;
        this.annotationsWidth = annotationsWidth;
        this.colors = colors;
        this.dateFormat = dateFormat;
        this.displayAnnotations = displayAnnotations;
        this.displayAnnotationsFilter = displayAnnotationsFilter;
        this.displayDateTimeBarSeparator = displayDateTimeBarSeparator;
        this.displayExactValues = displayExactValues;
        this.displayLegendDots = displayLegendDots;
        this.displayLegendValues = displayLegendValues;
        this.displayRangeSelector = displayRangeSelector;
        this.displayZoomButtons = displayZoomButtons;
        this.fill = fill;
        this.legendPosition = legendPosition;
        this.max = max;
        this.min = min;
        this.numberFormats = numberFormats;
        this.scaleColumns = scaleColumns;
        this.scaleFormat = scaleFormat;
        this.scaleType = scaleType;
        this.thickness = thickness;
        this.zoomEndTime = zoomEndTime;
        this.zoomStartTime = zoomStartTime;
    }

    (0, _createClass3.default)(AnnotationChartOptions, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.AnnotationChartOptions",
                interfaces: ["FSharpRecord", "System.IEquatable"],
                properties: {
                    allowHtml: "boolean",
                    allValuesSuffix: "string",
                    annotationsWidth: "number",
                    colors: (0, _Util.Array)("string"),
                    dateFormat: "string",
                    displayAnnotations: "boolean",
                    displayAnnotationsFilter: "boolean",
                    displayDateTimeBarSeparator: "boolean",
                    displayExactValues: "boolean",
                    displayLegendDots: "boolean",
                    displayLegendValues: "boolean",
                    displayRangeSelector: "boolean",
                    displayZoomButtons: "boolean",
                    fill: "number",
                    legendPosition: "string",
                    max: "number",
                    min: "number",
                    numberFormats: _Util.Any,
                    scaleColumns: (0, _Util.Array)(Float64Array, true),
                    scaleFormat: "string",
                    scaleType: "string",
                    thickness: "number",
                    zoomEndTime: Date,
                    zoomStartTime: Date
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }]);
    return AnnotationChartOptions;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.AnnotationChartOptions", AnnotationChartOptions);

var SteppedAreaChartOptions = exports.SteppedAreaChartOptions = function () {
    function SteppedAreaChartOptions(aggregationTarget, animation, areaOpacity, axisTitlesPosition, backgroundColor, chartArea, colors, connectSteps, enableInteractivity, focusTarget, fontSize, fontName, hAxis, height, interpolateNulls, isStacked, legend, reverseCategories, selectionMode, series, theme, title, titlePosition, titleTextStyle, tooltip, vAxes, vAxis, width) {
        (0, _classCallCheck3.default)(this, SteppedAreaChartOptions);
        this.aggregationTarget = aggregationTarget;
        this.animation = animation;
        this.areaOpacity = areaOpacity;
        this.axisTitlesPosition = axisTitlesPosition;
        this.backgroundColor = backgroundColor;
        this.chartArea = chartArea;
        this.colors = colors;
        this.connectSteps = connectSteps;
        this.enableInteractivity = enableInteractivity;
        this.focusTarget = focusTarget;
        this.fontSize = fontSize;
        this.fontName = fontName;
        this.hAxis = hAxis;
        this.height = height;
        this.interpolateNulls = interpolateNulls;
        this.isStacked = isStacked;
        this.legend = legend;
        this.reverseCategories = reverseCategories;
        this.selectionMode = selectionMode;
        this.series = series;
        this.theme = theme;
        this.title = title;
        this.titlePosition = titlePosition;
        this.titleTextStyle = titleTextStyle;
        this.tooltip = tooltip;
        this.vAxes = vAxes;
        this.vAxis = vAxis;
        this.width = width;
    }

    (0, _createClass3.default)(SteppedAreaChartOptions, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.SteppedAreaChartOptions",
                interfaces: ["FSharpRecord", "System.IEquatable"],
                properties: {
                    aggregationTarget: "string",
                    animation: TransitionAnimation,
                    areaOpacity: "number",
                    axisTitlesPosition: "string",
                    backgroundColor: _Util.Any,
                    chartArea: ChartArea,
                    colors: (0, _Util.Array)("string"),
                    connectSteps: "boolean",
                    enableInteractivity: "boolean",
                    focusTarget: "string",
                    fontSize: "number",
                    fontName: "string",
                    hAxis: ChartAxis,
                    height: "number",
                    interpolateNulls: "boolean",
                    isStacked: "boolean",
                    legend: ChartLegend,
                    reverseCategories: "boolean",
                    selectionMode: "string",
                    series: _Util.Any,
                    theme: "string",
                    title: "string",
                    titlePosition: "string",
                    titleTextStyle: ChartTextStyle,
                    tooltip: ChartTooltip,
                    vAxes: _Util.Any,
                    vAxis: ChartAxis,
                    width: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }]);
    return SteppedAreaChartOptions;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.SteppedAreaChartOptions", SteppedAreaChartOptions);

var PieChartOptions = exports.PieChartOptions = function () {
    function PieChartOptions(backgroundColor, chartArea, colors, enableInteractivity, fontSize, fontName, height, is3D, legend, pieHole, pieSliceBorderColor, pieSliceText, pieSliceTextStyle, pieStartAngle, reverseCategories, pieResidueSliceColor, pieResidueSliceLabel, slices, sliceVisibilityThreshold, title, titleTextStyle, tooltip, width) {
        (0, _classCallCheck3.default)(this, PieChartOptions);
        this.backgroundColor = backgroundColor;
        this.chartArea = chartArea;
        this.colors = colors;
        this.enableInteractivity = enableInteractivity;
        this.fontSize = fontSize;
        this.fontName = fontName;
        this.height = height;
        this.is3D = is3D;
        this.legend = legend;
        this.pieHole = pieHole;
        this.pieSliceBorderColor = pieSliceBorderColor;
        this.pieSliceText = pieSliceText;
        this.pieSliceTextStyle = pieSliceTextStyle;
        this.pieStartAngle = pieStartAngle;
        this.reverseCategories = reverseCategories;
        this.pieResidueSliceColor = pieResidueSliceColor;
        this.pieResidueSliceLabel = pieResidueSliceLabel;
        this.slices = slices;
        this.sliceVisibilityThreshold = sliceVisibilityThreshold;
        this.title = title;
        this.titleTextStyle = titleTextStyle;
        this.tooltip = tooltip;
        this.width = width;
    }

    (0, _createClass3.default)(PieChartOptions, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.PieChartOptions",
                interfaces: ["FSharpRecord", "System.IEquatable"],
                properties: {
                    backgroundColor: _Util.Any,
                    chartArea: ChartArea,
                    colors: (0, _Util.Array)("string"),
                    enableInteractivity: "boolean",
                    fontSize: "number",
                    fontName: "string",
                    height: "number",
                    is3D: "boolean",
                    legend: ChartLegend,
                    pieHole: "number",
                    pieSliceBorderColor: "string",
                    pieSliceText: "string",
                    pieSliceTextStyle: ChartTextStyle,
                    pieStartAngle: "number",
                    reverseCategories: "boolean",
                    pieResidueSliceColor: "string",
                    pieResidueSliceLabel: "string",
                    slices: _Util.Any,
                    sliceVisibilityThreshold: "number",
                    title: "string",
                    titleTextStyle: ChartTextStyle,
                    tooltip: ChartTooltip,
                    width: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }]);
    return PieChartOptions;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.PieChartOptions", PieChartOptions);

var ChartBubble = exports.ChartBubble = function () {
    function ChartBubble(opacity, stroke, textStyle) {
        (0, _classCallCheck3.default)(this, ChartBubble);
        this.opacity = opacity;
        this.stroke = stroke;
        this.textStyle = textStyle;
    }

    (0, _createClass3.default)(ChartBubble, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.ChartBubble",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    opacity: "number",
                    stroke: "string",
                    textStyle: ChartTextStyle
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return (0, _Util.compareRecords)(this, other);
        }
    }]);
    return ChartBubble;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.ChartBubble", ChartBubble);

var BubbleChartOptions = exports.BubbleChartOptions = function () {
    function BubbleChartOptions(animation, axisTitlesPosition, backgroundColor, bubble, chartArea, colors, colorAxis, enableInteractivity, explorer, fontSize, fontName, forceIFrame, hAxis, height, legend, selectionMode, series, sizeAxis, sortBubblesBySize, theme, title, titlePosition, titleTextStyle, tooltip, vAxis, width) {
        (0, _classCallCheck3.default)(this, BubbleChartOptions);
        this.animation = animation;
        this.axisTitlesPosition = axisTitlesPosition;
        this.backgroundColor = backgroundColor;
        this.bubble = bubble;
        this.chartArea = chartArea;
        this.colors = colors;
        this.colorAxis = colorAxis;
        this.enableInteractivity = enableInteractivity;
        this.explorer = explorer;
        this.fontSize = fontSize;
        this.fontName = fontName;
        this.forceIFrame = forceIFrame;
        this.hAxis = hAxis;
        this.height = height;
        this.legend = legend;
        this.selectionMode = selectionMode;
        this.series = series;
        this.sizeAxis = sizeAxis;
        this.sortBubblesBySize = sortBubblesBySize;
        this.theme = theme;
        this.title = title;
        this.titlePosition = titlePosition;
        this.titleTextStyle = titleTextStyle;
        this.tooltip = tooltip;
        this.vAxis = vAxis;
        this.width = width;
    }

    (0, _createClass3.default)(BubbleChartOptions, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.BubbleChartOptions",
                interfaces: ["FSharpRecord", "System.IEquatable"],
                properties: {
                    animation: TransitionAnimation,
                    axisTitlesPosition: "string",
                    backgroundColor: _Util.Any,
                    bubble: ChartBubble,
                    chartArea: ChartArea,
                    colors: (0, _Util.Array)("string"),
                    colorAxis: ChartColorAxis,
                    enableInteractivity: "boolean",
                    explorer: ChartExplorer,
                    fontSize: "number",
                    fontName: "string",
                    forceIFrame: "boolean",
                    hAxis: ChartAxis,
                    height: "number",
                    legend: ChartLegend,
                    selectionMode: "string",
                    series: _Util.Any,
                    sizeAxis: ChartSizeAxis,
                    sortBubblesBySize: "boolean",
                    theme: "string",
                    title: "string",
                    titlePosition: "string",
                    titleTextStyle: ChartTextStyle,
                    tooltip: ChartTooltip,
                    vAxis: ChartAxis,
                    width: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }]);
    return BubbleChartOptions;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.BubbleChartOptions", BubbleChartOptions);

var TreeMapOptions = exports.TreeMapOptions = function () {
    function TreeMapOptions(fontColor, fontFamily, fontSize, forceIFrame, headerColor, headerHeight, headerHighlightColor, hintOpacity, maxColor, maxDepth, maxHighlightColor, maxPostDepth, maxColorValue, midColor, midHighlightColor, minColor, minHighlightColor, minColorValue, showScale, showTooltips, textStyle, title, titleTextStyle, useWeightedAverageForAggregation) {
        (0, _classCallCheck3.default)(this, TreeMapOptions);
        this.fontColor = fontColor;
        this.fontFamily = fontFamily;
        this.fontSize = fontSize;
        this.forceIFrame = forceIFrame;
        this.headerColor = headerColor;
        this.headerHeight = headerHeight;
        this.headerHighlightColor = headerHighlightColor;
        this.hintOpacity = hintOpacity;
        this.maxColor = maxColor;
        this.maxDepth = maxDepth;
        this.maxHighlightColor = maxHighlightColor;
        this.maxPostDepth = maxPostDepth;
        this.maxColorValue = maxColorValue;
        this.midColor = midColor;
        this.midHighlightColor = midHighlightColor;
        this.minColor = minColor;
        this.minHighlightColor = minHighlightColor;
        this.minColorValue = minColorValue;
        this.showScale = showScale;
        this.showTooltips = showTooltips;
        this.textStyle = textStyle;
        this.title = title;
        this.titleTextStyle = titleTextStyle;
        this.useWeightedAverageForAggregation = useWeightedAverageForAggregation;
    }

    (0, _createClass3.default)(TreeMapOptions, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.TreeMapOptions",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    fontColor: "string",
                    fontFamily: "string",
                    fontSize: "number",
                    forceIFrame: "boolean",
                    headerColor: "string",
                    headerHeight: "number",
                    headerHighlightColor: "string",
                    hintOpacity: "number",
                    maxColor: "string",
                    maxDepth: "number",
                    maxHighlightColor: "string",
                    maxPostDepth: "number",
                    maxColorValue: "number",
                    midColor: "string",
                    midHighlightColor: "string",
                    minColor: "string",
                    minHighlightColor: "string",
                    minColorValue: "number",
                    showScale: "boolean",
                    showTooltips: "boolean",
                    textStyle: ChartTextStyle,
                    title: "string",
                    titleTextStyle: ChartTextStyle,
                    useWeightedAverageForAggregation: "boolean"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return (0, _Util.compareRecords)(this, other);
        }
    }]);
    return TreeMapOptions;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.TreeMapOptions", TreeMapOptions);

var CssClassNames = exports.CssClassNames = function () {
    function CssClassNames(headerRow, tableRow, oddTableRow, selectedTableRow, hoverTableRow, headerCell, tableCell, rowNumberCell) {
        (0, _classCallCheck3.default)(this, CssClassNames);
        this.headerRow = headerRow;
        this.tableRow = tableRow;
        this.oddTableRow = oddTableRow;
        this.selectedTableRow = selectedTableRow;
        this.hoverTableRow = hoverTableRow;
        this.headerCell = headerCell;
        this.tableCell = tableCell;
        this.rowNumberCell = rowNumberCell;
    }

    (0, _createClass3.default)(CssClassNames, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.CssClassNames",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    headerRow: "string",
                    tableRow: "string",
                    oddTableRow: "string",
                    selectedTableRow: "string",
                    hoverTableRow: "string",
                    headerCell: "string",
                    tableCell: "string",
                    rowNumberCell: "string"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return (0, _Util.compareRecords)(this, other);
        }
    }]);
    return CssClassNames;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.CssClassNames", CssClassNames);

var TableOptions = exports.TableOptions = function () {
    function TableOptions(allowHtml, alternatingRowStyle, cssClassName, firstRowNumber, height, page, pageSize, rtlTable, scrollLeftStartPosition, showRowNumber, sort, sortAscending, sortColumn, startPage, width) {
        (0, _classCallCheck3.default)(this, TableOptions);
        this.allowHtml = allowHtml;
        this.alternatingRowStyle = alternatingRowStyle;
        this.cssClassName = cssClassName;
        this.firstRowNumber = firstRowNumber;
        this.height = height;
        this.page = page;
        this.pageSize = pageSize;
        this.rtlTable = rtlTable;
        this.scrollLeftStartPosition = scrollLeftStartPosition;
        this.showRowNumber = showRowNumber;
        this.sort = sort;
        this.sortAscending = sortAscending;
        this.sortColumn = sortColumn;
        this.startPage = startPage;
        this.width = width;
    }

    (0, _createClass3.default)(TableOptions, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.TableOptions",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    allowHtml: "boolean",
                    alternatingRowStyle: "boolean",
                    cssClassName: CssClassNames,
                    firstRowNumber: "number",
                    height: "string",
                    page: "string",
                    pageSize: "number",
                    rtlTable: "boolean",
                    scrollLeftStartPosition: "number",
                    showRowNumber: "boolean",
                    sort: "string",
                    sortAscending: "boolean",
                    sortColumn: "number",
                    startPage: "number",
                    width: "string"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return (0, _Util.compareRecords)(this, other);
        }
    }]);
    return TableOptions;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.TableOptions", TableOptions);

var LabelStyle = exports.LabelStyle = function () {
    function LabelStyle(color, fontName, fontSize) {
        (0, _classCallCheck3.default)(this, LabelStyle);
        this.color = color;
        this.fontName = fontName;
        this.fontSize = fontSize;
    }

    (0, _createClass3.default)(LabelStyle, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.LabelStyle",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    color: "string",
                    fontName: "string",
                    fontSize: "string"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return (0, _Util.compareRecords)(this, other);
        }
    }]);
    return LabelStyle;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.LabelStyle", LabelStyle);

var TimelineTimeline = exports.TimelineTimeline = function () {
    function TimelineTimeline(barLabelStyle, colorByRowLabel, groupByRowLabel, rowLabelStyle, showRowLabels, singleColor) {
        (0, _classCallCheck3.default)(this, TimelineTimeline);
        this.barLabelStyle = barLabelStyle;
        this.colorByRowLabel = colorByRowLabel;
        this.groupByRowLabel = groupByRowLabel;
        this.rowLabelStyle = rowLabelStyle;
        this.showRowLabels = showRowLabels;
        this.singleColor = singleColor;
    }

    (0, _createClass3.default)(TimelineTimeline, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.TimelineTimeline",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    barLabelStyle: LabelStyle,
                    colorByRowLabel: "boolean",
                    groupByRowLabel: "boolean",
                    rowLabelStyle: LabelStyle,
                    showRowLabels: "boolean",
                    singleColor: "string"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return (0, _Util.compareRecords)(this, other);
        }
    }]);
    return TimelineTimeline;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.TimelineTimeline", TimelineTimeline);

var TimelineOptions = exports.TimelineOptions = function () {
    function TimelineOptions(avoidOverlappingGridLines, backgroundColor, colors, enableInteractivity, forceIFrame, height, timeline, width) {
        (0, _classCallCheck3.default)(this, TimelineOptions);
        this.avoidOverlappingGridLines = avoidOverlappingGridLines;
        this.backgroundColor = backgroundColor;
        this.colors = colors;
        this.enableInteractivity = enableInteractivity;
        this.forceIFrame = forceIFrame;
        this.height = height;
        this.timeline = timeline;
        this.width = width;
    }

    (0, _createClass3.default)(TimelineOptions, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.TimelineOptions",
                interfaces: ["FSharpRecord", "System.IEquatable"],
                properties: {
                    avoidOverlappingGridLines: "boolean",
                    backgroundColor: _Util.Any,
                    colors: (0, _Util.Array)("string"),
                    enableInteractivity: "boolean",
                    forceIFrame: "boolean",
                    height: "number",
                    timeline: TimelineTimeline,
                    width: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }]);
    return TimelineOptions;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.TimelineOptions", TimelineOptions);

var CandlestickCandlestick = exports.CandlestickCandlestick = function () {
    function CandlestickCandlestick(hollowIsRising, fallingColor, risingColor) {
        (0, _classCallCheck3.default)(this, CandlestickCandlestick);
        this.hollowIsRising = hollowIsRising;
        this.fallingColor = fallingColor;
        this.risingColor = risingColor;
    }

    (0, _createClass3.default)(CandlestickCandlestick, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.CandlestickCandlestick",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    hollowIsRising: "boolean",
                    fallingColor: ChartStroke,
                    risingColor: ChartStroke
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return (0, _Util.compareRecords)(this, other);
        }
    }]);
    return CandlestickCandlestick;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.CandlestickCandlestick", CandlestickCandlestick);

var CandlestickChartOptions = exports.CandlestickChartOptions = function () {
    function CandlestickChartOptions(aggregationTarget, animation, axisTitlesPosition, backgroundColor, bar, candlestick, chartArea, colors, enableInteractivity, focusTarget, fontSize, fontName, hAxis, height, legend, orientation, reverseCategories, selectionMode, series, theme, title, titlePosition, titleTextStyle, tooltip, vAxes, vAxis, width) {
        (0, _classCallCheck3.default)(this, CandlestickChartOptions);
        this.aggregationTarget = aggregationTarget;
        this.animation = animation;
        this.axisTitlesPosition = axisTitlesPosition;
        this.backgroundColor = backgroundColor;
        this.bar = bar;
        this.candlestick = candlestick;
        this.chartArea = chartArea;
        this.colors = colors;
        this.enableInteractivity = enableInteractivity;
        this.focusTarget = focusTarget;
        this.fontSize = fontSize;
        this.fontName = fontName;
        this.hAxis = hAxis;
        this.height = height;
        this.legend = legend;
        this.orientation = orientation;
        this.reverseCategories = reverseCategories;
        this.selectionMode = selectionMode;
        this.series = series;
        this.theme = theme;
        this.title = title;
        this.titlePosition = titlePosition;
        this.titleTextStyle = titleTextStyle;
        this.tooltip = tooltip;
        this.vAxes = vAxes;
        this.vAxis = vAxis;
        this.width = width;
    }

    (0, _createClass3.default)(CandlestickChartOptions, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.CandlestickChartOptions",
                interfaces: ["FSharpRecord", "System.IEquatable"],
                properties: {
                    aggregationTarget: "string",
                    animation: TransitionAnimation,
                    axisTitlesPosition: "string",
                    backgroundColor: _Util.Any,
                    bar: GroupWidth,
                    candlestick: CandlestickCandlestick,
                    chartArea: ChartArea,
                    colors: (0, _Util.Array)("string"),
                    enableInteractivity: "boolean",
                    focusTarget: "string",
                    fontSize: "number",
                    fontName: "string",
                    hAxis: ChartAxis,
                    height: "number",
                    legend: ChartLegend,
                    orientation: "string",
                    reverseCategories: "boolean",
                    selectionMode: "string",
                    series: _Util.Any,
                    theme: "string",
                    title: "string",
                    titlePosition: "string",
                    titleTextStyle: ChartTextStyle,
                    tooltip: ChartTooltip,
                    vAxes: _Util.Any,
                    vAxis: ChartAxis,
                    width: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }]);
    return CandlestickChartOptions;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.Options.CandlestickChartOptions", CandlestickChartOptions);
//# sourceMappingURL=options.js.map