"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ProviderHelpers = exports.ProvidedType = undefined;

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _Symbol2 = require("fable-core/umd/Symbol");

var _Symbol3 = _interopRequireDefault(_Symbol2);

var _Util = require("fable-core/umd/Util");

var _List = require("fable-core/umd/List");

var _List2 = _interopRequireDefault(_List);

var _ast = require("../ast/ast");

var _babel = require("../common/babel");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ProvidedType = exports.ProvidedType = function () {
  function ProvidedType(caseName, fields) {
    (0, _classCallCheck3.default)(this, ProvidedType);
    this.Case = caseName;
    this.Fields = fields;
  }

  (0, _createClass3.default)(ProvidedType, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.ProvidedType",
        interfaces: ["FSharpUnion"],
        cases: {
          GlobalValue: ["string", (0, _Util.makeGeneric)(_List2.default, {
            T: _ast.Metadata
          }), _babel.Expression, _ast.Type],
          NamedType: ["string", _ast.Type]
        }
      };
    }
  }]);
  return ProvidedType;
}();

(0, _Symbol2.setType)("TheGamma.TypeProviders.ProvidedType", ProvidedType);

var ProviderHelpers = exports.ProviderHelpers = function (__exports) {
  var docMeta = __exports.docMeta = function (doc) {
    return new _ast.Metadata("http://thegamma.net", "Documentation", doc);
  };

  return __exports;
}({});
//# sourceMappingURL=providers.js.map