import _classCallCheck from "babel-runtime/helpers/classCallCheck";
import _createClass from "babel-runtime/helpers/createClass";
import { setType } from "fable-core/Symbol";
import _Symbol from "fable-core/Symbol";
import { GenericParam, round as _round } from "fable-core/Util";
import { create, now as _now } from "fable-core/Date";
import { niceNumber } from "./common";
export var math = function () {
  function math() {
    _classCallCheck(this, math);
  }

  _createClass(math, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.General.math",
        properties: {}
      };
    }
  }], [{
    key: "sqrt",
    value: function (f) {
      return Math.sqrt(f);
    }
  }, {
    key: "pow",
    value: function (f, k) {
      return Math.pow(f, k);
    }
  }, {
    key: "log",
    value: function (f, b) {
      if (b != null) {
        return Math.log(f) / Math.log(b);
      } else {
        return Math.log(f);
      }
    }
  }, {
    key: "min",
    value: function (f1, f2) {
      if (f1 < f2) {
        return f1;
      } else {
        return f2;
      }
    }
  }, {
    key: "max",
    value: function (f1, f2) {
      if (f1 > f2) {
        return f1;
      } else {
        return f2;
      }
    }
  }, {
    key: "round",
    value: function (n, decimals) {
      return _round(n, decimals);
    }
  }, {
    key: "ceil",
    value: function (n) {
      return Math.ceil(n);
    }
  }, {
    key: "floor",
    value: function (n) {
      return Math.floor(n);
    }
  }]);

  return math;
}();
setType("TheGamma.General.math", math);
export var date = function () {
  function date() {
    _classCallCheck(this, date);
  }

  _createClass(date, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.General.date",
        properties: {}
      };
    }
  }], [{
    key: "now",
    value: function () {
      return _now();
    }
  }, {
    key: "date",
    value: function (year, month, day) {
      return create(year, month, day);
    }
  }, {
    key: "time",
    value: function (year, month, day, hour, minute, second) {
      return create(year, month, day, hour, minute, second);
    }
  }]);

  return date;
}();
setType("TheGamma.General.date", date);
export var dateformat = function () {
  function dateformat() {
    _classCallCheck(this, dateformat);
  }

  _createClass(dateformat, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.General.dateformat",
        properties: {}
      };
    }
  }], [{
    key: "longDate",
    value: function (dt) {
      return dt.toLocaleString("en-GB", {
        day: "numeric",
        year: "numeric",
        month: "long"
      });
    }
  }]);

  return dateformat;
}();
setType("TheGamma.General.dateformat", dateformat);
export var number = function () {
  function number() {
    _classCallCheck(this, number);
  }

  _createClass(number, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.General.number",
        properties: {}
      };
    }
  }], [{
    key: "format",
    value: function (n, decimals) {
      return niceNumber(n, decimals != null ? decimals : 999);
    }
  }]);

  return number;
}();
setType("TheGamma.General.number", number);
export var pair = function () {
  _createClass(pair, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.General.pair",
        properties: {
          first: GenericParam("t1"),
          second: GenericParam("t2")
        }
      };
    }
  }]);

  function pair(v1, v2) {
    _classCallCheck(this, pair);

    this.v1 = v1;
    this.v2 = v2;
  }

  _createClass(pair, [{
    key: "first",
    get: function () {
      return this.v1;
    }
  }, {
    key: "second",
    get: function () {
      return this.v2;
    }
  }]);

  return pair;
}();
setType("TheGamma.General.pair", pair);
//# sourceMappingURL=general.js.map