import _classCallCheck from "babel-runtime/helpers/classCallCheck";
import _createClass from "babel-runtime/helpers/createClass";
import { setType } from "fable-core/Symbol";
import _Symbol from "fable-core/Symbol";
import { AreaChartOptions$2E$get_empty$2E$Static as AreaChartOptions_get_empty_Static, Area, LineChartOptions$2E$get_empty$2E$Static as LineChartOptions_get_empty_Static, Line, ColumnChartOptions$2E$get_empty$2E$Static as ColumnChartOptions_get_empty_Static, Column, BarChartOptions$2E$get_empty$2E$Static as BarChartOptions_get_empty_Static, Bar, PieChartOptions$2E$get_empty$2E$Static as PieChartOptions_get_empty_Static, Pie, GeoChartOptions$2E$get_empty$2E$Static as GeoChartOptions_get_empty_Static, Geo, ScatterChartOptions$2E$get_empty$2E$Static as ScatterChartOptions_get_empty_Static, Scatter } from "./extensions";
import { Helpers, ChartDataOperations } from "./core";
export var chart = function () {
  function chart() {
    _classCallCheck(this, chart);
  }

  _createClass(chart, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.GoogleCharts.chart",
        properties: {}
      };
    }
  }], [{
    key: "scatter",
    value: function (xval, yval) {
      return new Scatter(ChartDataOperations.twoValues(xval, yval), "ScatterChart", ScatterChartOptions_get_empty_Static());
    }
  }, {
    key: "geo",
    value: function (data) {
      return new Geo(ChartDataOperations.oneKeyValue("string", data), "GeoChart", GeoChartOptions_get_empty_Static());
    }
  }, {
    key: "pie",
    value: function (data) {
      return new Pie(ChartDataOperations.oneKeyValue("string", data), "PieChart", PieChartOptions_get_empty_Static());
    }
  }, {
    key: "bar",
    value: function (data) {
      return new Bar(ChartDataOperations.oneKeyValue("string", data), "BarChart", BarChartOptions_get_empty_Static());
    }
  }, {
    key: "column",
    value: function (data) {
      return new Column(ChartDataOperations.oneKeyValue("string", data), "ColumnChart", ColumnChartOptions_get_empty_Static());
    }
  }, {
    key: "columns",
    value: function (data, colors) {
      return new Line(ChartDataOperations.oneKeyAppendValues("string", data, colors), "ColumnChart", LineChartOptions_get_empty_Static());
    }
  }, {
    key: "line",
    value: function (data) {
      return new Line(ChartDataOperations.oneKeyValue("number", data), "LineChart", LineChartOptions_get_empty_Static());
    }
  }, {
    key: "lines",
    value: function (data) {
      return new Line(ChartDataOperations.oneKeyNValues("number", data), "LineChart", LineChartOptions_get_empty_Static());
    }
  }, {
    key: "area",
    value: function (data) {
      return new Area(ChartDataOperations.oneKeyValue("number", data), "AreaChart", AreaChartOptions_get_empty_Static());
    }
  }, {
    key: "areas",
    value: function (data, names) {
      var i = {
        contents: 0
      };
      var data_1 = names == null ? data : data.map(function (s) {
        void i.contents++;
        return s.setProperties(null, null, names[i.contents - 1]);
      });
      return new Area(ChartDataOperations.oneKeyNValues("number", data_1), "AreaChart", AreaChartOptions_get_empty_Static());
    }
  }, {
    key: "show",
    value: function (chart_1) {
      return function (outputId) {
        Helpers.showChart(chart_1, outputId);
      };
    }
  }]);

  return chart;
}();
setType("TheGamma.GoogleCharts.chart", chart);
//# sourceMappingURL=charts.js.map