import _classCallCheck from "babel-runtime/helpers/classCallCheck";
import _createClass from "babel-runtime/helpers/createClass";
import { setType } from "fable-core/Symbol";
import _Symbol from "fable-core/Symbol";
import { Any, Array as _Array, compareRecords, equalsRecords } from "fable-core/Util";
export var ChartSizeAxis = function () {
    function ChartSizeAxis(maxSize, maxValue, minSize, minValue) {
        _classCallCheck(this, ChartSizeAxis);

        this.maxSize = maxSize;
        this.maxValue = maxValue;
        this.minSize = minSize;
        this.minValue = minValue;
    }

    _createClass(ChartSizeAxis, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.ChartSizeAxis",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    maxSize: "number",
                    maxValue: "number",
                    minSize: "number",
                    minValue: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareRecords(this, other);
        }
    }]);

    return ChartSizeAxis;
}();
setType("TheGamma.GoogleCharts.Options.ChartSizeAxis", ChartSizeAxis);
export var ChartTextStyle = function () {
    function ChartTextStyle(fontName, fontSize, bold, italic, color, auraColor, opacity) {
        _classCallCheck(this, ChartTextStyle);

        this.fontName = fontName;
        this.fontSize = fontSize;
        this.bold = bold;
        this.italic = italic;
        this.color = color;
        this.auraColor = auraColor;
        this.opacity = opacity;
    }

    _createClass(ChartTextStyle, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.ChartTextStyle",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    fontName: "string",
                    fontSize: "number",
                    bold: "boolean",
                    italic: "boolean",
                    color: "string",
                    auraColor: "string",
                    opacity: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareRecords(this, other);
        }
    }]);

    return ChartTextStyle;
}();
setType("TheGamma.GoogleCharts.Options.ChartTextStyle", ChartTextStyle);
export var ChartTooltip = function () {
    function ChartTooltip(isHtml, showColorCode, textStyle, trigger) {
        _classCallCheck(this, ChartTooltip);

        this.isHtml = isHtml;
        this.showColorCode = showColorCode;
        this.textStyle = textStyle;
        this.trigger = trigger;
    }

    _createClass(ChartTooltip, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.ChartTooltip",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    isHtml: "boolean",
                    showColorCode: "boolean",
                    textStyle: ChartTextStyle,
                    trigger: "string"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareRecords(this, other);
        }
    }]);

    return ChartTooltip;
}();
setType("TheGamma.GoogleCharts.Options.ChartTooltip", ChartTooltip);
export var ChartLegend = function () {
    function ChartLegend(alignment, maxLines, position, textStyle, numberFormat) {
        _classCallCheck(this, ChartLegend);

        this.alignment = alignment;
        this.maxLines = maxLines;
        this.position = position;
        this.textStyle = textStyle;
        this.numberFormat = numberFormat;
    }

    _createClass(ChartLegend, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.ChartLegend",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    alignment: "string",
                    maxLines: "number",
                    position: "string",
                    textStyle: ChartTextStyle,
                    numberFormat: "string"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareRecords(this, other);
        }
    }]);

    return ChartLegend;
}();
setType("TheGamma.GoogleCharts.Options.ChartLegend", ChartLegend);
export var ChartColorAxis = function () {
    function ChartColorAxis(minValue, maxValue, values, colors, legend) {
        _classCallCheck(this, ChartColorAxis);

        this.minValue = minValue;
        this.maxValue = maxValue;
        this.values = values;
        this.colors = colors;
        this.legend = legend;
    }

    _createClass(ChartColorAxis, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.ChartColorAxis",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    minValue: "number",
                    maxValue: "number",
                    values: _Array(Float64Array, true),
                    colors: _Array("string"),
                    legend: ChartLegend
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareRecords(this, other);
        }
    }]);

    return ChartColorAxis;
}();
setType("TheGamma.GoogleCharts.Options.ChartColorAxis", ChartColorAxis);
export var GeoChartMagnifyingGlass = function () {
    function GeoChartMagnifyingGlass(enable, zoomFactor) {
        _classCallCheck(this, GeoChartMagnifyingGlass);

        this.enable = enable;
        this.zoomFactor = zoomFactor;
    }

    _createClass(GeoChartMagnifyingGlass, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.GeoChartMagnifyingGlass",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    enable: "boolean",
                    zoomFactor: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareRecords(this, other);
        }
    }]);

    return GeoChartMagnifyingGlass;
}();
setType("TheGamma.GoogleCharts.Options.GeoChartMagnifyingGlass", GeoChartMagnifyingGlass);
export var GeoChartOptions = function () {
    function GeoChartOptions(backgroundColor, colorAxis, datalessRegionColor, displayMode, enableRegionInteractivity, height, keepAspectRatio, legend, region, magnifyingGlass, markerOpacity, resolution, sizeAxis, tooltip, width) {
        _classCallCheck(this, GeoChartOptions);

        this.backgroundColor = backgroundColor;
        this.colorAxis = colorAxis;
        this.datalessRegionColor = datalessRegionColor;
        this.displayMode = displayMode;
        this.enableRegionInteractivity = enableRegionInteractivity;
        this.height = height;
        this.keepAspectRatio = keepAspectRatio;
        this.legend = legend;
        this.region = region;
        this.magnifyingGlass = magnifyingGlass;
        this.markerOpacity = markerOpacity;
        this.resolution = resolution;
        this.sizeAxis = sizeAxis;
        this.tooltip = tooltip;
        this.width = width;
    }

    _createClass(GeoChartOptions, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.GeoChartOptions",
                interfaces: ["FSharpRecord", "System.IEquatable"],
                properties: {
                    backgroundColor: Any,
                    colorAxis: ChartColorAxis,
                    datalessRegionColor: "string",
                    displayMode: "string",
                    enableRegionInteractivity: "boolean",
                    height: "number",
                    keepAspectRatio: "boolean",
                    legend: ChartLegend,
                    region: "string",
                    magnifyingGlass: GeoChartMagnifyingGlass,
                    markerOpacity: "number",
                    resolution: "string",
                    sizeAxis: ChartSizeAxis,
                    tooltip: ChartTooltip,
                    width: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }]);

    return GeoChartOptions;
}();
setType("TheGamma.GoogleCharts.Options.GeoChartOptions", GeoChartOptions);
export var ChartBoxStyleGradient = function () {
    function ChartBoxStyleGradient(color1, color2, x1, y1, x2, y2, useObjectBoundingBoxUnits) {
        _classCallCheck(this, ChartBoxStyleGradient);

        this.color1 = color1;
        this.color2 = color2;
        this.x1 = x1;
        this.y1 = y1;
        this.x2 = x2;
        this.y2 = y2;
        this.useObjectBoundingBoxUnits = useObjectBoundingBoxUnits;
    }

    _createClass(ChartBoxStyleGradient, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.ChartBoxStyleGradient",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    color1: "string",
                    color2: "string",
                    x1: "string",
                    y1: "string",
                    x2: "string",
                    y2: "string",
                    useObjectBoundingBoxUnits: "boolean"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareRecords(this, other);
        }
    }]);

    return ChartBoxStyleGradient;
}();
setType("TheGamma.GoogleCharts.Options.ChartBoxStyleGradient", ChartBoxStyleGradient);
export var ChartBoxStyle = function () {
    function ChartBoxStyle(stroke, strokeWidth, rx, ry, gradient) {
        _classCallCheck(this, ChartBoxStyle);

        this.stroke = stroke;
        this.strokeWidth = strokeWidth;
        this.rx = rx;
        this.ry = ry;
        this.gradient = gradient;
    }

    _createClass(ChartBoxStyle, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.ChartBoxStyle",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    stroke: "string",
                    strokeWidth: "number",
                    rx: "number",
                    ry: "number",
                    gradient: ChartBoxStyleGradient
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareRecords(this, other);
        }
    }]);

    return ChartBoxStyle;
}();
setType("TheGamma.GoogleCharts.Options.ChartBoxStyle", ChartBoxStyle);
export var ChartAnnotations = function () {
    function ChartAnnotations(boxStyle, textStyle) {
        _classCallCheck(this, ChartAnnotations);

        this.boxStyle = boxStyle;
        this.textStyle = textStyle;
    }

    _createClass(ChartAnnotations, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.ChartAnnotations",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    boxStyle: ChartBoxStyle,
                    textStyle: ChartTextStyle
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareRecords(this, other);
        }
    }]);

    return ChartAnnotations;
}();
setType("TheGamma.GoogleCharts.Options.ChartAnnotations", ChartAnnotations);
export var ChartCrosshairFocused = function () {
    function ChartCrosshairFocused(color, opacity) {
        _classCallCheck(this, ChartCrosshairFocused);

        this.color = color;
        this.opacity = opacity;
    }

    _createClass(ChartCrosshairFocused, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.ChartCrosshairFocused",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    color: "string",
                    opacity: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareRecords(this, other);
        }
    }]);

    return ChartCrosshairFocused;
}();
setType("TheGamma.GoogleCharts.Options.ChartCrosshairFocused", ChartCrosshairFocused);
export var ChartCrosshairSelected = function () {
    function ChartCrosshairSelected(color, opacity) {
        _classCallCheck(this, ChartCrosshairSelected);

        this.color = color;
        this.opacity = opacity;
    }

    _createClass(ChartCrosshairSelected, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.ChartCrosshairSelected",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    color: "string",
                    opacity: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareRecords(this, other);
        }
    }]);

    return ChartCrosshairSelected;
}();
setType("TheGamma.GoogleCharts.Options.ChartCrosshairSelected", ChartCrosshairSelected);
export var ChartCrosshair = function () {
    function ChartCrosshair(color, focused, opacity, orientation, selected, trigger) {
        _classCallCheck(this, ChartCrosshair);

        this.color = color;
        this.focused = focused;
        this.opacity = opacity;
        this.orientation = orientation;
        this.selected = selected;
        this.trigger = trigger;
    }

    _createClass(ChartCrosshair, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.ChartCrosshair",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    color: "string",
                    focused: ChartCrosshairFocused,
                    opacity: "number",
                    orientation: "string",
                    selected: ChartCrosshairSelected,
                    trigger: "string"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareRecords(this, other);
        }
    }]);

    return ChartCrosshair;
}();
setType("TheGamma.GoogleCharts.Options.ChartCrosshair", ChartCrosshair);
export var ChartExplorer = function () {
    function ChartExplorer(actions, axis, keepInBounds, maxZoomIn, maxZoomOut, zoomDelta) {
        _classCallCheck(this, ChartExplorer);

        this.actions = actions;
        this.axis = axis;
        this.keepInBounds = keepInBounds;
        this.maxZoomIn = maxZoomIn;
        this.maxZoomOut = maxZoomOut;
        this.zoomDelta = zoomDelta;
    }

    _createClass(ChartExplorer, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.ChartExplorer",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    actions: _Array("string"),
                    axis: "string",
                    keepInBounds: "boolean",
                    maxZoomIn: "number",
                    maxZoomOut: "number",
                    zoomDelta: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareRecords(this, other);
        }
    }]);

    return ChartExplorer;
}();
setType("TheGamma.GoogleCharts.Options.ChartExplorer", ChartExplorer);
export var ChartStroke = function () {
    function ChartStroke(stroke, strokeWidth, fill) {
        _classCallCheck(this, ChartStroke);

        this.stroke = stroke;
        this.strokeWidth = strokeWidth;
        this.fill = fill;
    }

    _createClass(ChartStroke, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.ChartStroke",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    stroke: "string",
                    strokeWidth: "number",
                    fill: "string"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareRecords(this, other);
        }
    }]);

    return ChartStroke;
}();
setType("TheGamma.GoogleCharts.Options.ChartStroke", ChartStroke);
export var ChartArea = function () {
    function ChartArea(top, left, width, height) {
        _classCallCheck(this, ChartArea);

        this.top = top;
        this.left = left;
        this.width = width;
        this.height = height;
    }

    _createClass(ChartArea, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.ChartArea",
                interfaces: ["FSharpRecord", "System.IEquatable"],
                properties: {
                    top: Any,
                    left: Any,
                    width: Any,
                    height: Any
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }]);

    return ChartArea;
}();
setType("TheGamma.GoogleCharts.Options.ChartArea", ChartArea);
export var TransitionAnimation = function () {
    function TransitionAnimation(duration, easing) {
        _classCallCheck(this, TransitionAnimation);

        this.duration = duration;
        this.easing = easing;
    }

    _createClass(TransitionAnimation, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.TransitionAnimation",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    duration: "number",
                    easing: "string"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareRecords(this, other);
        }
    }]);

    return TransitionAnimation;
}();
setType("TheGamma.GoogleCharts.Options.TransitionAnimation", TransitionAnimation);
export var ChartGridlines = function () {
    function ChartGridlines(color, count) {
        _classCallCheck(this, ChartGridlines);

        this.color = color;
        this.count = count;
    }

    _createClass(ChartGridlines, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.ChartGridlines",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    color: "string",
                    count: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareRecords(this, other);
        }
    }]);

    return ChartGridlines;
}();
setType("TheGamma.GoogleCharts.Options.ChartGridlines", ChartGridlines);
export var ChartViewWindow = function () {
    function ChartViewWindow(max, min) {
        _classCallCheck(this, ChartViewWindow);

        this.max = max;
        this.min = min;
    }

    _createClass(ChartViewWindow, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.ChartViewWindow",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    max: "number",
                    min: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareRecords(this, other);
        }
    }]);

    return ChartViewWindow;
}();
setType("TheGamma.GoogleCharts.Options.ChartViewWindow", ChartViewWindow);
export var ChartAxis = function () {
    function ChartAxis(baseline, baselineColor, direction, format, gridlines, minorGridlines, logScale, textPosition, textStyle, ticks, title, titleTextStyle, allowContainerBoundaryTextCufoff, slantedText, slantedTextAngle, maxAlternation, maxTextLines, minTextSpacing, showTextEvery, maxValue, minValue, viewWindowMode, viewWindow) {
        _classCallCheck(this, ChartAxis);

        this.baseline = baseline;
        this.baselineColor = baselineColor;
        this.direction = direction;
        this.format = format;
        this.gridlines = gridlines;
        this.minorGridlines = minorGridlines;
        this.logScale = logScale;
        this.textPosition = textPosition;
        this.textStyle = textStyle;
        this.ticks = ticks;
        this.title = title;
        this.titleTextStyle = titleTextStyle;
        this.allowContainerBoundaryTextCufoff = allowContainerBoundaryTextCufoff;
        this.slantedText = slantedText;
        this.slantedTextAngle = slantedTextAngle;
        this.maxAlternation = maxAlternation;
        this.maxTextLines = maxTextLines;
        this.minTextSpacing = minTextSpacing;
        this.showTextEvery = showTextEvery;
        this.maxValue = maxValue;
        this.minValue = minValue;
        this.viewWindowMode = viewWindowMode;
        this.viewWindow = viewWindow;
    }

    _createClass(ChartAxis, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.ChartAxis",
                interfaces: ["FSharpRecord", "System.IEquatable"],
                properties: {
                    baseline: "number",
                    baselineColor: "string",
                    direction: "number",
                    format: "string",
                    gridlines: ChartGridlines,
                    minorGridlines: ChartGridlines,
                    logScale: "boolean",
                    textPosition: "string",
                    textStyle: ChartTextStyle,
                    ticks: _Array(Any),
                    title: "string",
                    titleTextStyle: ChartTextStyle,
                    allowContainerBoundaryTextCufoff: "boolean",
                    slantedText: "boolean",
                    slantedTextAngle: "number",
                    maxAlternation: "number",
                    maxTextLines: "number",
                    minTextSpacing: "number",
                    showTextEvery: "number",
                    maxValue: "number",
                    minValue: "number",
                    viewWindowMode: "string",
                    viewWindow: ChartViewWindow
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }]);

    return ChartAxis;
}();
setType("TheGamma.GoogleCharts.Options.ChartAxis", ChartAxis);
export var ChartBoundingBox = function () {
    function ChartBoundingBox(left, top, width, height) {
        _classCallCheck(this, ChartBoundingBox);

        this.left = left;
        this.top = top;
        this.width = width;
        this.height = height;
    }

    _createClass(ChartBoundingBox, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.ChartBoundingBox",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    left: "number",
                    top: "number",
                    width: "number",
                    height: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareRecords(this, other);
        }
    }]);

    return ChartBoundingBox;
}();
setType("TheGamma.GoogleCharts.Options.ChartBoundingBox", ChartBoundingBox);
export var GroupWidth = function () {
    function GroupWidth(groupWidth) {
        _classCallCheck(this, GroupWidth);

        this.groupWidth = groupWidth;
    }

    _createClass(GroupWidth, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.GroupWidth",
                interfaces: ["FSharpRecord", "System.IEquatable"],
                properties: {
                    groupWidth: Any
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }]);

    return GroupWidth;
}();
setType("TheGamma.GoogleCharts.Options.GroupWidth", GroupWidth);
export var Trendline = function () {
    function Trendline(color, lineWidth, labelInLegend, opacity, pointSize, pointsVisible, showR2, type, visibleInLegend) {
        _classCallCheck(this, Trendline);

        this.color = color;
        this.lineWidth = lineWidth;
        this.labelInLegend = labelInLegend;
        this.opacity = opacity;
        this.pointSize = pointSize;
        this.pointsVisible = pointsVisible;
        this.showR2 = showR2;
        this.type = type;
        this.visibleInLegend = visibleInLegend;
    }

    _createClass(Trendline, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.Trendline",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    color: "string",
                    lineWidth: "number",
                    labelInLegend: "string",
                    opacity: "number",
                    pointSize: "number",
                    pointsVisible: "boolean",
                    showR2: "boolean",
                    type: "string",
                    visibleInLegend: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareRecords(this, other);
        }
    }]);

    return Trendline;
}();
setType("TheGamma.GoogleCharts.Options.Trendline", Trendline);
export var ScatterChartOptions = function () {
    function ScatterChartOptions(aggregationTarget, animation, annotations, axisTitlesPosition, backgroundColor, chartArea, colors, crosshair, curveType, dataOpacity, enableInteractivity, explorer, fontSize, fontName, forceIFrame, hAxis, height, legend, lineWidth, pointSize, selectionMode, series, theme, title, titlePosition, titleTextStyle, tooltip, trendlines, vAxis, width) {
        _classCallCheck(this, ScatterChartOptions);

        this.aggregationTarget = aggregationTarget;
        this.animation = animation;
        this.annotations = annotations;
        this.axisTitlesPosition = axisTitlesPosition;
        this.backgroundColor = backgroundColor;
        this.chartArea = chartArea;
        this.colors = colors;
        this.crosshair = crosshair;
        this.curveType = curveType;
        this.dataOpacity = dataOpacity;
        this.enableInteractivity = enableInteractivity;
        this.explorer = explorer;
        this.fontSize = fontSize;
        this.fontName = fontName;
        this.forceIFrame = forceIFrame;
        this.hAxis = hAxis;
        this.height = height;
        this.legend = legend;
        this.lineWidth = lineWidth;
        this.pointSize = pointSize;
        this.selectionMode = selectionMode;
        this.series = series;
        this.theme = theme;
        this.title = title;
        this.titlePosition = titlePosition;
        this.titleTextStyle = titleTextStyle;
        this.tooltip = tooltip;
        this.trendlines = trendlines;
        this.vAxis = vAxis;
        this.width = width;
    }

    _createClass(ScatterChartOptions, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.ScatterChartOptions",
                interfaces: ["FSharpRecord", "System.IEquatable"],
                properties: {
                    aggregationTarget: "string",
                    animation: TransitionAnimation,
                    annotations: ChartAnnotations,
                    axisTitlesPosition: "string",
                    backgroundColor: Any,
                    chartArea: ChartArea,
                    colors: _Array("string"),
                    crosshair: ChartCrosshair,
                    curveType: "string",
                    dataOpacity: "number",
                    enableInteractivity: "boolean",
                    explorer: ChartExplorer,
                    fontSize: "number",
                    fontName: "string",
                    forceIFrame: "boolean",
                    hAxis: ChartAxis,
                    height: "number",
                    legend: ChartLegend,
                    lineWidth: "number",
                    pointSize: "number",
                    selectionMode: "string",
                    series: Any,
                    theme: "string",
                    title: "string",
                    titlePosition: "string",
                    titleTextStyle: ChartTextStyle,
                    tooltip: ChartTooltip,
                    trendlines: _Array(Trendline),
                    vAxis: ChartAxis,
                    width: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }]);

    return ScatterChartOptions;
}();
setType("TheGamma.GoogleCharts.Options.ScatterChartOptions", ScatterChartOptions);
export var ColumnChartOptions = function () {
    function ColumnChartOptions(aggregationTarget, animation, annotations, axisTitlesPosition, backgroundColor, bar, chartArea, colors, enableInteractivity, focusTarget, fontSize, fontName, hAxis, height, isStacked, legend, reverseCategories, selectionMode, series, theme, title, titlePosition, titleTextStyle, tooltip, vAxes, vAxis, width) {
        _classCallCheck(this, ColumnChartOptions);

        this.aggregationTarget = aggregationTarget;
        this.animation = animation;
        this.annotations = annotations;
        this.axisTitlesPosition = axisTitlesPosition;
        this.backgroundColor = backgroundColor;
        this.bar = bar;
        this.chartArea = chartArea;
        this.colors = colors;
        this.enableInteractivity = enableInteractivity;
        this.focusTarget = focusTarget;
        this.fontSize = fontSize;
        this.fontName = fontName;
        this.hAxis = hAxis;
        this.height = height;
        this.isStacked = isStacked;
        this.legend = legend;
        this.reverseCategories = reverseCategories;
        this.selectionMode = selectionMode;
        this.series = series;
        this.theme = theme;
        this.title = title;
        this.titlePosition = titlePosition;
        this.titleTextStyle = titleTextStyle;
        this.tooltip = tooltip;
        this.vAxes = vAxes;
        this.vAxis = vAxis;
        this.width = width;
    }

    _createClass(ColumnChartOptions, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.ColumnChartOptions",
                interfaces: ["FSharpRecord", "System.IEquatable"],
                properties: {
                    aggregationTarget: "string",
                    animation: TransitionAnimation,
                    annotations: ChartAnnotations,
                    axisTitlesPosition: "string",
                    backgroundColor: Any,
                    bar: GroupWidth,
                    chartArea: ChartArea,
                    colors: _Array("string"),
                    enableInteractivity: "boolean",
                    focusTarget: "string",
                    fontSize: "number",
                    fontName: "string",
                    hAxis: ChartAxis,
                    height: "number",
                    isStacked: "boolean",
                    legend: ChartLegend,
                    reverseCategories: "boolean",
                    selectionMode: "string",
                    series: Any,
                    theme: "string",
                    title: "string",
                    titlePosition: "string",
                    titleTextStyle: ChartTextStyle,
                    tooltip: ChartTooltip,
                    vAxes: Any,
                    vAxis: ChartAxis,
                    width: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }]);

    return ColumnChartOptions;
}();
setType("TheGamma.GoogleCharts.Options.ColumnChartOptions", ColumnChartOptions);
export var LineChartOptions = function () {
    function LineChartOptions(aggregationTarget, animation, annotations, axisTitlesPosition, backgroundColor, chartArea, colors, crosshair, curveType, dataOpacity, enableInteractivity, explorer, focusTarget, fontSize, fontName, hAxis, height, interpolateNulls, legend, lineWidth, orientation, pointSize, reverseCategories, selectionMode, series, theme, title, titlePosition, titleTextStyle, tooltip, vAxes, vAxis, width) {
        _classCallCheck(this, LineChartOptions);

        this.aggregationTarget = aggregationTarget;
        this.animation = animation;
        this.annotations = annotations;
        this.axisTitlesPosition = axisTitlesPosition;
        this.backgroundColor = backgroundColor;
        this.chartArea = chartArea;
        this.colors = colors;
        this.crosshair = crosshair;
        this.curveType = curveType;
        this.dataOpacity = dataOpacity;
        this.enableInteractivity = enableInteractivity;
        this.explorer = explorer;
        this.focusTarget = focusTarget;
        this.fontSize = fontSize;
        this.fontName = fontName;
        this.hAxis = hAxis;
        this.height = height;
        this.interpolateNulls = interpolateNulls;
        this.legend = legend;
        this.lineWidth = lineWidth;
        this.orientation = orientation;
        this.pointSize = pointSize;
        this.reverseCategories = reverseCategories;
        this.selectionMode = selectionMode;
        this.series = series;
        this.theme = theme;
        this.title = title;
        this.titlePosition = titlePosition;
        this.titleTextStyle = titleTextStyle;
        this.tooltip = tooltip;
        this.vAxes = vAxes;
        this.vAxis = vAxis;
        this.width = width;
    }

    _createClass(LineChartOptions, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.LineChartOptions",
                interfaces: ["FSharpRecord", "System.IEquatable"],
                properties: {
                    aggregationTarget: "string",
                    animation: TransitionAnimation,
                    annotations: ChartAnnotations,
                    axisTitlesPosition: "string",
                    backgroundColor: Any,
                    chartArea: ChartArea,
                    colors: _Array("string"),
                    crosshair: ChartCrosshair,
                    curveType: "string",
                    dataOpacity: "number",
                    enableInteractivity: "boolean",
                    explorer: ChartExplorer,
                    focusTarget: "string",
                    fontSize: "number",
                    fontName: "string",
                    hAxis: ChartAxis,
                    height: "number",
                    interpolateNulls: "boolean",
                    legend: ChartLegend,
                    lineWidth: "number",
                    orientation: "string",
                    pointSize: "number",
                    reverseCategories: "boolean",
                    selectionMode: "string",
                    series: Any,
                    theme: "string",
                    title: "string",
                    titlePosition: "string",
                    titleTextStyle: ChartTextStyle,
                    tooltip: ChartTooltip,
                    vAxes: Any,
                    vAxis: ChartAxis,
                    width: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }]);

    return LineChartOptions;
}();
setType("TheGamma.GoogleCharts.Options.LineChartOptions", LineChartOptions);
export var BarChartOptions = function () {
    function BarChartOptions(aggregationTarget, animation, annotations, axisTitlesPosition, backgroundColor, bar, chartArea, colors, dataOpacity, enableInteractivity, focusTarget, fontSize, fontName, hAxes, hAxis, height, isStacked, legend, reverseCategories, series, theme, title, titlePosition, titleTextStyle, tooltip, vAxes, vAxis, width) {
        _classCallCheck(this, BarChartOptions);

        this.aggregationTarget = aggregationTarget;
        this.animation = animation;
        this.annotations = annotations;
        this.axisTitlesPosition = axisTitlesPosition;
        this.backgroundColor = backgroundColor;
        this.bar = bar;
        this.chartArea = chartArea;
        this.colors = colors;
        this.dataOpacity = dataOpacity;
        this.enableInteractivity = enableInteractivity;
        this.focusTarget = focusTarget;
        this.fontSize = fontSize;
        this.fontName = fontName;
        this.hAxes = hAxes;
        this.hAxis = hAxis;
        this.height = height;
        this.isStacked = isStacked;
        this.legend = legend;
        this.reverseCategories = reverseCategories;
        this.series = series;
        this.theme = theme;
        this.title = title;
        this.titlePosition = titlePosition;
        this.titleTextStyle = titleTextStyle;
        this.tooltip = tooltip;
        this.vAxes = vAxes;
        this.vAxis = vAxis;
        this.width = width;
    }

    _createClass(BarChartOptions, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.BarChartOptions",
                interfaces: ["FSharpRecord", "System.IEquatable"],
                properties: {
                    aggregationTarget: "string",
                    animation: TransitionAnimation,
                    annotations: ChartAnnotations,
                    axisTitlesPosition: "string",
                    backgroundColor: Any,
                    bar: GroupWidth,
                    chartArea: ChartArea,
                    colors: _Array("string"),
                    dataOpacity: "number",
                    enableInteractivity: "boolean",
                    focusTarget: "string",
                    fontSize: "number",
                    fontName: "string",
                    hAxes: Any,
                    hAxis: ChartAxis,
                    height: "number",
                    isStacked: "boolean",
                    legend: ChartLegend,
                    reverseCategories: "boolean",
                    series: Any,
                    theme: "string",
                    title: "string",
                    titlePosition: "string",
                    titleTextStyle: ChartTextStyle,
                    tooltip: ChartTooltip,
                    vAxes: Any,
                    vAxis: ChartAxis,
                    width: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }]);

    return BarChartOptions;
}();
setType("TheGamma.GoogleCharts.Options.BarChartOptions", BarChartOptions);
export var HistogramHistogram = function () {
    function HistogramHistogram(bucketSize, hideBucketItems, lastBucketPercentile) {
        _classCallCheck(this, HistogramHistogram);

        this.bucketSize = bucketSize;
        this.hideBucketItems = hideBucketItems;
        this.lastBucketPercentile = lastBucketPercentile;
    }

    _createClass(HistogramHistogram, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.HistogramHistogram",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    bucketSize: "number",
                    hideBucketItems: "boolean",
                    lastBucketPercentile: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareRecords(this, other);
        }
    }]);

    return HistogramHistogram;
}();
setType("TheGamma.GoogleCharts.Options.HistogramHistogram", HistogramHistogram);
export var HistogramOptions = function () {
    function HistogramOptions(animation, axisTitlesPosition, backgroundColor, bar, chartArea, colors, dataOpacity, enableInteractivity, focusTarget, fontSize, fontName, hAxis, histogram, height, interpolateNulls, isStacked, legend, orientation, reverseCategories, series, theme, title, titlePosition, titleTextStyle, tooltip, vAxes, vAxis, width) {
        _classCallCheck(this, HistogramOptions);

        this.animation = animation;
        this.axisTitlesPosition = axisTitlesPosition;
        this.backgroundColor = backgroundColor;
        this.bar = bar;
        this.chartArea = chartArea;
        this.colors = colors;
        this.dataOpacity = dataOpacity;
        this.enableInteractivity = enableInteractivity;
        this.focusTarget = focusTarget;
        this.fontSize = fontSize;
        this.fontName = fontName;
        this.hAxis = hAxis;
        this.histogram = histogram;
        this.height = height;
        this.interpolateNulls = interpolateNulls;
        this.isStacked = isStacked;
        this.legend = legend;
        this.orientation = orientation;
        this.reverseCategories = reverseCategories;
        this.series = series;
        this.theme = theme;
        this.title = title;
        this.titlePosition = titlePosition;
        this.titleTextStyle = titleTextStyle;
        this.tooltip = tooltip;
        this.vAxes = vAxes;
        this.vAxis = vAxis;
        this.width = width;
    }

    _createClass(HistogramOptions, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.HistogramOptions",
                interfaces: ["FSharpRecord", "System.IEquatable"],
                properties: {
                    animation: TransitionAnimation,
                    axisTitlesPosition: "string",
                    backgroundColor: Any,
                    bar: GroupWidth,
                    chartArea: ChartArea,
                    colors: _Array("string"),
                    dataOpacity: "number",
                    enableInteractivity: "boolean",
                    focusTarget: "string",
                    fontSize: "number",
                    fontName: "string",
                    hAxis: ChartAxis,
                    histogram: HistogramHistogram,
                    height: "number",
                    interpolateNulls: "boolean",
                    isStacked: "boolean",
                    legend: ChartLegend,
                    orientation: "string",
                    reverseCategories: "boolean",
                    series: Any,
                    theme: "string",
                    title: "string",
                    titlePosition: "string",
                    titleTextStyle: ChartTextStyle,
                    tooltip: ChartTooltip,
                    vAxes: Any,
                    vAxis: ChartAxis,
                    width: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }]);

    return HistogramOptions;
}();
setType("TheGamma.GoogleCharts.Options.HistogramOptions", HistogramOptions);
export var AreaChartOptions = function () {
    function AreaChartOptions(aggregationTarget, animation, areaOpacity, axisTitlesPosition, backgroundColor, chartArea, colors, crosshair, dataOpacity, enableInteractivity, explorer, focusTarget, fontSize, fontName, hAxis, height, interpolateNulls, isStacked, legend, lineWidth, orientation, pointSize, reverseCategories, selectionMode, series, theme, title, titlePosition, titleTextStyle, tooltip, vAxes, vAxis, width) {
        _classCallCheck(this, AreaChartOptions);

        this.aggregationTarget = aggregationTarget;
        this.animation = animation;
        this.areaOpacity = areaOpacity;
        this.axisTitlesPosition = axisTitlesPosition;
        this.backgroundColor = backgroundColor;
        this.chartArea = chartArea;
        this.colors = colors;
        this.crosshair = crosshair;
        this.dataOpacity = dataOpacity;
        this.enableInteractivity = enableInteractivity;
        this.explorer = explorer;
        this.focusTarget = focusTarget;
        this.fontSize = fontSize;
        this.fontName = fontName;
        this.hAxis = hAxis;
        this.height = height;
        this.interpolateNulls = interpolateNulls;
        this.isStacked = isStacked;
        this.legend = legend;
        this.lineWidth = lineWidth;
        this.orientation = orientation;
        this.pointSize = pointSize;
        this.reverseCategories = reverseCategories;
        this.selectionMode = selectionMode;
        this.series = series;
        this.theme = theme;
        this.title = title;
        this.titlePosition = titlePosition;
        this.titleTextStyle = titleTextStyle;
        this.tooltip = tooltip;
        this.vAxes = vAxes;
        this.vAxis = vAxis;
        this.width = width;
    }

    _createClass(AreaChartOptions, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.AreaChartOptions",
                interfaces: ["FSharpRecord", "System.IEquatable"],
                properties: {
                    aggregationTarget: "string",
                    animation: TransitionAnimation,
                    areaOpacity: "number",
                    axisTitlesPosition: "string",
                    backgroundColor: Any,
                    chartArea: ChartArea,
                    colors: _Array("string"),
                    crosshair: ChartCrosshair,
                    dataOpacity: "number",
                    enableInteractivity: "boolean",
                    explorer: ChartExplorer,
                    focusTarget: "string",
                    fontSize: "number",
                    fontName: "string",
                    hAxis: ChartAxis,
                    height: "number",
                    interpolateNulls: "boolean",
                    isStacked: "boolean",
                    legend: ChartLegend,
                    lineWidth: "number",
                    orientation: "string",
                    pointSize: "number",
                    reverseCategories: "boolean",
                    selectionMode: "string",
                    series: Any,
                    theme: "string",
                    title: "string",
                    titlePosition: "string",
                    titleTextStyle: ChartTextStyle,
                    tooltip: ChartTooltip,
                    vAxes: Any,
                    vAxis: ChartAxis,
                    width: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }]);

    return AreaChartOptions;
}();
setType("TheGamma.GoogleCharts.Options.AreaChartOptions", AreaChartOptions);
export var AnnotationChartOptions = function () {
    function AnnotationChartOptions(allowHtml, allValuesSuffix, annotationsWidth, colors, dateFormat, displayAnnotations, displayAnnotationsFilter, displayDateTimeBarSeparator, displayExactValues, displayLegendDots, displayLegendValues, displayRangeSelector, displayZoomButtons, fill, legendPosition, max, min, numberFormats, scaleColumns, scaleFormat, scaleType, thickness, zoomEndTime, zoomStartTime) {
        _classCallCheck(this, AnnotationChartOptions);

        this.allowHtml = allowHtml;
        this.allValuesSuffix = allValuesSuffix;
        this.annotationsWidth = annotationsWidth;
        this.colors = colors;
        this.dateFormat = dateFormat;
        this.displayAnnotations = displayAnnotations;
        this.displayAnnotationsFilter = displayAnnotationsFilter;
        this.displayDateTimeBarSeparator = displayDateTimeBarSeparator;
        this.displayExactValues = displayExactValues;
        this.displayLegendDots = displayLegendDots;
        this.displayLegendValues = displayLegendValues;
        this.displayRangeSelector = displayRangeSelector;
        this.displayZoomButtons = displayZoomButtons;
        this.fill = fill;
        this.legendPosition = legendPosition;
        this.max = max;
        this.min = min;
        this.numberFormats = numberFormats;
        this.scaleColumns = scaleColumns;
        this.scaleFormat = scaleFormat;
        this.scaleType = scaleType;
        this.thickness = thickness;
        this.zoomEndTime = zoomEndTime;
        this.zoomStartTime = zoomStartTime;
    }

    _createClass(AnnotationChartOptions, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.AnnotationChartOptions",
                interfaces: ["FSharpRecord", "System.IEquatable"],
                properties: {
                    allowHtml: "boolean",
                    allValuesSuffix: "string",
                    annotationsWidth: "number",
                    colors: _Array("string"),
                    dateFormat: "string",
                    displayAnnotations: "boolean",
                    displayAnnotationsFilter: "boolean",
                    displayDateTimeBarSeparator: "boolean",
                    displayExactValues: "boolean",
                    displayLegendDots: "boolean",
                    displayLegendValues: "boolean",
                    displayRangeSelector: "boolean",
                    displayZoomButtons: "boolean",
                    fill: "number",
                    legendPosition: "string",
                    max: "number",
                    min: "number",
                    numberFormats: Any,
                    scaleColumns: _Array(Float64Array, true),
                    scaleFormat: "string",
                    scaleType: "string",
                    thickness: "number",
                    zoomEndTime: Date,
                    zoomStartTime: Date
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }]);

    return AnnotationChartOptions;
}();
setType("TheGamma.GoogleCharts.Options.AnnotationChartOptions", AnnotationChartOptions);
export var SteppedAreaChartOptions = function () {
    function SteppedAreaChartOptions(aggregationTarget, animation, areaOpacity, axisTitlesPosition, backgroundColor, chartArea, colors, connectSteps, enableInteractivity, focusTarget, fontSize, fontName, hAxis, height, interpolateNulls, isStacked, legend, reverseCategories, selectionMode, series, theme, title, titlePosition, titleTextStyle, tooltip, vAxes, vAxis, width) {
        _classCallCheck(this, SteppedAreaChartOptions);

        this.aggregationTarget = aggregationTarget;
        this.animation = animation;
        this.areaOpacity = areaOpacity;
        this.axisTitlesPosition = axisTitlesPosition;
        this.backgroundColor = backgroundColor;
        this.chartArea = chartArea;
        this.colors = colors;
        this.connectSteps = connectSteps;
        this.enableInteractivity = enableInteractivity;
        this.focusTarget = focusTarget;
        this.fontSize = fontSize;
        this.fontName = fontName;
        this.hAxis = hAxis;
        this.height = height;
        this.interpolateNulls = interpolateNulls;
        this.isStacked = isStacked;
        this.legend = legend;
        this.reverseCategories = reverseCategories;
        this.selectionMode = selectionMode;
        this.series = series;
        this.theme = theme;
        this.title = title;
        this.titlePosition = titlePosition;
        this.titleTextStyle = titleTextStyle;
        this.tooltip = tooltip;
        this.vAxes = vAxes;
        this.vAxis = vAxis;
        this.width = width;
    }

    _createClass(SteppedAreaChartOptions, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.SteppedAreaChartOptions",
                interfaces: ["FSharpRecord", "System.IEquatable"],
                properties: {
                    aggregationTarget: "string",
                    animation: TransitionAnimation,
                    areaOpacity: "number",
                    axisTitlesPosition: "string",
                    backgroundColor: Any,
                    chartArea: ChartArea,
                    colors: _Array("string"),
                    connectSteps: "boolean",
                    enableInteractivity: "boolean",
                    focusTarget: "string",
                    fontSize: "number",
                    fontName: "string",
                    hAxis: ChartAxis,
                    height: "number",
                    interpolateNulls: "boolean",
                    isStacked: "boolean",
                    legend: ChartLegend,
                    reverseCategories: "boolean",
                    selectionMode: "string",
                    series: Any,
                    theme: "string",
                    title: "string",
                    titlePosition: "string",
                    titleTextStyle: ChartTextStyle,
                    tooltip: ChartTooltip,
                    vAxes: Any,
                    vAxis: ChartAxis,
                    width: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }]);

    return SteppedAreaChartOptions;
}();
setType("TheGamma.GoogleCharts.Options.SteppedAreaChartOptions", SteppedAreaChartOptions);
export var PieChartOptions = function () {
    function PieChartOptions(backgroundColor, chartArea, colors, enableInteractivity, fontSize, fontName, height, is3D, legend, pieHole, pieSliceBorderColor, pieSliceText, pieSliceTextStyle, pieStartAngle, reverseCategories, pieResidueSliceColor, pieResidueSliceLabel, slices, sliceVisibilityThreshold, title, titleTextStyle, tooltip, width) {
        _classCallCheck(this, PieChartOptions);

        this.backgroundColor = backgroundColor;
        this.chartArea = chartArea;
        this.colors = colors;
        this.enableInteractivity = enableInteractivity;
        this.fontSize = fontSize;
        this.fontName = fontName;
        this.height = height;
        this.is3D = is3D;
        this.legend = legend;
        this.pieHole = pieHole;
        this.pieSliceBorderColor = pieSliceBorderColor;
        this.pieSliceText = pieSliceText;
        this.pieSliceTextStyle = pieSliceTextStyle;
        this.pieStartAngle = pieStartAngle;
        this.reverseCategories = reverseCategories;
        this.pieResidueSliceColor = pieResidueSliceColor;
        this.pieResidueSliceLabel = pieResidueSliceLabel;
        this.slices = slices;
        this.sliceVisibilityThreshold = sliceVisibilityThreshold;
        this.title = title;
        this.titleTextStyle = titleTextStyle;
        this.tooltip = tooltip;
        this.width = width;
    }

    _createClass(PieChartOptions, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.PieChartOptions",
                interfaces: ["FSharpRecord", "System.IEquatable"],
                properties: {
                    backgroundColor: Any,
                    chartArea: ChartArea,
                    colors: _Array("string"),
                    enableInteractivity: "boolean",
                    fontSize: "number",
                    fontName: "string",
                    height: "number",
                    is3D: "boolean",
                    legend: ChartLegend,
                    pieHole: "number",
                    pieSliceBorderColor: "string",
                    pieSliceText: "string",
                    pieSliceTextStyle: ChartTextStyle,
                    pieStartAngle: "number",
                    reverseCategories: "boolean",
                    pieResidueSliceColor: "string",
                    pieResidueSliceLabel: "string",
                    slices: Any,
                    sliceVisibilityThreshold: "number",
                    title: "string",
                    titleTextStyle: ChartTextStyle,
                    tooltip: ChartTooltip,
                    width: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }]);

    return PieChartOptions;
}();
setType("TheGamma.GoogleCharts.Options.PieChartOptions", PieChartOptions);
export var ChartBubble = function () {
    function ChartBubble(opacity, stroke, textStyle) {
        _classCallCheck(this, ChartBubble);

        this.opacity = opacity;
        this.stroke = stroke;
        this.textStyle = textStyle;
    }

    _createClass(ChartBubble, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.ChartBubble",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    opacity: "number",
                    stroke: "string",
                    textStyle: ChartTextStyle
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareRecords(this, other);
        }
    }]);

    return ChartBubble;
}();
setType("TheGamma.GoogleCharts.Options.ChartBubble", ChartBubble);
export var BubbleChartOptions = function () {
    function BubbleChartOptions(animation, axisTitlesPosition, backgroundColor, bubble, chartArea, colors, colorAxis, enableInteractivity, explorer, fontSize, fontName, forceIFrame, hAxis, height, legend, selectionMode, series, sizeAxis, sortBubblesBySize, theme, title, titlePosition, titleTextStyle, tooltip, vAxis, width) {
        _classCallCheck(this, BubbleChartOptions);

        this.animation = animation;
        this.axisTitlesPosition = axisTitlesPosition;
        this.backgroundColor = backgroundColor;
        this.bubble = bubble;
        this.chartArea = chartArea;
        this.colors = colors;
        this.colorAxis = colorAxis;
        this.enableInteractivity = enableInteractivity;
        this.explorer = explorer;
        this.fontSize = fontSize;
        this.fontName = fontName;
        this.forceIFrame = forceIFrame;
        this.hAxis = hAxis;
        this.height = height;
        this.legend = legend;
        this.selectionMode = selectionMode;
        this.series = series;
        this.sizeAxis = sizeAxis;
        this.sortBubblesBySize = sortBubblesBySize;
        this.theme = theme;
        this.title = title;
        this.titlePosition = titlePosition;
        this.titleTextStyle = titleTextStyle;
        this.tooltip = tooltip;
        this.vAxis = vAxis;
        this.width = width;
    }

    _createClass(BubbleChartOptions, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.BubbleChartOptions",
                interfaces: ["FSharpRecord", "System.IEquatable"],
                properties: {
                    animation: TransitionAnimation,
                    axisTitlesPosition: "string",
                    backgroundColor: Any,
                    bubble: ChartBubble,
                    chartArea: ChartArea,
                    colors: _Array("string"),
                    colorAxis: ChartColorAxis,
                    enableInteractivity: "boolean",
                    explorer: ChartExplorer,
                    fontSize: "number",
                    fontName: "string",
                    forceIFrame: "boolean",
                    hAxis: ChartAxis,
                    height: "number",
                    legend: ChartLegend,
                    selectionMode: "string",
                    series: Any,
                    sizeAxis: ChartSizeAxis,
                    sortBubblesBySize: "boolean",
                    theme: "string",
                    title: "string",
                    titlePosition: "string",
                    titleTextStyle: ChartTextStyle,
                    tooltip: ChartTooltip,
                    vAxis: ChartAxis,
                    width: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }]);

    return BubbleChartOptions;
}();
setType("TheGamma.GoogleCharts.Options.BubbleChartOptions", BubbleChartOptions);
export var TreeMapOptions = function () {
    function TreeMapOptions(fontColor, fontFamily, fontSize, forceIFrame, headerColor, headerHeight, headerHighlightColor, hintOpacity, maxColor, maxDepth, maxHighlightColor, maxPostDepth, maxColorValue, midColor, midHighlightColor, minColor, minHighlightColor, minColorValue, showScale, showTooltips, textStyle, title, titleTextStyle, useWeightedAverageForAggregation) {
        _classCallCheck(this, TreeMapOptions);

        this.fontColor = fontColor;
        this.fontFamily = fontFamily;
        this.fontSize = fontSize;
        this.forceIFrame = forceIFrame;
        this.headerColor = headerColor;
        this.headerHeight = headerHeight;
        this.headerHighlightColor = headerHighlightColor;
        this.hintOpacity = hintOpacity;
        this.maxColor = maxColor;
        this.maxDepth = maxDepth;
        this.maxHighlightColor = maxHighlightColor;
        this.maxPostDepth = maxPostDepth;
        this.maxColorValue = maxColorValue;
        this.midColor = midColor;
        this.midHighlightColor = midHighlightColor;
        this.minColor = minColor;
        this.minHighlightColor = minHighlightColor;
        this.minColorValue = minColorValue;
        this.showScale = showScale;
        this.showTooltips = showTooltips;
        this.textStyle = textStyle;
        this.title = title;
        this.titleTextStyle = titleTextStyle;
        this.useWeightedAverageForAggregation = useWeightedAverageForAggregation;
    }

    _createClass(TreeMapOptions, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.TreeMapOptions",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    fontColor: "string",
                    fontFamily: "string",
                    fontSize: "number",
                    forceIFrame: "boolean",
                    headerColor: "string",
                    headerHeight: "number",
                    headerHighlightColor: "string",
                    hintOpacity: "number",
                    maxColor: "string",
                    maxDepth: "number",
                    maxHighlightColor: "string",
                    maxPostDepth: "number",
                    maxColorValue: "number",
                    midColor: "string",
                    midHighlightColor: "string",
                    minColor: "string",
                    minHighlightColor: "string",
                    minColorValue: "number",
                    showScale: "boolean",
                    showTooltips: "boolean",
                    textStyle: ChartTextStyle,
                    title: "string",
                    titleTextStyle: ChartTextStyle,
                    useWeightedAverageForAggregation: "boolean"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareRecords(this, other);
        }
    }]);

    return TreeMapOptions;
}();
setType("TheGamma.GoogleCharts.Options.TreeMapOptions", TreeMapOptions);
export var CssClassNames = function () {
    function CssClassNames(headerRow, tableRow, oddTableRow, selectedTableRow, hoverTableRow, headerCell, tableCell, rowNumberCell) {
        _classCallCheck(this, CssClassNames);

        this.headerRow = headerRow;
        this.tableRow = tableRow;
        this.oddTableRow = oddTableRow;
        this.selectedTableRow = selectedTableRow;
        this.hoverTableRow = hoverTableRow;
        this.headerCell = headerCell;
        this.tableCell = tableCell;
        this.rowNumberCell = rowNumberCell;
    }

    _createClass(CssClassNames, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.CssClassNames",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    headerRow: "string",
                    tableRow: "string",
                    oddTableRow: "string",
                    selectedTableRow: "string",
                    hoverTableRow: "string",
                    headerCell: "string",
                    tableCell: "string",
                    rowNumberCell: "string"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareRecords(this, other);
        }
    }]);

    return CssClassNames;
}();
setType("TheGamma.GoogleCharts.Options.CssClassNames", CssClassNames);
export var TableOptions = function () {
    function TableOptions(allowHtml, alternatingRowStyle, cssClassName, firstRowNumber, height, page, pageSize, rtlTable, scrollLeftStartPosition, showRowNumber, sort, sortAscending, sortColumn, startPage, width) {
        _classCallCheck(this, TableOptions);

        this.allowHtml = allowHtml;
        this.alternatingRowStyle = alternatingRowStyle;
        this.cssClassName = cssClassName;
        this.firstRowNumber = firstRowNumber;
        this.height = height;
        this.page = page;
        this.pageSize = pageSize;
        this.rtlTable = rtlTable;
        this.scrollLeftStartPosition = scrollLeftStartPosition;
        this.showRowNumber = showRowNumber;
        this.sort = sort;
        this.sortAscending = sortAscending;
        this.sortColumn = sortColumn;
        this.startPage = startPage;
        this.width = width;
    }

    _createClass(TableOptions, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.TableOptions",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    allowHtml: "boolean",
                    alternatingRowStyle: "boolean",
                    cssClassName: CssClassNames,
                    firstRowNumber: "number",
                    height: "string",
                    page: "string",
                    pageSize: "number",
                    rtlTable: "boolean",
                    scrollLeftStartPosition: "number",
                    showRowNumber: "boolean",
                    sort: "string",
                    sortAscending: "boolean",
                    sortColumn: "number",
                    startPage: "number",
                    width: "string"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareRecords(this, other);
        }
    }]);

    return TableOptions;
}();
setType("TheGamma.GoogleCharts.Options.TableOptions", TableOptions);
export var LabelStyle = function () {
    function LabelStyle(color, fontName, fontSize) {
        _classCallCheck(this, LabelStyle);

        this.color = color;
        this.fontName = fontName;
        this.fontSize = fontSize;
    }

    _createClass(LabelStyle, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.LabelStyle",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    color: "string",
                    fontName: "string",
                    fontSize: "string"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareRecords(this, other);
        }
    }]);

    return LabelStyle;
}();
setType("TheGamma.GoogleCharts.Options.LabelStyle", LabelStyle);
export var TimelineTimeline = function () {
    function TimelineTimeline(barLabelStyle, colorByRowLabel, groupByRowLabel, rowLabelStyle, showRowLabels, singleColor) {
        _classCallCheck(this, TimelineTimeline);

        this.barLabelStyle = barLabelStyle;
        this.colorByRowLabel = colorByRowLabel;
        this.groupByRowLabel = groupByRowLabel;
        this.rowLabelStyle = rowLabelStyle;
        this.showRowLabels = showRowLabels;
        this.singleColor = singleColor;
    }

    _createClass(TimelineTimeline, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.TimelineTimeline",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    barLabelStyle: LabelStyle,
                    colorByRowLabel: "boolean",
                    groupByRowLabel: "boolean",
                    rowLabelStyle: LabelStyle,
                    showRowLabels: "boolean",
                    singleColor: "string"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareRecords(this, other);
        }
    }]);

    return TimelineTimeline;
}();
setType("TheGamma.GoogleCharts.Options.TimelineTimeline", TimelineTimeline);
export var TimelineOptions = function () {
    function TimelineOptions(avoidOverlappingGridLines, backgroundColor, colors, enableInteractivity, forceIFrame, height, timeline, width) {
        _classCallCheck(this, TimelineOptions);

        this.avoidOverlappingGridLines = avoidOverlappingGridLines;
        this.backgroundColor = backgroundColor;
        this.colors = colors;
        this.enableInteractivity = enableInteractivity;
        this.forceIFrame = forceIFrame;
        this.height = height;
        this.timeline = timeline;
        this.width = width;
    }

    _createClass(TimelineOptions, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.TimelineOptions",
                interfaces: ["FSharpRecord", "System.IEquatable"],
                properties: {
                    avoidOverlappingGridLines: "boolean",
                    backgroundColor: Any,
                    colors: _Array("string"),
                    enableInteractivity: "boolean",
                    forceIFrame: "boolean",
                    height: "number",
                    timeline: TimelineTimeline,
                    width: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }]);

    return TimelineOptions;
}();
setType("TheGamma.GoogleCharts.Options.TimelineOptions", TimelineOptions);
export var CandlestickCandlestick = function () {
    function CandlestickCandlestick(hollowIsRising, fallingColor, risingColor) {
        _classCallCheck(this, CandlestickCandlestick);

        this.hollowIsRising = hollowIsRising;
        this.fallingColor = fallingColor;
        this.risingColor = risingColor;
    }

    _createClass(CandlestickCandlestick, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.CandlestickCandlestick",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    hollowIsRising: "boolean",
                    fallingColor: ChartStroke,
                    risingColor: ChartStroke
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareRecords(this, other);
        }
    }]);

    return CandlestickCandlestick;
}();
setType("TheGamma.GoogleCharts.Options.CandlestickCandlestick", CandlestickCandlestick);
export var CandlestickChartOptions = function () {
    function CandlestickChartOptions(aggregationTarget, animation, axisTitlesPosition, backgroundColor, bar, candlestick, chartArea, colors, enableInteractivity, focusTarget, fontSize, fontName, hAxis, height, legend, orientation, reverseCategories, selectionMode, series, theme, title, titlePosition, titleTextStyle, tooltip, vAxes, vAxis, width) {
        _classCallCheck(this, CandlestickChartOptions);

        this.aggregationTarget = aggregationTarget;
        this.animation = animation;
        this.axisTitlesPosition = axisTitlesPosition;
        this.backgroundColor = backgroundColor;
        this.bar = bar;
        this.candlestick = candlestick;
        this.chartArea = chartArea;
        this.colors = colors;
        this.enableInteractivity = enableInteractivity;
        this.focusTarget = focusTarget;
        this.fontSize = fontSize;
        this.fontName = fontName;
        this.hAxis = hAxis;
        this.height = height;
        this.legend = legend;
        this.orientation = orientation;
        this.reverseCategories = reverseCategories;
        this.selectionMode = selectionMode;
        this.series = series;
        this.theme = theme;
        this.title = title;
        this.titlePosition = titlePosition;
        this.titleTextStyle = titleTextStyle;
        this.tooltip = tooltip;
        this.vAxes = vAxes;
        this.vAxis = vAxis;
        this.width = width;
    }

    _createClass(CandlestickChartOptions, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.GoogleCharts.Options.CandlestickChartOptions",
                interfaces: ["FSharpRecord", "System.IEquatable"],
                properties: {
                    aggregationTarget: "string",
                    animation: TransitionAnimation,
                    axisTitlesPosition: "string",
                    backgroundColor: Any,
                    bar: GroupWidth,
                    candlestick: CandlestickCandlestick,
                    chartArea: ChartArea,
                    colors: _Array("string"),
                    enableInteractivity: "boolean",
                    focusTarget: "string",
                    fontSize: "number",
                    fontName: "string",
                    hAxis: ChartAxis,
                    height: "number",
                    legend: ChartLegend,
                    orientation: "string",
                    reverseCategories: "boolean",
                    selectionMode: "string",
                    series: Any,
                    theme: "string",
                    title: "string",
                    titlePosition: "string",
                    titleTextStyle: ChartTextStyle,
                    tooltip: ChartTooltip,
                    vAxes: Any,
                    vAxis: ChartAxis,
                    width: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }]);

    return CandlestickChartOptions;
}();
setType("TheGamma.GoogleCharts.Options.CandlestickChartOptions", CandlestickChartOptions);
//# sourceMappingURL=options.js.map