import _typeof from "babel-runtime/helpers/typeof";
import _Object$keys from "babel-runtime/core-js/object/keys";
import _classCallCheck from "babel-runtime/helpers/classCallCheck";
import _createClass from "babel-runtime/helpers/createClass";
import { setType } from "fable-core/Symbol";
import _Symbol from "fable-core/Symbol";
import { renderTo, text, op_EqualsGreater, h, El } from "./html";
import { ofArray } from "fable-core/List";
import List from "fable-core/List";
import { series } from "./series";
import { compare, Tuple, Any, Option, toString, makeGeneric, GenericParam } from "fable-core/Util";
import { startImmediate } from "fable-core/Async";
import { Log, niceNumber, Async$2E$AwaitFuture$2E$Static as Async_AwaitFuture_Static } from "./common";
import { head, map, empty, append, singleton, collect, delay, toList } from "fable-core/Seq";
import { isNullOrWhiteSpace, join, fsFormat } from "fable-core/String";
import { singleton as singleton_1 } from "fable-core/AsyncBuilder";
import { add, create as create_1 } from "fable-core/Map";
import _Map from "fable-core/Map";
import { create as _create } from "fable-core/Set";
import _Set from "fable-core/Set";
import GenericComparer from "fable-core/GenericComparer";
export var html = function () {
  function html() {
    _classCallCheck(this, html);
  }

  _createClass(html, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.html",
        properties: {}
      };
    }
  }], [{
    key: "img",
    value: function (url) {
      return function (arg0) {
        return function (arg1) {
          return El.op_Dynamic(arg0, arg1);
        };
      }(h)("img")(ofArray([op_EqualsGreater("src", url)]))(new List());
    }
  }]);

  return html;
}();
setType("TheGamma.html", html);
export var list = function () {
  function list(data, listTag, elementTag, itemFormat) {
    _classCallCheck(this, list);

    this.data = data;
    this.listTag = listTag;
    this.elementTag = elementTag;
    this.itemFormat = itemFormat;
  }

  _createClass(list, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.list",
        interfaces: ["FSharpRecord"],
        properties: {
          data: makeGeneric(series, {
            k: GenericParam("k"),
            v: GenericParam("v")
          }),
          listTag: "string",
          elementTag: "string",
          itemFormat: "function"
        }
      };
    }
  }, {
    key: "show",
    value: function (outputId) {
      var _this = this;

      (function (arg00) {
        startImmediate(arg00);
      })(function (builder_) {
        return builder_.Delay(function () {
          return builder_.Bind(Async_AwaitFuture_Static(_this.data.data), function (_arg1) {
            var els = toList(delay(function () {
              return collect(function (matchValue) {
                return singleton(fsFormat("<%s>%s</%s>")(function (x) {
                  return x;
                })(_this.elementTag)(toString(_this.itemFormat(matchValue[1])))(_this.elementTag));
              }, _arg1);
            }));
            document.getElementById(outputId).innerHTML = fsFormat("<%s>%s</%s>")(function (x) {
              return x;
            })(_this.listTag)(join("", els))(_this.listTag);
            return builder_.Zero();
          });
        });
      }(singleton_1));
    }
  }, {
    key: "setTags",
    value: function (list_1, element) {
      return new list(this.data, list_1, element, this.itemFormat);
    }
  }, {
    key: "setFormat",
    value: function (f) {
      return new list(this.data, this.listTag, this.elementTag, f);
    }
  }], [{
    key: "create",
    value: function (data) {
      return new list(data, "ol", "li", function (o) {
        return o;
      });
    }
  }]);

  return list;
}();
setType("TheGamma.list", list);
export var table = function () {
  function table(data, showKey, emptyText, columnFormatters, hiddenColumns, addedColumns) {
    _classCallCheck(this, table);

    this.data = data;
    this.showKey = showKey;
    this.emptyText = emptyText;
    this.columnFormatters = columnFormatters;
    this.hiddenColumns = hiddenColumns;
    this.addedColumns = addedColumns;
  }

  _createClass(table, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.table",
        interfaces: ["FSharpRecord"],
        properties: {
          data: makeGeneric(series, {
            k: GenericParam("k"),
            v: GenericParam("v")
          }),
          showKey: Option("boolean"),
          emptyText: "string",
          columnFormatters: makeGeneric(_Map, {
            Key: "string",
            Value: Any
          }),
          hiddenColumns: makeGeneric(_Set, {
            T: "string"
          }),
          addedColumns: makeGeneric(List, {
            T: Tuple(["string", "function"])
          })
        }
      };
    }
  }, {
    key: "set",
    value: function (title, showKey, emptyText) {
      var data = this.data.set(this.data.data, null, null, title != null ? title : this.data.seriesName);
      var emptyText_1 = emptyText != null ? emptyText : this.emptyText;
      return new table(data, showKey == null ? this.showKey : showKey, emptyText_1, this.columnFormatters, this.hiddenColumns, this.addedColumns);
    }
  }, {
    key: "setFormat",
    value: function (column, formatter) {
      var columnFormatters = add(column, formatter, this.columnFormatters);
      return new table(this.data, this.showKey, this.emptyText, columnFormatters, this.hiddenColumns, this.addedColumns);
    }
  }, {
    key: "hideColumns",
    value: function (names) {
      var hiddenColumns = _create(names, new GenericComparer(compare));

      return new table(this.data, this.showKey, this.emptyText, this.columnFormatters, hiddenColumns, this.addedColumns);
    }
  }, {
    key: "addColumn",
    value: function (name, f) {
      var addedColumns = new List([name, f], this.addedColumns);
      return new table(this.data, this.showKey, this.emptyText, this.columnFormatters, this.hiddenColumns, addedColumns);
    }
  }, {
    key: "render",
    value: function () {
      var _this2 = this;

      var row = function row(showKey) {
        return function (el) {
          return function (k) {
            return function (things) {
              var withTitle = function withTitle(_arg1) {
                if (_arg1.Case === "Text") {
                  return function (arg0) {
                    return function (arg1) {
                      return El.op_Dynamic(arg0, arg1);
                    };
                  }(h)("div")(ofArray([op_EqualsGreater("title", _arg1.Fields[0])]))(ofArray([text(_arg1.Fields[0])]));
                } else {
                  return _arg1;
                }
              };

              return function (arg0_1) {
                return function (arg1_1) {
                  return El.op_Dynamic(arg0_1, arg1_1);
                };
              }(h)("tr")(new List())(toList(delay(function () {
                return append(showKey ? singleton(function (arg0_2) {
                  return function (arg1_2) {
                    return El.op_Dynamic(arg0_2, arg1_2);
                  };
                }(h)(el)(new List())(ofArray([withTitle(text(k))]))) : empty(), delay(function () {
                  return map(function (t) {
                    return function (arg0_3) {
                      return function (arg1_3) {
                        return El.op_Dynamic(arg0_3, arg1_3);
                      };
                    }(h)(el)(new List())(ofArray([withTitle(t)]));
                  }, things);
                }));
              })));
            };
          };
        };
      };

      var makeTable = function makeTable(showKey_1) {
        return function (k_1) {
          return function (header) {
            return function (body) {
              return function (arg0_4) {
                return function (arg1_4) {
                  return El.op_Dynamic(arg0_4, arg1_4);
                };
              }(h)("table")(ofArray([op_EqualsGreater("class", "thegamma-table")]))(toList(delay(function () {
                return append(!isNullOrWhiteSpace(_this2.data.seriesName) ? singleton(function (arg0_5) {
                  return function (arg1_5) {
                    return El.op_Dynamic(arg0_5, arg1_5);
                  };
                }(h)("caption")(new List())(ofArray([text(_this2.data.seriesName)]))) : empty(), delay(function () {
                  return append(singleton(function (arg0_6) {
                    return function (arg1_6) {
                      return El.op_Dynamic(arg0_6, arg1_6);
                    };
                  }(h)("thead")(new List())(ofArray([row(showKey_1)("th")(k_1)(header)]))), delay(function () {
                    return singleton(function (arg0_7) {
                      return function (arg1_7) {
                        return El.op_Dynamic(arg0_7, arg1_7);
                      };
                    }(h)("tbody")(new List())(body));
                  }));
                }));
              })));
            };
          };
        };
      };

      var formatAdded = function formatAdded(o) {
        var isSeries = toList(delay(function () {
          return map(function (kv) {
            return kv.key;
          }, function (o) {
            return _Object$keys(o).map(function (k) {
              return {
                "key": k,
                "value": o[k]
              };
            });
          }(o));
        })).Equals(ofArray(["data", "keyName", "valueName", "seriesName"]));

        if (isSeries) {
          var result = null;
          o.data.Then(function (r) {
            result = r;
          });
          return function (arg0_8) {
            return function (arg1_8) {
              return El.op_Dynamic(arg0_8, arg1_8);
            };
          }(h)("span")(new List())(ofArray(result.map(function (tuple) {
            return tuple[1];
          })));
        } else {
          return text(toString(o));
        }
      };

      return function (builder_) {
        return builder_.Delay(function () {
          return builder_.TryWith(builder_.Delay(function () {
            return builder_.Bind(Async_AwaitFuture_Static(_this2.data.data), function (_arg29) {
              if (_arg29.length === 0) {
                return builder_.Return(function (arg0_9) {
                  return function (arg1_9) {
                    return El.op_Dynamic(arg0_9, arg1_9);
                  };
                }(h)("div")(ofArray([op_EqualsGreater("class", "placeholder")]))(ofArray([function (arg0_10) {
                  return function (arg1_10) {
                    return El.op_Dynamic(arg0_10, arg1_10);
                  };
                }(h)("p")(new List())(ofArray([text(_this2.emptyText)]))])));
              } else {
                var filteredProperties = function filteredProperties(o_1) {
                  return function (o) {
                    return _Object$keys(o).map(function (k) {
                      return {
                        "key": k,
                        "value": o[k]
                      };
                    });
                  }(o_1).filter(function (kv_1) {
                    return !_this2.hiddenColumns.has(kv_1.key);
                  });
                };

                var patternInput = head(_arg29);
                var headers = toList(delay(function () {
                  return append(_typeof(patternInput[1]) == 'object' ? map(function (kv_2) {
                    return text(kv_2.key);
                  }, filteredProperties(patternInput[1])) : singleton(text(_this2.data.valueName)), delay(function () {
                    return collect(function (matchValue) {
                      return singleton(text(matchValue[0]));
                    }, _this2.addedColumns);
                  }));
                }));
                var showKey_2 = _this2.showKey != null ? _this2.showKey : !(_typeof(patternInput[1]) == 'object');
                return builder_.Return(function (arg00) {
                  var clo1 = makeTable(arg00);
                  return function (arg10) {
                    var clo2 = clo1(arg10);
                    return function (arg20) {
                      var clo3 = clo2(arg20);
                      return function (arg30) {
                        return clo3(arg30);
                      };
                    };
                  };
                }(showKey_2)(_this2.data.keyName)(headers)(toList(delay(function () {
                  return collect(function (matchValue_1) {
                    return singleton(function () {
                      var formattedVals = toList(delay(function () {
                        return append(_typeof(matchValue_1[1]) == 'object' ? collect(function (kv_3) {
                          return _this2.columnFormatters.has(kv_3.key) ? singleton(text(_this2.columnFormatters.get(kv_3.key)(kv_3.value))) : kv_3.value instanceof Date ? singleton(text(kv_3.value.toLocaleString("en-US", {
                            hour: "numeric",
                            minute: "numeric",
                            second: "numeric"
                          }) + ", " + kv_3.value.toLocaleString("en-US", {
                            day: "numeric",
                            year: "numeric",
                            month: "short"
                          }))) : !(typeof kv_3.value == 'number') ? singleton(text(toString(kv_3.value))) : isNaN(kv_3.value) ? singleton(text("")) : singleton(text(niceNumber(kv_3.value, 2)));
                        }, filteredProperties(matchValue_1[1])) : matchValue_1[1] instanceof Date ? singleton(text(matchValue_1[1].toLocaleString("en-US", {
                          hour: "numeric",
                          minute: "numeric",
                          second: "numeric"
                        }) + ", " + matchValue_1[1].toLocaleString("en-US", {
                          day: "numeric",
                          year: "numeric",
                          month: "short"
                        }))) : !(typeof matchValue_1[1] == 'number') ? singleton(text(toString(matchValue_1[1]))) : isNaN(matchValue_1[1]) ? singleton(text("")) : singleton(text(niceNumber(matchValue_1[1], 2))), delay(function () {
                          return collect(function (matchValue_2) {
                            return singleton(formatAdded(matchValue_2[1](matchValue_1[1])));
                          }, _this2.addedColumns);
                        }));
                      }));
                      return function (arg00_1) {
                        var clo1_1 = row(arg00_1);
                        return function (arg10_1) {
                          var clo2_1 = clo1_1(arg10_1);
                          return function (arg20_1) {
                            var clo3_1 = clo2_1(arg20_1);
                            return function (arg30_1) {
                              return clo3_1(arg30_1);
                            };
                          };
                        };
                      }(showKey_2)("td")(matchValue_1[0])(formattedVals);
                    }());
                  }, _arg29);
                }))));
              }
            });
          }), function (_arg36) {
            Log.exn("live", "Getting data for table failed: %O", _arg36);
            return builder_.Return(function () {
              throw _arg36;
            }());
          });
        });
      }(singleton_1);
    }
  }, {
    key: "show",
    value: function (outputId) {
      var _this3 = this;

      (function (arg00) {
        startImmediate(arg00);
      })(function (builder_) {
        return builder_.Delay(function () {
          return builder_.Bind(_this3.render(), function (_arg37) {
            renderTo(document.getElementById(outputId), _arg37);
            return builder_.Zero();
          });
        });
      }(singleton_1));
    }
  }], [{
    key: "create",
    value: function (data) {
      var emptyText = "No data available";

      var hiddenColumns = _create(null, new GenericComparer(compare));

      var columnFormatters = create_1(null, new GenericComparer(compare));
      var addedColumns = new List();
      return new table(data, null, emptyText, columnFormatters, hiddenColumns, addedColumns);
    }
  }]);

  return table;
}();
setType("TheGamma.table", table);
export var placeholder = function () {
  _createClass(placeholder, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.placeholder",
        properties: {}
      };
    }
  }]);

  function placeholder(message) {
    _classCallCheck(this, placeholder);

    this.message = message;
  }

  _createClass(placeholder, [{
    key: "show",
    value: function (outputId) {
      renderTo(document.getElementById(outputId), function (arg0) {
        return function (arg1) {
          return El.op_Dynamic(arg0, arg1);
        };
      }(h)("div")(ofArray([op_EqualsGreater("class", "placeholder")]))(ofArray([function (arg0_1) {
        return function (arg1_1) {
          return El.op_Dynamic(arg0_1, arg1_1);
        };
      }(h)("p")(new List())(ofArray([text(this.message)]))])));
    }
  }], [{
    key: "create",
    value: function (message) {
      return new placeholder(message);
    }
  }]);

  return placeholder;
}();
setType("TheGamma.placeholder", placeholder);
//# sourceMappingURL=tables.js.map