"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.worker = exports.languages = exports.editor = exports.Selection = exports.Range = exports.Position = exports.KeyMod = exports.Uri = exports.CancellationTokenSource = exports.Emitter = undefined;

var _monaco = require("monaco");

var Emitter = exports.Emitter = _monaco.Emitter;
var CancellationTokenSource = exports.CancellationTokenSource = _monaco.CancellationTokenSource;
var Uri = exports.Uri = _monaco.Uri;
var KeyMod = exports.KeyMod = _monaco.KeyMod;
var Position = exports.Position = _monaco.Position;
var _Range = _monaco.Range;
exports.Range = _Range;
var Selection = exports.Selection = _monaco.Selection;

var editor = exports.editor = function (__exports) {
    var MonacoWebWorker = __exports.MonacoWebWorker = _monaco.editor.MonacoWebWorker;
    var InternalEditorScrollbarOptions = __exports.InternalEditorScrollbarOptions = _monaco.editor.InternalEditorScrollbarOptions;
    var EditorWrappingInfo = __exports.EditorWrappingInfo = _monaco.editor.EditorWrappingInfo;
    var InternalEditorViewOptions = __exports.InternalEditorViewOptions = _monaco.editor.InternalEditorViewOptions;
    var EditorContribOptions = __exports.EditorContribOptions = _monaco.editor.EditorContribOptions;
    var InternalEditorOptions = __exports.InternalEditorOptions = _monaco.editor.InternalEditorOptions;
    var OverviewRulerPosition = __exports.OverviewRulerPosition = _monaco.editor.OverviewRulerPosition;
    var EditorLayoutInfo = __exports.EditorLayoutInfo = _monaco.editor.EditorLayoutInfo;
    var BareFontInfo = __exports.BareFontInfo = _monaco.editor.BareFontInfo;
    var FontInfo = __exports.FontInfo = _monaco.editor.FontInfo;
    var Globals = __exports.Globals = _monaco.editor;
    return __exports;
}({});

var languages = exports.languages = function (__exports) {
    var Globals = __exports.Globals = _monaco.languages;
    return __exports;
}({});

var worker = exports.worker = function (__exports) {
    var Globals = __exports.Globals = _monaco.worker;
    return __exports;
}({});
//# sourceMappingURL=monaco.js.map