"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.chart = undefined;

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _Symbol2 = require("fable-core/umd/Symbol");

var _Symbol3 = _interopRequireDefault(_Symbol2);

var _extensions = require("./extensions");

var _core = require("./core");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var chart = exports.chart = function () {
  function chart() {
    (0, _classCallCheck3.default)(this, chart);
  }

  (0, _createClass3.default)(chart, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.GoogleCharts.chart",
        properties: {}
      };
    }
  }], [{
    key: "scatter",
    value: function (xval, yval) {
      return new _extensions.Scatter(_core.ChartDataOperations.twoValues(xval, yval), "ScatterChart", (0, _extensions.ScatterChartOptions$2E$get_empty$2E$Static)());
    }
  }, {
    key: "geo",
    value: function (data) {
      return new _extensions.Geo(_core.ChartDataOperations.oneKeyValue("string", data), "GeoChart", (0, _extensions.GeoChartOptions$2E$get_empty$2E$Static)());
    }
  }, {
    key: "pie",
    value: function (data) {
      return new _extensions.Pie(_core.ChartDataOperations.oneKeyValue("string", data), "PieChart", (0, _extensions.PieChartOptions$2E$get_empty$2E$Static)());
    }
  }, {
    key: "bar",
    value: function (data) {
      return new _extensions.Bar(_core.ChartDataOperations.oneKeyValue("string", data), "BarChart", (0, _extensions.BarChartOptions$2E$get_empty$2E$Static)());
    }
  }, {
    key: "column",
    value: function (data) {
      return new _extensions.Column(_core.ChartDataOperations.oneKeyValue("string", data), "ColumnChart", (0, _extensions.ColumnChartOptions$2E$get_empty$2E$Static)());
    }
  }, {
    key: "columns",
    value: function (data, colors) {
      return new _extensions.Line(_core.ChartDataOperations.oneKeyAppendValues("string", data, colors), "ColumnChart", (0, _extensions.LineChartOptions$2E$get_empty$2E$Static)());
    }
  }, {
    key: "line",
    value: function (data) {
      return new _extensions.Line(_core.ChartDataOperations.oneKeyValue("number", data), "LineChart", (0, _extensions.LineChartOptions$2E$get_empty$2E$Static)());
    }
  }, {
    key: "lines",
    value: function (data) {
      return new _extensions.Line(_core.ChartDataOperations.oneKeyNValues("number", data), "LineChart", (0, _extensions.LineChartOptions$2E$get_empty$2E$Static)());
    }
  }, {
    key: "area",
    value: function (data) {
      return new _extensions.Area(_core.ChartDataOperations.oneKeyValue("number", data), "AreaChart", (0, _extensions.AreaChartOptions$2E$get_empty$2E$Static)());
    }
  }, {
    key: "areas",
    value: function (data, names) {
      var i = {
        contents: 0
      };
      var data_1 = names == null ? data : data.map(function (s) {
        void i.contents++;
        return s.setProperties(null, null, names[i.contents - 1]);
      });
      return new _extensions.Area(_core.ChartDataOperations.oneKeyNValues("number", data_1), "AreaChart", (0, _extensions.AreaChartOptions$2E$get_empty$2E$Static)());
    }
  }, {
    key: "show",
    value: function (chart_1) {
      return function (outputId) {
        _core.Helpers.showChart(chart_1, outputId);
      };
    }
  }]);
  return chart;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.chart", chart);
//# sourceMappingURL=charts.js.map