"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.placeholder = exports.table = exports.list = exports.html = undefined;

var _typeof2 = require("babel-runtime/helpers/typeof");

var _typeof3 = _interopRequireDefault(_typeof2);

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _Symbol2 = require("fable-core/umd/Symbol");

var _Symbol3 = _interopRequireDefault(_Symbol2);

var _html = require("./html");

var _List = require("fable-core/umd/List");

var _List2 = _interopRequireDefault(_List);

var _series = require("./series");

var _Util = require("fable-core/umd/Util");

var _Async = require("fable-core/umd/Async");

var _common = require("./common");

var _Seq = require("fable-core/umd/Seq");

var _String = require("fable-core/umd/String");

var _AsyncBuilder = require("fable-core/umd/AsyncBuilder");

var _Map2 = require("fable-core/umd/Map");

var _Map3 = _interopRequireDefault(_Map2);

var _Set2 = require("fable-core/umd/Set");

var _Set3 = _interopRequireDefault(_Set2);

var _GenericComparer = require("fable-core/umd/GenericComparer");

var _GenericComparer2 = _interopRequireDefault(_GenericComparer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var html = exports.html = function () {
  function html() {
    (0, _classCallCheck3.default)(this, html);
  }

  (0, _createClass3.default)(html, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.html",
        properties: {}
      };
    }
  }], [{
    key: "img",
    value: function (url) {
      return function (arg0) {
        return function (arg1) {
          return _html.El.op_Dynamic(arg0, arg1);
        };
      }(_html.h)("img")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("src", url)]))(new _List2.default());
    }
  }]);
  return html;
}();

(0, _Symbol2.setType)("TheGamma.html", html);

var list = exports.list = function () {
  function list(data, listTag, elementTag, itemFormat) {
    (0, _classCallCheck3.default)(this, list);
    this.data = data;
    this.listTag = listTag;
    this.elementTag = elementTag;
    this.itemFormat = itemFormat;
  }

  (0, _createClass3.default)(list, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.list",
        interfaces: ["FSharpRecord"],
        properties: {
          data: (0, _Util.makeGeneric)(_series.series, {
            k: (0, _Util.GenericParam)("k"),
            v: (0, _Util.GenericParam)("v")
          }),
          listTag: "string",
          elementTag: "string",
          itemFormat: "function"
        }
      };
    }
  }, {
    key: "show",
    value: function (outputId) {
      var _this = this;

      (function (arg00) {
        (0, _Async.startImmediate)(arg00);
      })(function (builder_) {
        return builder_.Delay(function () {
          return builder_.Bind((0, _common.Async$2E$AwaitFuture$2E$Static)(_this.data.data), function (_arg1) {
            var els = (0, _Seq.toList)((0, _Seq.delay)(function () {
              return (0, _Seq.collect)(function (matchValue) {
                return (0, _Seq.singleton)((0, _String.fsFormat)("<%s>%s</%s>")(function (x) {
                  return x;
                })(_this.elementTag)((0, _Util.toString)(_this.itemFormat(matchValue[1])))(_this.elementTag));
              }, _arg1);
            }));
            document.getElementById(outputId).innerHTML = (0, _String.fsFormat)("<%s>%s</%s>")(function (x) {
              return x;
            })(_this.listTag)((0, _String.join)("", els))(_this.listTag);
            return builder_.Zero();
          });
        });
      }(_AsyncBuilder.singleton));
    }
  }, {
    key: "setTags",
    value: function (list_1, element) {
      return new list(this.data, list_1, element, this.itemFormat);
    }
  }, {
    key: "setFormat",
    value: function (f) {
      return new list(this.data, this.listTag, this.elementTag, f);
    }
  }], [{
    key: "create",
    value: function (data) {
      return new list(data, "ol", "li", function (o) {
        return o;
      });
    }
  }]);
  return list;
}();

(0, _Symbol2.setType)("TheGamma.list", list);

var table = exports.table = function () {
  function table(data, showKey, emptyText, columnFormatters, hiddenColumns, addedColumns) {
    (0, _classCallCheck3.default)(this, table);
    this.data = data;
    this.showKey = showKey;
    this.emptyText = emptyText;
    this.columnFormatters = columnFormatters;
    this.hiddenColumns = hiddenColumns;
    this.addedColumns = addedColumns;
  }

  (0, _createClass3.default)(table, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.table",
        interfaces: ["FSharpRecord"],
        properties: {
          data: (0, _Util.makeGeneric)(_series.series, {
            k: (0, _Util.GenericParam)("k"),
            v: (0, _Util.GenericParam)("v")
          }),
          showKey: (0, _Util.Option)("boolean"),
          emptyText: "string",
          columnFormatters: (0, _Util.makeGeneric)(_Map3.default, {
            Key: "string",
            Value: _Util.Any
          }),
          hiddenColumns: (0, _Util.makeGeneric)(_Set3.default, {
            T: "string"
          }),
          addedColumns: (0, _Util.makeGeneric)(_List2.default, {
            T: (0, _Util.Tuple)(["string", "function"])
          })
        }
      };
    }
  }, {
    key: "set",
    value: function (title, showKey, emptyText) {
      var data = this.data.set(this.data.data, null, null, title != null ? title : this.data.seriesName);
      var emptyText_1 = emptyText != null ? emptyText : this.emptyText;
      return new table(data, showKey == null ? this.showKey : showKey, emptyText_1, this.columnFormatters, this.hiddenColumns, this.addedColumns);
    }
  }, {
    key: "setFormat",
    value: function (column, formatter) {
      var columnFormatters = (0, _Map2.add)(column, formatter, this.columnFormatters);
      return new table(this.data, this.showKey, this.emptyText, columnFormatters, this.hiddenColumns, this.addedColumns);
    }
  }, {
    key: "hideColumns",
    value: function (names) {
      var hiddenColumns = (0, _Set2.create)(names, new _GenericComparer2.default(_Util.compare));
      return new table(this.data, this.showKey, this.emptyText, this.columnFormatters, hiddenColumns, this.addedColumns);
    }
  }, {
    key: "addColumn",
    value: function (name, f) {
      var addedColumns = new _List2.default([name, f], this.addedColumns);
      return new table(this.data, this.showKey, this.emptyText, this.columnFormatters, this.hiddenColumns, addedColumns);
    }
  }, {
    key: "render",
    value: function () {
      var _this2 = this;

      var row = function row(showKey) {
        return function (el) {
          return function (k) {
            return function (things) {
              var withTitle = function withTitle(_arg1) {
                if (_arg1.Case === "Text") {
                  return function (arg0) {
                    return function (arg1) {
                      return _html.El.op_Dynamic(arg0, arg1);
                    };
                  }(_html.h)("div")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("title", _arg1.Fields[0])]))((0, _List.ofArray)([(0, _html.text)(_arg1.Fields[0])]));
                } else {
                  return _arg1;
                }
              };

              return function (arg0_1) {
                return function (arg1_1) {
                  return _html.El.op_Dynamic(arg0_1, arg1_1);
                };
              }(_html.h)("tr")(new _List2.default())((0, _Seq.toList)((0, _Seq.delay)(function () {
                return (0, _Seq.append)(showKey ? (0, _Seq.singleton)(function (arg0_2) {
                  return function (arg1_2) {
                    return _html.El.op_Dynamic(arg0_2, arg1_2);
                  };
                }(_html.h)(el)(new _List2.default())((0, _List.ofArray)([withTitle((0, _html.text)(k))]))) : (0, _Seq.empty)(), (0, _Seq.delay)(function () {
                  return (0, _Seq.map)(function (t) {
                    return function (arg0_3) {
                      return function (arg1_3) {
                        return _html.El.op_Dynamic(arg0_3, arg1_3);
                      };
                    }(_html.h)(el)(new _List2.default())((0, _List.ofArray)([withTitle(t)]));
                  }, things);
                }));
              })));
            };
          };
        };
      };

      var makeTable = function makeTable(showKey_1) {
        return function (k_1) {
          return function (header) {
            return function (body) {
              return function (arg0_4) {
                return function (arg1_4) {
                  return _html.El.op_Dynamic(arg0_4, arg1_4);
                };
              }(_html.h)("table")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("class", "thegamma-table")]))((0, _Seq.toList)((0, _Seq.delay)(function () {
                return (0, _Seq.append)(!(0, _String.isNullOrWhiteSpace)(_this2.data.seriesName) ? (0, _Seq.singleton)(function (arg0_5) {
                  return function (arg1_5) {
                    return _html.El.op_Dynamic(arg0_5, arg1_5);
                  };
                }(_html.h)("caption")(new _List2.default())((0, _List.ofArray)([(0, _html.text)(_this2.data.seriesName)]))) : (0, _Seq.empty)(), (0, _Seq.delay)(function () {
                  return (0, _Seq.append)((0, _Seq.singleton)(function (arg0_6) {
                    return function (arg1_6) {
                      return _html.El.op_Dynamic(arg0_6, arg1_6);
                    };
                  }(_html.h)("thead")(new _List2.default())((0, _List.ofArray)([row(showKey_1)("th")(k_1)(header)]))), (0, _Seq.delay)(function () {
                    return (0, _Seq.singleton)(function (arg0_7) {
                      return function (arg1_7) {
                        return _html.El.op_Dynamic(arg0_7, arg1_7);
                      };
                    }(_html.h)("tbody")(new _List2.default())(body));
                  }));
                }));
              })));
            };
          };
        };
      };

      var formatAdded = function formatAdded(o) {
        var isSeries = (0, _Seq.toList)((0, _Seq.delay)(function () {
          return (0, _Seq.map)(function (kv) {
            return kv.key;
          }, function (o) {
            return (0, _keys2.default)(o).map(function (k) {
              return {
                "key": k,
                "value": o[k]
              };
            });
          }(o));
        })).Equals((0, _List.ofArray)(["data", "keyName", "valueName", "seriesName"]));

        if (isSeries) {
          var result = null;
          o.data.Then(function (r) {
            result = r;
          });
          return function (arg0_8) {
            return function (arg1_8) {
              return _html.El.op_Dynamic(arg0_8, arg1_8);
            };
          }(_html.h)("span")(new _List2.default())((0, _List.ofArray)(result.map(function (tuple) {
            return tuple[1];
          })));
        } else {
          return (0, _html.text)((0, _Util.toString)(o));
        }
      };

      return function (builder_) {
        return builder_.Delay(function () {
          return builder_.TryWith(builder_.Delay(function () {
            return builder_.Bind((0, _common.Async$2E$AwaitFuture$2E$Static)(_this2.data.data), function (_arg29) {
              if (_arg29.length === 0) {
                return builder_.Return(function (arg0_9) {
                  return function (arg1_9) {
                    return _html.El.op_Dynamic(arg0_9, arg1_9);
                  };
                }(_html.h)("div")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("class", "placeholder")]))((0, _List.ofArray)([function (arg0_10) {
                  return function (arg1_10) {
                    return _html.El.op_Dynamic(arg0_10, arg1_10);
                  };
                }(_html.h)("p")(new _List2.default())((0, _List.ofArray)([(0, _html.text)(_this2.emptyText)]))])));
              } else {
                var filteredProperties = function filteredProperties(o_1) {
                  return function (o) {
                    return (0, _keys2.default)(o).map(function (k) {
                      return {
                        "key": k,
                        "value": o[k]
                      };
                    });
                  }(o_1).filter(function (kv_1) {
                    return !_this2.hiddenColumns.has(kv_1.key);
                  });
                };

                var patternInput = (0, _Seq.head)(_arg29);
                var headers = (0, _Seq.toList)((0, _Seq.delay)(function () {
                  return (0, _Seq.append)((0, _typeof3.default)(patternInput[1]) == 'object' ? (0, _Seq.map)(function (kv_2) {
                    return (0, _html.text)(kv_2.key);
                  }, filteredProperties(patternInput[1])) : (0, _Seq.singleton)((0, _html.text)(_this2.data.valueName)), (0, _Seq.delay)(function () {
                    return (0, _Seq.collect)(function (matchValue) {
                      return (0, _Seq.singleton)((0, _html.text)(matchValue[0]));
                    }, _this2.addedColumns);
                  }));
                }));
                var showKey_2 = _this2.showKey != null ? _this2.showKey : !((0, _typeof3.default)(patternInput[1]) == 'object');
                return builder_.Return(function (arg00) {
                  var clo1 = makeTable(arg00);
                  return function (arg10) {
                    var clo2 = clo1(arg10);
                    return function (arg20) {
                      var clo3 = clo2(arg20);
                      return function (arg30) {
                        return clo3(arg30);
                      };
                    };
                  };
                }(showKey_2)(_this2.data.keyName)(headers)((0, _Seq.toList)((0, _Seq.delay)(function () {
                  return (0, _Seq.collect)(function (matchValue_1) {
                    return (0, _Seq.singleton)(function () {
                      var formattedVals = (0, _Seq.toList)((0, _Seq.delay)(function () {
                        return (0, _Seq.append)((0, _typeof3.default)(matchValue_1[1]) == 'object' ? (0, _Seq.collect)(function (kv_3) {
                          return _this2.columnFormatters.has(kv_3.key) ? (0, _Seq.singleton)((0, _html.text)(_this2.columnFormatters.get(kv_3.key)(kv_3.value))) : kv_3.value instanceof Date ? (0, _Seq.singleton)((0, _html.text)(kv_3.value.toLocaleString("en-US", {
                            hour: "numeric",
                            minute: "numeric",
                            second: "numeric"
                          }) + ", " + kv_3.value.toLocaleString("en-US", {
                            day: "numeric",
                            year: "numeric",
                            month: "short"
                          }))) : !(typeof kv_3.value == 'number') ? (0, _Seq.singleton)((0, _html.text)((0, _Util.toString)(kv_3.value))) : isNaN(kv_3.value) ? (0, _Seq.singleton)((0, _html.text)("")) : (0, _Seq.singleton)((0, _html.text)((0, _common.niceNumber)(kv_3.value, 2)));
                        }, filteredProperties(matchValue_1[1])) : matchValue_1[1] instanceof Date ? (0, _Seq.singleton)((0, _html.text)(matchValue_1[1].toLocaleString("en-US", {
                          hour: "numeric",
                          minute: "numeric",
                          second: "numeric"
                        }) + ", " + matchValue_1[1].toLocaleString("en-US", {
                          day: "numeric",
                          year: "numeric",
                          month: "short"
                        }))) : !(typeof matchValue_1[1] == 'number') ? (0, _Seq.singleton)((0, _html.text)((0, _Util.toString)(matchValue_1[1]))) : isNaN(matchValue_1[1]) ? (0, _Seq.singleton)((0, _html.text)("")) : (0, _Seq.singleton)((0, _html.text)((0, _common.niceNumber)(matchValue_1[1], 2))), (0, _Seq.delay)(function () {
                          return (0, _Seq.collect)(function (matchValue_2) {
                            return (0, _Seq.singleton)(formatAdded(matchValue_2[1](matchValue_1[1])));
                          }, _this2.addedColumns);
                        }));
                      }));
                      return function (arg00_1) {
                        var clo1_1 = row(arg00_1);
                        return function (arg10_1) {
                          var clo2_1 = clo1_1(arg10_1);
                          return function (arg20_1) {
                            var clo3_1 = clo2_1(arg20_1);
                            return function (arg30_1) {
                              return clo3_1(arg30_1);
                            };
                          };
                        };
                      }(showKey_2)("td")(matchValue_1[0])(formattedVals);
                    }());
                  }, _arg29);
                }))));
              }
            });
          }), function (_arg36) {
            _common.Log.exn("live", "Getting data for table failed: %O", _arg36);

            return builder_.Return(function () {
              throw _arg36;
            }());
          });
        });
      }(_AsyncBuilder.singleton);
    }
  }, {
    key: "show",
    value: function (outputId) {
      var _this3 = this;

      (function (arg00) {
        (0, _Async.startImmediate)(arg00);
      })(function (builder_) {
        return builder_.Delay(function () {
          return builder_.Bind(_this3.render(), function (_arg37) {
            (0, _html.renderTo)(document.getElementById(outputId), _arg37);
            return builder_.Zero();
          });
        });
      }(_AsyncBuilder.singleton));
    }
  }], [{
    key: "create",
    value: function (data) {
      var emptyText = "No data available";
      var hiddenColumns = (0, _Set2.create)(null, new _GenericComparer2.default(_Util.compare));
      var columnFormatters = (0, _Map2.create)(null, new _GenericComparer2.default(_Util.compare));
      var addedColumns = new _List2.default();
      return new table(data, null, emptyText, columnFormatters, hiddenColumns, addedColumns);
    }
  }]);
  return table;
}();

(0, _Symbol2.setType)("TheGamma.table", table);

var placeholder = exports.placeholder = function () {
  (0, _createClass3.default)(placeholder, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.placeholder",
        properties: {}
      };
    }
  }]);

  function placeholder(message) {
    (0, _classCallCheck3.default)(this, placeholder);
    this.message = message;
  }

  (0, _createClass3.default)(placeholder, [{
    key: "show",
    value: function (outputId) {
      (0, _html.renderTo)(document.getElementById(outputId), function (arg0) {
        return function (arg1) {
          return _html.El.op_Dynamic(arg0, arg1);
        };
      }(_html.h)("div")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("class", "placeholder")]))((0, _List.ofArray)([function (arg0_1) {
        return function (arg1_1) {
          return _html.El.op_Dynamic(arg0_1, arg1_1);
        };
      }(_html.h)("p")(new _List2.default())((0, _List.ofArray)([(0, _html.text)(this.message)]))])));
    }
  }], [{
    key: "create",
    value: function (message) {
      return new placeholder(message);
    }
  }]);
  return placeholder;
}();

(0, _Symbol2.setType)("TheGamma.placeholder", placeholder);
//# sourceMappingURL=tables.js.map