"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof2 = require("babel-runtime/helpers/typeof");

var _typeof3 = _interopRequireDefault(_typeof2);

exports.listsEqual = listsEqual;
exports.optionsEqual = optionsEqual;
exports.typesEqual = typesEqual;

var _Seq = require("fable-core/umd/Seq");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function listsEqual($var315, $var316, $var317) {
  var _loop = function _loop() {
    var l1 = $var315;
    var l2 = $var316;
    var f = $var317;
    var matchValue = [l1, l2];
    var $var312 = matchValue[0].tail != null ? matchValue[1].tail != null ? function () {
      var ys = matchValue[1].tail;
      var y = matchValue[1].head;
      var xs = matchValue[0].tail;
      var x = matchValue[0].head;
      return f(x)(y);
    }() ? [1, matchValue[0].head, matchValue[0].tail, matchValue[1].head, matchValue[1].tail] : [2] : [2] : matchValue[1].tail == null ? [0] : [2];

    switch ($var312[0]) {
      case 0:
        return {
          v: true
        };

      case 1:
        $var315 = $var312[2];
        $var316 = $var312[4];
        $var317 = f;
        return "continue|listsEqual";

      case 2:
        return {
          v: false
        };
    }
  };

  listsEqual: while (true) {
    var _ret = _loop();

    switch (_ret) {
      case "continue|listsEqual":
        continue listsEqual;

      default:
        if ((typeof _ret === "undefined" ? "undefined" : (0, _typeof3.default)(_ret)) === "object") return _ret.v;
    }
  }
}

function optionsEqual(o1, o2, f) {
  var matchValue = [o1, o2];
  var $var313 = matchValue[0] != null ? matchValue[1] != null ? [1, matchValue[0], matchValue[1]] : [2] : matchValue[1] == null ? [0] : [2];

  switch ($var313[0]) {
    case 0:
      return true;

    case 1:
      return f($var313[1])($var313[2]);

    case 2:
      return false;
  }
}

function typesEqual(t1, t2) {
  var _loop2 = function _loop2() {
    var matchValue = [t1, t2];
    var $var314 = matchValue[0].Case === "Any" ? [0] : matchValue[0].Case === "List" ? matchValue[1].Case === "Any" ? [0] : matchValue[1].Case === "List" ? [1, matchValue[0].Fields[0], matchValue[1].Fields[0]] : [5] : matchValue[0].Case === "Method" ? matchValue[1].Case === "Any" ? [0] : matchValue[1].Case === "Method" ? [2, matchValue[0].Fields[0], matchValue[1].Fields[0], matchValue[0].Fields[1], matchValue[1].Fields[1]] : [5] : matchValue[0].Case === "Object" ? matchValue[1].Case === "Any" ? [0] : matchValue[1].Case === "Object" ? [3, matchValue[0].Fields[0], matchValue[1].Fields[0]] : [5] : matchValue[0].Case === "Primitive" ? matchValue[1].Case === "Any" ? [0] : matchValue[1].Case === "Primitive" ? [4, matchValue[0].Fields[0], matchValue[1].Fields[0]] : [5] : matchValue[1].Case === "Any" ? [0] : [5];

    switch ($var314[0]) {
      case 0:
        return {
          v: true
        };

      case 1:
        t1 = $var314[1];
        t2 = $var314[2];
        return "continue|typesEqual";

      case 2:
        if (optionsEqual($var314[3]((0, _Seq.toList)((0, _Seq.delay)(function () {
          return (0, _Seq.map)(function (ma) {
            return [ma.Type, null];
          }, $var314[1]);
        }))), $var314[4]((0, _Seq.toList)((0, _Seq.delay)(function () {
          return (0, _Seq.map)(function (ma_1) {
            return [ma_1.Type, null];
          }, $var314[2]);
        }))), function (t1_1) {
          return function (t2_1) {
            return typesEqual(t1_1, t2_1);
          };
        })) {
          return {
            v: listsEqual($var314[1], $var314[2], function (m1) {
              return function (m2) {
                return ((m1.Name === m2.Name ? m1.Optional === m2.Optional : false) ? m1.Static === m2.Static : false) ? typesEqual(m1.Type, m2.Type) : false;
              };
            })
          };
        } else {
          return {
            v: false
          };
        }

      case 3:
        return {
          v: $var314[1].TypeEquals($var314[2])
        };

      case 4:
        return {
          v: $var314[1].Equals($var314[2])
        };

      case 5:
        return {
          v: false
        };
    }
  };

  typesEqual: while (true) {
    var _ret2 = _loop2();

    switch (_ret2) {
      case "continue|typesEqual":
        continue typesEqual;

      default:
        if ((typeof _ret2 === "undefined" ? "undefined" : (0, _typeof3.default)(_ret2)) === "object") return _ret2.v;
    }
  }
}
//# sourceMappingURL=typeops.js.map