import _typeof from "babel-runtime/helpers/typeof";
import _Array$from from "babel-runtime/core-js/array/from";
import _Math$log from "babel-runtime/core-js/math/log10";
import _getIterator from "babel-runtime/core-js/get-iterator";
import _classCallCheck from "babel-runtime/helpers/classCallCheck";
import _createClass from "babel-runtime/helpers/createClass";
import { setType } from "fable-core/Symbol";
import _Symbol from "fable-core/Symbol";
import { Any, defaultArg, round, equalsRecords, toString, Option, Array as _Array, makeGeneric, GenericParam, Tuple, Interface, compareUnions, equalsUnions } from "fable-core/Util";
import { ofArray, reverse } from "fable-core/List";
import List from "fable-core/List";
import { split, newGuid, replace, fsFormat, join } from "fable-core/String";
import { op_EqualsBangGreater, h as h_1, text, s as s_3, El, op_EqualsGreater, DomNode } from "./html";
import { exists, skip, head, reduce, fold, rangeStep, filter, tryHead, isEmpty, map, empty, collect, singleton, append, toList, delay } from "fable-core/Seq";
import { distinct } from "fable-core/Set";
import Choice from "fable-core/Choice";
import { niceNumber } from "./common";
export var Color = function () {
  function Color(caseName, fields) {
    _classCallCheck(this, Color);

    this.Case = caseName;
    this.Fields = fields;
  }

  _createClass(Color, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Interactive.Compost.Color",
        interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
        cases: {
          HTML: ["string"],
          RGB: ["number", "number", "number"]
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsUnions(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return compareUnions(this, other);
    }
  }]);

  return Color;
}();
setType("TheGamma.Interactive.Compost.Color", Color);
export var Width = function () {
  function Width(caseName, fields) {
    _classCallCheck(this, Width);

    this.Case = caseName;
    this.Fields = fields;
  }

  _createClass(Width, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Interactive.Compost.Width",
        interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
        cases: {
          Pixels: ["number"]
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsUnions(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return compareUnions(this, other);
    }
  }]);

  return Width;
}();
setType("TheGamma.Interactive.Compost.Width", Width);
export var FillStyle = function () {
  function FillStyle(caseName, fields) {
    _classCallCheck(this, FillStyle);

    this.Case = caseName;
    this.Fields = fields;
  }

  _createClass(FillStyle, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Interactive.Compost.FillStyle",
        interfaces: ["FSharpUnion", "System.IEquatable"],
        cases: {
          LinearGradient: [Interface("System.Collections.Generic.IEnumerable")],
          Solid: [Tuple(["number", Color])]
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsUnions(this, other);
    }
  }]);

  return FillStyle;
}();
setType("TheGamma.Interactive.Compost.FillStyle", FillStyle);

var _Number = function () {
  function _Number(caseName, fields) {
    _classCallCheck(this, _Number);

    this.Case = caseName;
    this.Fields = fields;
  }

  _createClass(_Number, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Interactive.Compost.Number",
        interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
        cases: {
          Integer: ["number"],
          Percentage: ["number"]
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsUnions(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return compareUnions(this, other);
    }
  }]);

  return _Number;
}();

export { _Number as Number };
setType("TheGamma.Interactive.Compost.Number", _Number);
export var HorizontalAlign = function () {
  function HorizontalAlign(caseName, fields) {
    _classCallCheck(this, HorizontalAlign);

    this.Case = caseName;
    this.Fields = fields;
  }

  _createClass(HorizontalAlign, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Interactive.Compost.HorizontalAlign",
        interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
        cases: {
          Center: [],
          End: [],
          Start: []
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsUnions(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return compareUnions(this, other);
    }
  }]);

  return HorizontalAlign;
}();
setType("TheGamma.Interactive.Compost.HorizontalAlign", HorizontalAlign);
export var VerticalAlign = function () {
  function VerticalAlign(caseName, fields) {
    _classCallCheck(this, VerticalAlign);

    this.Case = caseName;
    this.Fields = fields;
  }

  _createClass(VerticalAlign, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Interactive.Compost.VerticalAlign",
        interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
        cases: {
          Baseline: [],
          Hanging: [],
          Middle: []
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsUnions(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return compareUnions(this, other);
    }
  }]);

  return VerticalAlign;
}();
setType("TheGamma.Interactive.Compost.VerticalAlign", VerticalAlign);
export var continuous = function () {
  function continuous(caseName, fields) {
    _classCallCheck(this, continuous);

    this.Case = caseName;
    this.Fields = fields;
  }

  _createClass(continuous, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Interactive.Compost.continuous",
        interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
        cases: {
          CO: ["number"]
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsUnions(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return compareUnions(this, other);
    }
  }]);

  return continuous;
}();
setType("TheGamma.Interactive.Compost.continuous", continuous);
export var categorical = function () {
  function categorical(caseName, fields) {
    _classCallCheck(this, categorical);

    this.Case = caseName;
    this.Fields = fields;
  }

  _createClass(categorical, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Interactive.Compost.categorical",
        interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
        cases: {
          CA: ["string"]
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsUnions(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return compareUnions(this, other);
    }
  }]);

  return categorical;
}();
setType("TheGamma.Interactive.Compost.categorical", categorical);
export var Value = function () {
  function Value(caseName, fields) {
    _classCallCheck(this, Value);

    this.Case = caseName;
    this.Fields = fields;
  }

  _createClass(Value, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Interactive.Compost.Value",
        interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
        cases: {
          CAR: [makeGeneric(categorical, {
            u: GenericParam("u")
          }), "number"],
          COV: [makeGeneric(continuous, {
            u: GenericParam("u")
          })]
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsUnions(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return compareUnions(this, other);
    }
  }]);

  return Value;
}();
setType("TheGamma.Interactive.Compost.Value", Value);
export var Scale = function () {
  function Scale(caseName, fields) {
    _classCallCheck(this, Scale);

    this.Case = caseName;
    this.Fields = fields;
  }

  _createClass(Scale, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Interactive.Compost.Scale",
        interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
        cases: {
          Categorical: [_Array(makeGeneric(categorical, {
            u: GenericParam("v")
          }))],
          Continuous: [makeGeneric(continuous, {
            u: GenericParam("v")
          }), makeGeneric(continuous, {
            u: GenericParam("v")
          })]
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsUnions(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return compareUnions(this, other);
    }
  }]);

  return Scale;
}();
setType("TheGamma.Interactive.Compost.Scale", Scale);
export var Style = function () {
  function Style(strokeColor, strokeWidth, strokeDashArray, fill, animation, font, cursor, formatAxisXLabel, formatAxisYLabel) {
    _classCallCheck(this, Style);

    this.StrokeColor = strokeColor;
    this.StrokeWidth = strokeWidth;
    this.StrokeDashArray = strokeDashArray;
    this.Fill = fill;
    this.Animation = animation;
    this.Font = font;
    this.Cursor = cursor;
    this.FormatAxisXLabel = formatAxisXLabel;
    this.FormatAxisYLabel = formatAxisYLabel;
  }

  _createClass(Style, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Interactive.Compost.Style",
        interfaces: ["FSharpRecord"],
        properties: {
          StrokeColor: Tuple(["number", Color]),
          StrokeWidth: Width,
          StrokeDashArray: Interface("System.Collections.Generic.IEnumerable"),
          Fill: FillStyle,
          Animation: Option(Tuple(["number", "string", "function"])),
          Font: "string",
          Cursor: "string",
          FormatAxisXLabel: "function",
          FormatAxisYLabel: "function"
        }
      };
    }
  }]);

  return Style;
}();
setType("TheGamma.Interactive.Compost.Style", Style);
export var EventHandler = function () {
  function EventHandler(caseName, fields) {
    _classCallCheck(this, EventHandler);

    this.Case = caseName;
    this.Fields = fields;
  }

  _createClass(EventHandler, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Interactive.Compost.EventHandler",
        interfaces: ["FSharpUnion"],
        cases: {
          Click: ["function"],
          MouseDown: ["function"],
          MouseLeave: ["function"],
          MouseMove: ["function"],
          MouseUp: ["function"],
          TouchEnd: ["function"],
          TouchMove: ["function"],
          TouchStart: ["function"]
        }
      };
    }
  }]);

  return EventHandler;
}();
setType("TheGamma.Interactive.Compost.EventHandler", EventHandler);
export var Orientation = function () {
  function Orientation(caseName, fields) {
    _classCallCheck(this, Orientation);

    this.Case = caseName;
    this.Fields = fields;
  }

  _createClass(Orientation, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Interactive.Compost.Orientation",
        interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
        cases: {
          Horizontal: [],
          Vertical: []
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsUnions(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return compareUnions(this, other);
    }
  }]);

  return Orientation;
}();
setType("TheGamma.Interactive.Compost.Orientation", Orientation);
export var Shape = function () {
  function Shape(caseName, fields) {
    _classCallCheck(this, Shape);

    this.Case = caseName;
    this.Fields = fields;
  }

  _createClass(Shape, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Interactive.Compost.Shape",
        interfaces: ["FSharpUnion"],
        cases: {
          AutoScale: ["boolean", "boolean", makeGeneric(Shape, {
            vx: GenericParam("vx"),
            vy: GenericParam("vy")
          })],
          Axes: ["boolean", "boolean", "boolean", "boolean", makeGeneric(Shape, {
            vx: GenericParam("vx"),
            vy: GenericParam("vy")
          })],
          Bubble: [makeGeneric(Value, {
            u: GenericParam("vx")
          }), makeGeneric(Value, {
            u: GenericParam("vy")
          }), "number", "number"],
          InnerScale: [Option(Tuple([makeGeneric(continuous, {
            u: GenericParam("vx")
          }), makeGeneric(continuous, {
            u: GenericParam("vx")
          })])), Option(Tuple([makeGeneric(continuous, {
            u: GenericParam("vy")
          }), makeGeneric(continuous, {
            u: GenericParam("vy")
          })])), makeGeneric(Shape, {
            vx: GenericParam("vx"),
            vy: GenericParam("vy")
          })],
          Interactive: [Interface("System.Collections.Generic.IEnumerable"), makeGeneric(Shape, {
            vx: GenericParam("vx"),
            vy: GenericParam("vy")
          })],
          Layered: [Interface("System.Collections.Generic.IEnumerable")],
          Line: [Interface("System.Collections.Generic.IEnumerable")],
          Offset: [Tuple(["number", "number"]), makeGeneric(Shape, {
            vx: GenericParam("vx"),
            vy: GenericParam("vy")
          })],
          OuterScale: [Option(makeGeneric(Scale, {
            v: GenericParam("vx")
          })), Option(makeGeneric(Scale, {
            v: GenericParam("vy")
          })), makeGeneric(Shape, {
            vx: GenericParam("vx"),
            vy: GenericParam("vy")
          })],
          Padding: [Tuple(["number", "number", "number", "number"]), makeGeneric(Shape, {
            vx: GenericParam("vx"),
            vy: GenericParam("vy")
          })],
          Shape: [Interface("System.Collections.Generic.IEnumerable")],
          Stack: [Orientation, Interface("System.Collections.Generic.IEnumerable")],
          Style: ["function", makeGeneric(Shape, {
            vx: GenericParam("vx"),
            vy: GenericParam("vy")
          })],
          Text: [makeGeneric(Value, {
            u: GenericParam("vx")
          }), makeGeneric(Value, {
            u: GenericParam("vy")
          }), VerticalAlign, HorizontalAlign, "number", "string"]
        }
      };
    }
  }]);

  return Shape;
}();
setType("TheGamma.Interactive.Compost.Shape", Shape);
export var Svg = function (__exports) {
  var StringBuilder = __exports.StringBuilder = function () {
    _createClass(StringBuilder, [{
      key: _Symbol.reflection,
      value: function () {
        return {
          type: "TheGamma.Interactive.Compost.Svg.StringBuilder",
          properties: {}
        };
      }
    }]);

    function StringBuilder() {
      _classCallCheck(this, StringBuilder);

      this.strs = new List();
    }

    _createClass(StringBuilder, [{
      key: "Append",
      value: function (s) {
        this.strs = new List(s, this.strs);
      }
    }, {
      key: "ToString",
      value: function () {
        return join("", reverse(this.strs));
      }
    }]);

    return StringBuilder;
  }();

  setType("TheGamma.Interactive.Compost.Svg.StringBuilder", StringBuilder);

  var PathSegment = __exports.PathSegment = function () {
    function PathSegment(caseName, fields) {
      _classCallCheck(this, PathSegment);

      this.Case = caseName;
      this.Fields = fields;
    }

    _createClass(PathSegment, [{
      key: _Symbol.reflection,
      value: function () {
        return {
          type: "TheGamma.Interactive.Compost.Svg.PathSegment",
          interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
          cases: {
            LineTo: [Tuple(["number", "number"])],
            MoveTo: [Tuple(["number", "number"])]
          }
        };
      }
    }, {
      key: "Equals",
      value: function (other) {
        return equalsUnions(this, other);
      }
    }, {
      key: "CompareTo",
      value: function (other) {
        return compareUnions(this, other);
      }
    }]);

    return PathSegment;
  }();

  setType("TheGamma.Interactive.Compost.Svg.PathSegment", PathSegment);

  var Svg = __exports.Svg = function () {
    function Svg(caseName, fields) {
      _classCallCheck(this, Svg);

      this.Case = caseName;
      this.Fields = fields;
    }

    _createClass(Svg, [{
      key: _Symbol.reflection,
      value: function () {
        return {
          type: "TheGamma.Interactive.Compost.Svg.Svg",
          interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
          cases: {
            Combine: [_Array(Svg)],
            Ellipse: [Tuple(["number", "number"]), Tuple(["number", "number"]), "string"],
            Empty: [],
            Path: [_Array(PathSegment), "string"],
            Rect: [Tuple(["number", "number"]), Tuple(["number", "number"]), "string"],
            Text: [Tuple(["number", "number"]), "string", "number", "string"]
          }
        };
      }
    }, {
      key: "Equals",
      value: function (other) {
        return equalsUnions(this, other);
      }
    }, {
      key: "CompareTo",
      value: function (other) {
        return compareUnions(this, other);
      }
    }]);

    return Svg;
  }();

  setType("TheGamma.Interactive.Compost.Svg.Svg", Svg);

  var mapSvg = __exports.mapSvg = function (f, _arg1) {
    if (_arg1.Case === "Combine") {
      return new Svg("Combine", [_arg1.Fields[0].map(function (_arg1_1) {
        return mapSvg(f, _arg1_1);
      })]);
    } else {
      return f(_arg1);
    }
  };

  var formatPath = __exports.formatPath = function (path) {
    var sb = new StringBuilder();
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = _getIterator(path), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var ps = _step.value;

        if (ps.Case === "LineTo") {
          var y = ps.Fields[0][1];
          var x = ps.Fields[0][0];
          sb.Append("L" + String(x) + " " + String(y) + " ");
        } else {
          var y_1 = ps.Fields[0][1];
          var x_1 = ps.Fields[0][0];
          sb.Append("M" + String(x_1) + " " + String(y_1) + " ");
        }
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }

    return toString(sb);
  };

  var RenderingContext = __exports.RenderingContext = function () {
    function RenderingContext(definitions) {
      _classCallCheck(this, RenderingContext);

      this.Definitions = definitions;
    }

    _createClass(RenderingContext, [{
      key: _Symbol.reflection,
      value: function () {
        return {
          type: "TheGamma.Interactive.Compost.Svg.RenderingContext",
          interfaces: ["FSharpRecord", "System.IEquatable"],
          properties: {
            Definitions: _Array(DomNode)
          }
        };
      }
    }, {
      key: "Equals",
      value: function (other) {
        return equalsRecords(this, other);
      }
    }]);

    return RenderingContext;
  }();

  setType("TheGamma.Interactive.Compost.Svg.RenderingContext", RenderingContext);

  var renderSvg = __exports.renderSvg = function (ctx, svg) {
    return delay(function () {
      if (svg.Case === "Text") {
        var y = svg.Fields[0][1];
        var x = svg.Fields[0][0];
        var attrs = toList(delay(function () {
          return append(singleton(op_EqualsGreater("style", svg.Fields[3])), delay(function () {
            return svg.Fields[2] === 0 ? append(singleton(op_EqualsGreater("x", String(x))), delay(function () {
              return singleton(op_EqualsGreater("y", String(y)));
            })) : append(singleton(op_EqualsGreater("x", "0")), delay(function () {
              return append(singleton(op_EqualsGreater("y", "0")), delay(function () {
                return singleton(op_EqualsGreater("transform", fsFormat("translate(%f,%f) rotate(%f)")(function (x) {
                  return x;
                })(x)(y)(svg.Fields[2])));
              }));
            }));
          }));
        }));
        return singleton(function (arg0) {
          return function (arg1) {
            return El.op_Dynamic(arg0, arg1);
          };
        }(s_3)("text")(attrs)(ofArray([text(svg.Fields[1])])));
      } else if (svg.Case === "Combine") {
        return collect(function (s) {
          return renderSvg(ctx, s);
        }, svg.Fields[0]);
      } else if (svg.Case === "Ellipse") {
        var ry = svg.Fields[1][1];
        var rx = svg.Fields[1][0];
        var cy = svg.Fields[0][1];
        var cx = svg.Fields[0][0];
        var attrs_1 = ofArray([op_EqualsGreater("cx", String(cx)), op_EqualsGreater("cy", String(cy)), op_EqualsGreater("rx", String(rx)), op_EqualsGreater("ry", String(ry)), op_EqualsGreater("style", svg.Fields[2])]);
        return singleton(function (arg0_1) {
          return function (arg1_1) {
            return El.op_Dynamic(arg0_1, arg1_1);
          };
        }(s_3)("ellipse")(attrs_1)(new List()));
      } else if (svg.Case === "Rect") {
        var y2 = svg.Fields[1][1];
        var y1 = svg.Fields[0][1];
        var x2 = svg.Fields[1][0];
        var x1 = svg.Fields[0][0];
        var patternInput = [x1 < x2 ? x1 : x2, y1 < y2 ? y1 : y2];
        var patternInput_1 = [Math.abs(x1 - x2), Math.abs(y1 - y2)];
        var attrs_2 = ofArray([op_EqualsGreater("x", String(patternInput[0])), op_EqualsGreater("y", String(patternInput[1])), op_EqualsGreater("width", String(patternInput_1[0])), op_EqualsGreater("height", String(patternInput_1[1])), op_EqualsGreater("style", svg.Fields[2])]);
        return singleton(function (arg0_2) {
          return function (arg1_2) {
            return El.op_Dynamic(arg0_2, arg1_2);
          };
        }(s_3)("rect")(attrs_2)(new List()));
      } else if (svg.Case === "Path") {
        var attrs_3 = ofArray([op_EqualsGreater("d", formatPath(svg.Fields[0])), op_EqualsGreater("style", svg.Fields[1])]);
        return singleton(function (arg0_3) {
          return function (arg1_3) {
            return El.op_Dynamic(arg0_3, arg1_3);
          };
        }(s_3)("path")(attrs_3)(new List()));
      } else {
        return empty();
      }
    });
  };

  var formatColor = __exports.formatColor = function (_arg1) {
    if (_arg1.Case === "HTML") {
      return _arg1.Fields[0];
    } else {
      return fsFormat("rgb(%d, %d, %d)")(function (x) {
        return x;
      })(_arg1.Fields[0])(_arg1.Fields[1])(_arg1.Fields[2]);
    }
  };

  var formatNumber = __exports.formatNumber = function (_arg1) {
    if (_arg1.Case === "Percentage") {
      return String(_arg1.Fields[0]) + "%";
    } else {
      return String(_arg1.Fields[0]);
    }
  };

  var formatStyle = __exports.formatStyle = function (defs, style) {
    var patternInput = void 0;

    if (style.Animation == null) {
      patternInput = [style, ""];
    } else {
      var ms = style.Animation[0];
      var ease = style.Animation[1];
      var anim = style.Animation[2];
      var id = "anim_" + replace(function () {
        var copyOfStruct = newGuid();
        return copyOfStruct;
      }(), "-", "");
      var fromstyle = formatStyle(defs, function () {
        var Animation = null;
        return new Style(style.StrokeColor, style.StrokeWidth, style.StrokeDashArray, style.Fill, Animation, style.Font, style.Cursor, style.FormatAxisXLabel, style.FormatAxisYLabel);
      }());
      var tostyle = formatStyle(defs, function () {
        var inputRecord = anim(style);
        var Animation_1 = null;
        return new Style(inputRecord.StrokeColor, inputRecord.StrokeWidth, inputRecord.StrokeDashArray, inputRecord.Fill, Animation_1, inputRecord.Font, inputRecord.Cursor, inputRecord.FormatAxisXLabel, inputRecord.FormatAxisYLabel);
      }());

      (function (arg00) {
        defs.push(arg00);
      })(function (arg0) {
        return function (arg1) {
          return El.op_Dynamic(arg0, arg1);
        };
      }(h_1)("style")(new List())(ofArray([text(fsFormat("@keyframes %s { from { %s } to { %s } }")(function (x) {
        return x;
      })(id)(fromstyle)(tostyle))])));

      patternInput = [anim(style), fsFormat("animation: %s %dms %s; ")(function (x) {
        return x;
      })(id)(ms)(ease)];
    }

    return patternInput[1] + join("", toList(delay(function () {
      return map(function (c) {
        return "cursor:" + c + ";";
      }, split(patternInput[0].Cursor, ","));
    }))) + ("font:" + patternInput[0].Font + ";") + fsFormat("stroke-opacity:%f; stroke-width:%dpx; stroke:%s; ")(function (x) {
      return x;
    })(patternInput[0].StrokeColor[0])(patternInput[0].StrokeWidth.Fields[0])(formatColor(patternInput[0].StrokeColor[1])) + (isEmpty(patternInput[0].StrokeDashArray) ? "" : "stroke-dasharray:" + join(",", map(function (_arg1) {
      return formatNumber(_arg1);
    }, patternInput[0].StrokeDashArray)) + ";") + (patternInput[0].Fill.Case === "Solid" ? function () {
      var fo = patternInput[0].Fill.Fields[0][0];
      var clr = patternInput[0].Fill.Fields[0][1];
      return fsFormat("fill-opacity:%f; fill:%s; ")(function (x) {
        return x;
      })(fo)(formatColor(clr));
    }() : function () {
      var id_1 = "gradient_" + replace(function () {
        var copyOfStruct_1 = newGuid();
        return copyOfStruct_1;
      }(), "-", "");

      (function (arg00_1) {
        defs.push(arg00_1);
      })(function (arg0_1) {
        return function (arg1_1) {
          return El.op_Dynamic(arg0_1, arg1_1);
        };
      }(s_3)("linearGradient")(ofArray([op_EqualsGreater("id", id_1)]))(toList(delay(function () {
        return collect(function (matchValue) {
          var o = matchValue[1][0];
          var clr_1 = matchValue[1][1];
          return singleton(function (arg0_2) {
            return function (arg1_2) {
              return El.op_Dynamic(arg0_2, arg1_2);
            };
          }(s_3)("stop")(ofArray([op_EqualsGreater("offset", String(matchValue[0]) + "%"), op_EqualsGreater("stop-color", formatColor(clr_1)), op_EqualsGreater("stop-opacity", String(o))]))(new List()));
        }, patternInput[0].Fill.Fields[0]);
      }))));

      return fsFormat("fill:url(#%s)")(function (x) {
        return x;
      })(id_1);
    }());
  };

  return __exports;
}({});
export var Scales = function (__exports) {
  var ScaledShapeInner = __exports.ScaledShapeInner = function () {
    function ScaledShapeInner(caseName, fields) {
      _classCallCheck(this, ScaledShapeInner);

      this.Case = caseName;
      this.Fields = fields;
    }

    _createClass(ScaledShapeInner, [{
      key: _Symbol.reflection,
      value: function () {
        return {
          type: "TheGamma.Interactive.Compost.Scales.ScaledShapeInner",
          interfaces: ["FSharpUnion"],
          cases: {
            ScaledBubble: [makeGeneric(Value, {
              u: GenericParam("vx")
            }), makeGeneric(Value, {
              u: GenericParam("vy")
            }), "number", "number"],
            ScaledInteractive: [Interface("System.Collections.Generic.IEnumerable"), makeGeneric(ScaledShape, {
              vx: GenericParam("vx"),
              vy: GenericParam("vy")
            })],
            ScaledLayered: [_Array(makeGeneric(ScaledShape, {
              vx: GenericParam("vx"),
              vy: GenericParam("vy")
            }))],
            ScaledLine: [_Array(Tuple([makeGeneric(Value, {
              u: GenericParam("vx")
            }), makeGeneric(Value, {
              u: GenericParam("vy")
            })]))],
            ScaledOffset: [Tuple(["number", "number"]), makeGeneric(ScaledShape, {
              vx: GenericParam("vx"),
              vy: GenericParam("vy")
            })],
            ScaledOuterScale: [Option(makeGeneric(Scale, {
              v: GenericParam("vx")
            })), Option(makeGeneric(Scale, {
              v: GenericParam("vy")
            })), makeGeneric(ScaledShape, {
              vx: GenericParam("vx"),
              vy: GenericParam("vy")
            })],
            ScaledPadding: [Tuple(["number", "number", "number", "number"]), makeGeneric(ScaledShape, {
              vx: GenericParam("vx"),
              vy: GenericParam("vy")
            })],
            ScaledShape: [_Array(Tuple([makeGeneric(Value, {
              u: GenericParam("vx")
            }), makeGeneric(Value, {
              u: GenericParam("vy")
            })]))],
            ScaledStack: [Orientation, _Array(makeGeneric(ScaledShape, {
              vx: GenericParam("vx"),
              vy: GenericParam("vy")
            }))],
            ScaledStyle: ["function", makeGeneric(ScaledShape, {
              vx: GenericParam("vx"),
              vy: GenericParam("vy")
            })],
            ScaledText: [makeGeneric(Value, {
              u: GenericParam("vx")
            }), makeGeneric(Value, {
              u: GenericParam("vy")
            }), VerticalAlign, HorizontalAlign, "number", "string"]
          }
        };
      }
    }]);

    return ScaledShapeInner;
  }();

  setType("TheGamma.Interactive.Compost.Scales.ScaledShapeInner", ScaledShapeInner);

  var ScaledShape = __exports.ScaledShape = function () {
    function ScaledShape(caseName, fields) {
      _classCallCheck(this, ScaledShape);

      this.Case = caseName;
      this.Fields = fields;
    }

    _createClass(ScaledShape, [{
      key: _Symbol.reflection,
      value: function () {
        return {
          type: "TheGamma.Interactive.Compost.Scales.ScaledShape",
          interfaces: ["FSharpUnion"],
          cases: {
            Scaled: [Tuple([makeGeneric(Scale, {
              v: GenericParam("vx")
            }), makeGeneric(Scale, {
              v: GenericParam("vy")
            })]), Tuple([makeGeneric(Scale, {
              v: GenericParam("vx")
            }), makeGeneric(Scale, {
              v: GenericParam("vy")
            })]), makeGeneric(ScaledShapeInner, {
              vx: GenericParam("vx"),
              vy: GenericParam("vy")
            })]
          }
        };
      }
    }]);

    return ScaledShape;
  }();

  setType("TheGamma.Interactive.Compost.Scales.ScaledShape", ScaledShape);

  var getExtremes = __exports.getExtremes = function (_arg1) {
    if (_arg1.Case === "Categorical") {
      return [new Value("CAR", [_arg1.Fields[0][0], 0]), new Value("CAR", [_arg1.Fields[0][_arg1.Fields[0].length - 1], 1])];
    } else {
      return [new Value("COV", [_arg1.Fields[0]]), new Value("COV", [_arg1.Fields[1]])];
    }
  };

  var calculateMagnitudeAndRange = __exports.calculateMagnitudeAndRange = function (lo, hi) {
    var magnitude = Math.pow(10, round(_Math$log(hi - lo)));
    var magnitude_1 = magnitude / 2;
    return [magnitude_1, [Math.floor(lo / magnitude_1) * magnitude_1, Math.ceil(hi / magnitude_1) * magnitude_1]];
  };

  var decimalPoints = __exports.decimalPoints = function (range_0, range_1) {
    var range = [range_0, range_1];
    var patternInput = calculateMagnitudeAndRange(range[0], range[1]);

    if (0 > Math.ceil(-_Math$log(patternInput[0]))) {
      return 0;
    } else {
      return Math.ceil(-_Math$log(patternInput[0]));
    }
  };

  var adjustRange = __exports.adjustRange = function (range_0, range_1) {
    var range = [range_0, range_1];
    return calculateMagnitudeAndRange(range[0], range[1])[1];
  };

  var adjustRangeUnits = __exports.adjustRangeUnits = function (l, h) {
    var patternInput = adjustRange(l, h);
    return [patternInput[0], patternInput[1]];
  };

  var toArray = __exports.toArray = function (s) {
    return _Array$from(s);
  };

  var generateSteps = __exports.generateSteps = function (count, k, lo, hi) {
    var patternInput = calculateMagnitudeAndRange(lo, hi);
    var nlo = patternInput[1][0];
    var nhi = patternInput[1][1];
    var dividers = ofArray([0.2, 0.5, 1, 2, 5, 10, 20, 40, 50, 60, 80, 100]);
    var magnitudes = map(function (d) {
      return patternInput[0] / d;
    }, dividers);
    var step = tryHead(filter(function (m) {
      return (hi - lo) / m >= count;
    }, magnitudes));
    var step_1 = step != null ? step : patternInput[0] / 100;
    return toArray(delay(function () {
      return collect(function (v) {
        return (v >= lo ? v <= hi : false) ? singleton(v) : empty();
      }, rangeStep(nlo, step_1 * k, nhi));
    }));
  };

  var generateAxisSteps = __exports.generateAxisSteps = function (s) {
    if (s.Case === "Categorical") {
      return _Array$from(delay(function () {
        return collect(function (matchValue) {
          return singleton(new Value("CAR", [new categorical("CA", [matchValue.Fields[0]]), 0.5]));
        }, s.Fields[0]);
      }));
    } else {
      var l = s.Fields[0].Fields[0];
      var h = s.Fields[1].Fields[0];
      return _Array$from(map(function (f) {
        return new Value("COV", [new continuous("CO", [f])]);
      }, generateSteps(6, 1, l, h)));
    }
  };

  var generateAxisLabels = __exports.generateAxisLabels = function (fmt, s) {
    var sunit = s;

    if (s.Case === "Categorical") {
      return _Array$from(delay(function () {
        return collect(function (matchValue) {
          return singleton([new Value("CAR", [new categorical("CA", [matchValue.Fields[0]]), 0.5]), fmt(sunit)(new Value("CAR", [new categorical("CA", [matchValue.Fields[0]]), 0.5]))]);
        }, s.Fields[0]);
      }));
    } else {
      var l = s.Fields[0].Fields[0];
      var h = s.Fields[1].Fields[0];
      return _Array$from(map(function (f) {
        return [new Value("COV", [new continuous("CO", [f])]), fmt(sunit)(new Value("COV", [new continuous("CO", [f])]))];
      }, generateSteps(6, 2, l, h)));
    }
  };

  var unionScales = __exports.unionScales = function (s1, s2) {
    var matchValue = [s1, s2];
    var $var85 = matchValue[0].Case === "Categorical" ? matchValue[1].Case === "Categorical" ? [1, matchValue[0].Fields[0], matchValue[1].Fields[0]] : [2] : matchValue[1].Case === "Continuous" ? [0, matchValue[0].Fields[1], matchValue[1].Fields[1], matchValue[0].Fields[0], matchValue[1].Fields[0]] : [2];

    switch ($var85[0]) {
      case 0:
        return new Scale("Continuous", [$var85[3].CompareTo($var85[4]) < 0 ? $var85[3] : $var85[4], $var85[1].CompareTo($var85[2]) > 0 ? $var85[1] : $var85[2]]);

      case 1:
        return new Scale("Categorical", [_Array$from(distinct($var85[1].concat($var85[2])))]);

      case 2:
        throw new Error("Cannot union continuous with categorical");
    }
  };

  var replaceScales = __exports.replaceScales = function (outer_0, outer_1, _arg1) {
    var outer = [outer_0, outer_1];
    var $var86 = _arg1.Fields[2].Case === "ScaledText" ? [0] : _arg1.Fields[2].Case === "ScaledBubble" ? [0] : _arg1.Fields[2].Case === "ScaledShape" ? [0] : _arg1.Fields[2].Case === "ScaledOuterScale" ? [1] : _arg1.Fields[2].Case === "ScaledOffset" ? [2] : _arg1.Fields[2].Case === "ScaledStyle" ? [3] : _arg1.Fields[2].Case === "ScaledPadding" ? [4] : _arg1.Fields[2].Case === "ScaledInteractive" ? [5] : _arg1.Fields[2].Case === "ScaledLayered" ? [6] : _arg1.Fields[2].Case === "ScaledStack" ? [7] : [0];

    switch ($var86[0]) {
      case 0:
        return new ScaledShape("Scaled", [outer, _arg1.Fields[1], _arg1.Fields[2]]);

      case 1:
        return new ScaledShape("Scaled", [outer, _arg1.Fields[1], _arg1.Fields[2]]);

      case 2:
        return new ScaledShape("Scaled", [outer, _arg1.Fields[1], new ScaledShapeInner("ScaledOffset", [_arg1.Fields[2].Fields[0], replaceScales(outer[0], outer[1], _arg1.Fields[2].Fields[1])])]);

      case 3:
        return new ScaledShape("Scaled", [outer, _arg1.Fields[1], new ScaledShapeInner("ScaledStyle", [_arg1.Fields[2].Fields[0], replaceScales(outer[0], outer[1], _arg1.Fields[2].Fields[1])])]);

      case 4:
        return new ScaledShape("Scaled", [outer, _arg1.Fields[1], new ScaledShapeInner("ScaledPadding", [_arg1.Fields[2].Fields[0], replaceScales(outer[0], outer[1], _arg1.Fields[2].Fields[1])])]);

      case 5:
        return new ScaledShape("Scaled", [outer, _arg1.Fields[1], new ScaledShapeInner("ScaledInteractive", [_arg1.Fields[2].Fields[0], replaceScales(outer[0], outer[1], _arg1.Fields[2].Fields[1])])]);

      case 6:
        return new ScaledShape("Scaled", [outer, _arg1.Fields[1], new ScaledShapeInner("ScaledLayered", [_arg1.Fields[2].Fields[0].map(function (arg10_) {
          return replaceScales(outer[0], outer[1], arg10_);
        })])]);

      case 7:
        return new ScaledShape("Scaled", [outer, _arg1.Fields[1], new ScaledShapeInner("ScaledStack", [_arg1.Fields[2].Fields[0], _arg1.Fields[2].Fields[1].map(function (arg10__1) {
          return replaceScales(outer[0], outer[1], arg10__1);
        })])]);
    }
  };

  var calculateShapeScale = __exports.calculateShapeScale = function (vals) {
    var scales = fold(function (state, value) {
      var matchValue = [state, value];
      var $var87 = matchValue[0].Case === "Choice2Of3" ? matchValue[1].Case === "COV" ? [1, matchValue[1].Fields[0].Fields[0], matchValue[0].Fields[0]] : [4] : matchValue[0].Case === "Choice3Of3" ? matchValue[1].Case === "CAR" ? [3, matchValue[1].Fields[0].Fields[0], matchValue[0].Fields[0]] : [4] : matchValue[1].Case === "CAR" ? [2, matchValue[1].Fields[0].Fields[0]] : [0, matchValue[1].Fields[0].Fields[0]];

      switch ($var87[0]) {
        case 0:
          return new Choice("Choice2Of3", [ofArray([$var87[1]])]);

        case 1:
          return new Choice("Choice2Of3", [new List($var87[1], $var87[2])]);

        case 2:
          return new Choice("Choice3Of3", [ofArray([$var87[1]])]);

        case 3:
          return new Choice("Choice3Of3", [new List($var87[1], $var87[2])]);

        case 4:
          throw new Error("Values with mismatching scales");
      }
    }, new Choice("Choice1Of3", [null]), vals);

    if (scales.Case === "Choice2Of3") {
      return new Scale("Continuous", [new continuous("CO", [reduce(function (x, y) {
        return Math.min(x, y);
      }, scales.Fields[0])]), new continuous("CO", [reduce(function (x, y) {
        return Math.max(x, y);
      }, scales.Fields[0])])]);
    } else if (scales.Case === "Choice3Of3") {
      return new Scale("Categorical", [_Array$from(distinct(_Array$from(delay(function () {
        return map(function (x) {
          return new categorical("CA", [x]);
        }, reverse(scales.Fields[0]));
      }))))]);
    } else {
      throw new Error("No values for calculating a scale");
    }
  };

  var calculateShapeScales = __exports.calculateShapeScales = function (points) {
    var xs = points.map(function (tuple) {
      return tuple[0];
    });
    var ys = points.map(function (tuple_1) {
      return tuple_1[1];
    });
    return [calculateShapeScale(xs), calculateShapeScale(ys)];
  };

  var calculateScales = __exports.calculateScales = function (style, shape) {
    var calculateScalesStyle = function calculateScalesStyle(style_1) {
      return function (shape_1) {
        return calculateScales(style_1, shape_1);
      };
    };

    var calculateScales_1 = function calculateScales_1(shape_2) {
      return calculateScales(style, shape_2);
    };

    if (shape.Case === "InnerScale") {
      var patternInput = calculateScales_1(shape.Fields[2]);
      var asy = patternInput.Fields[0][1];
      var asx = patternInput.Fields[0][0];
      var scales = [shape.Fields[0] != null ? function (tupledArg) {
        return new Scale("Continuous", [tupledArg[0], tupledArg[1]]);
      }(shape.Fields[0]) : asx, shape.Fields[1] != null ? function (tupledArg_1) {
        return new Scale("Continuous", [tupledArg_1[0], tupledArg_1[1]]);
      }(shape.Fields[1]) : asy];
      return replaceScales(scales[0], scales[1], new ScaledShape("Scaled", [scales, scales, patternInput.Fields[2]]));
    } else if (shape.Case === "AutoScale") {
      var patternInput_1 = calculateScales_1(shape.Fields[2]);
      var asy_1 = patternInput_1.Fields[0][1];
      var asx_1 = patternInput_1.Fields[0][0];

      var autoScale = function autoScale(_arg1) {
        if (_arg1.Case === "Continuous") {
          var l = _arg1.Fields[0].Fields[0];
          var h = _arg1.Fields[1].Fields[0];
          var patternInput_2 = adjustRangeUnits(l, h);
          return new Scale("Continuous", [new continuous("CO", [patternInput_2[0]]), new continuous("CO", [patternInput_2[1]])]);
        } else {
          return _arg1;
        }
      };

      var scales_1 = [shape.Fields[0] ? autoScale(asx_1) : asx_1, shape.Fields[1] ? autoScale(asy_1) : asy_1];
      return replaceScales(scales_1[0], scales_1[1], new ScaledShape("Scaled", [scales_1, scales_1, patternInput_1.Fields[2]]));
    } else if (shape.Case === "Offset") {
      var patternInput_3 = calculateScales_1(shape.Fields[1]);
      return new ScaledShape("Scaled", [patternInput_3.Fields[0], patternInput_3.Fields[0], new ScaledShapeInner("ScaledOffset", [shape.Fields[0], new ScaledShape("Scaled", [patternInput_3.Fields[0], patternInput_3.Fields[0], patternInput_3.Fields[2]])])]);
    } else if (shape.Case === "Style") {
      var patternInput_4 = calculateScalesStyle(shape.Fields[0](style))(shape.Fields[1]);
      return new ScaledShape("Scaled", [patternInput_4.Fields[0], patternInput_4.Fields[0], new ScaledShapeInner("ScaledStyle", [shape.Fields[0], new ScaledShape("Scaled", [patternInput_4.Fields[0], patternInput_4.Fields[0], patternInput_4.Fields[2]])])]);
    } else if (shape.Case === "Padding") {
      var patternInput_5 = calculateScales_1(shape.Fields[1]);
      return new ScaledShape("Scaled", [patternInput_5.Fields[0], patternInput_5.Fields[0], new ScaledShapeInner("ScaledPadding", [shape.Fields[0], new ScaledShape("Scaled", [patternInput_5.Fields[0], patternInput_5.Fields[0], patternInput_5.Fields[2]])])]);
    } else if (shape.Case === "Bubble") {
      var makeSingletonScale = function makeSingletonScale(_arg2) {
        if (_arg2.Case === "CAR") {
          return new Scale("Categorical", [[_arg2.Fields[0]]]);
        } else {
          return new Scale("Continuous", [_arg2.Fields[0], _arg2.Fields[0]]);
        }
      };

      var scales_2 = [makeSingletonScale(shape.Fields[0]), makeSingletonScale(shape.Fields[1])];
      return new ScaledShape("Scaled", [scales_2, scales_2, new ScaledShapeInner("ScaledBubble", [shape.Fields[0], shape.Fields[1], shape.Fields[2], shape.Fields[3]])]);
    } else if (shape.Case === "Text") {
      var makeSingletonScale_1 = function makeSingletonScale_1(_arg3) {
        if (_arg3.Case === "CAR") {
          return new Scale("Categorical", [[_arg3.Fields[0]]]);
        } else {
          return new Scale("Continuous", [_arg3.Fields[0], _arg3.Fields[0]]);
        }
      };

      var scales_3 = [makeSingletonScale_1(shape.Fields[0]), makeSingletonScale_1(shape.Fields[1])];
      return new ScaledShape("Scaled", [scales_3, scales_3, new ScaledShapeInner("ScaledText", [shape.Fields[0], shape.Fields[1], shape.Fields[2], shape.Fields[3], shape.Fields[4], shape.Fields[5]])]);
    } else if (shape.Case === "Line") {
      var line = _Array$from(shape.Fields[0]);

      var scales_4 = calculateShapeScales(line);
      return new ScaledShape("Scaled", [scales_4, scales_4, new ScaledShapeInner("ScaledLine", [line])]);
    } else if (shape.Case === "Shape") {
      var points = _Array$from(shape.Fields[0]);

      var scales_5 = calculateShapeScales(points);
      return new ScaledShape("Scaled", [scales_5, scales_5, new ScaledShapeInner("ScaledShape", [points])]);
    } else if (shape.Case === "Axes") {
      var patternInput_6 = calculateScales_1(shape.Fields[4]);
      var sy = patternInput_6.Fields[0][1];
      var sx = patternInput_6.Fields[0][0];
      var patternInput_7 = [getExtremes(sx), getExtremes(sy)];
      var ly = patternInput_7[1][0];
      var lx = patternInput_7[0][0];
      var hy = patternInput_7[1][1];
      var hx = patternInput_7[0][1];

      var LineStyle = function LineStyle(clr) {
        return function (alpha) {
          return function (width) {
            return function (shape_3) {
              return new Shape("Style", [function (s) {
                var Fill = new FillStyle("Solid", [[1, new Color("HTML", ["transparent"])]]);
                var StrokeWidth = new Width("Pixels", [width]);
                return new Style([alpha, new Color("HTML", [clr])], StrokeWidth, s.StrokeDashArray, Fill, s.Animation, s.Font, s.Cursor, s.FormatAxisXLabel, s.FormatAxisYLabel);
              }, shape_3]);
            };
          };
        };
      };

      var FontStyle = function FontStyle(style_2) {
        return function (shape_4) {
          return new Shape("Style", [function (s_1) {
            var Fill_1 = new FillStyle("Solid", [[1, new Color("HTML", ["black"])]]);
            return new Style([0, new Color("HTML", ["transparent"])], s_1.StrokeWidth, s_1.StrokeDashArray, Fill_1, s_1.Animation, style_2, s_1.Cursor, s_1.FormatAxisXLabel, s_1.FormatAxisYLabel);
          }, shape_4]);
        };
      };

      var shape_5 = calculateScales_1(new Shape("Layered", [toList(delay(function () {
        return append(map(function (x) {
          return LineStyle("#e4e4e4")(1)(1)(new Shape("Line", [ofArray([[x, ly], [x, hy]])]));
        }, generateAxisSteps(sx)), delay(function () {
          return append(map(function (y) {
            return LineStyle("#e4e4e4")(1)(1)(new Shape("Line", [ofArray([[lx, y], [hx, y]])]));
          }, generateAxisSteps(sy)), delay(function () {
            return append(shape.Fields[0] ? append(singleton(LineStyle("black")(1)(2)(new Shape("Line", [ofArray([[lx, hy], [hx, hy]])]))), delay(function () {
              return collect(function (matchValue) {
                return singleton(FontStyle("9pt sans-serif")(new Shape("Offset", [[0, -10], new Shape("Text", [matchValue[0], hy, new VerticalAlign("Baseline", []), new HorizontalAlign("Center", []), 0, matchValue[1]])])));
              }, generateAxisLabels(style.FormatAxisXLabel, sx));
            })) : empty(), delay(function () {
              return append(shape.Fields[1] ? append(singleton(LineStyle("black")(1)(2)(new Shape("Line", [ofArray([[hx, hy], [hx, ly]])]))), delay(function () {
                return collect(function (matchValue_1) {
                  return singleton(FontStyle("9pt sans-serif")(new Shape("Offset", [[10, 0], new Shape("Text", [hx, matchValue_1[0], new VerticalAlign("Middle", []), new HorizontalAlign("Start", []), 0, matchValue_1[1]])])));
                }, generateAxisLabels(style.FormatAxisYLabel, sy));
              })) : empty(), delay(function () {
                return append(shape.Fields[2] ? append(singleton(LineStyle("black")(1)(2)(new Shape("Line", [ofArray([[lx, ly], [hx, ly]])]))), delay(function () {
                  return collect(function (matchValue_2) {
                    return singleton(FontStyle("9pt sans-serif")(new Shape("Offset", [[0, 10], new Shape("Text", [matchValue_2[0], ly, new VerticalAlign("Hanging", []), new HorizontalAlign("Center", []), 0, matchValue_2[1]])])));
                  }, generateAxisLabels(style.FormatAxisXLabel, sx));
                })) : empty(), delay(function () {
                  return append(shape.Fields[3] ? append(singleton(LineStyle("black")(1)(2)(new Shape("Line", [ofArray([[lx, hy], [lx, ly]])]))), delay(function () {
                    return collect(function (matchValue_3) {
                      return singleton(FontStyle("9pt sans-serif")(new Shape("Offset", [[-10, 0], new Shape("Text", [lx, matchValue_3[0], new VerticalAlign("Middle", []), new HorizontalAlign("End", []), 0, matchValue_3[1]])])));
                    }, generateAxisLabels(style.FormatAxisYLabel, sy));
                  })) : empty(), delay(function () {
                    return singleton(shape.Fields[4]);
                  }));
                }));
              }));
            }));
          }));
        }));
      }))]));

      if (shape_5.Fields[2].Case === "ScaledLayered") {
        var shapes = shape_5.Fields[2].Fields[0];
        var padding = [shape.Fields[0] ? 30 : 0, shape.Fields[1] ? 50 : 0, shape.Fields[2] ? 30 : 0, shape.Fields[3] ? 50 : 0];
        return new ScaledShape("Scaled", [patternInput_6.Fields[0], patternInput_6.Fields[0], new ScaledShapeInner("ScaledPadding", [padding, new ScaledShape("Scaled", [patternInput_6.Fields[0], patternInput_6.Fields[0], new ScaledShapeInner("ScaledLayered", [shapes.map(function (arg10_) {
          return replaceScales(patternInput_6.Fields[0][0], patternInput_6.Fields[0][1], arg10_);
        })])])])]);
      } else {
        throw new Error("calculateScales: processing layered shape did not return layered shape");
      }
    } else if (shape.Case === "Stack") {
      var shapes_1 = _Array$from(shape.Fields[1]);

      var scaled = function (array) {
        return array.map(calculateScales_1);
      }(shapes_1);

      var sxs = scaled.map(function (_arg1_1) {
        var sx_1 = _arg1_1.Fields[0][0];
        return sx_1;
      });
      var sys = scaled.map(function (_arg2_1) {
        var sy_1 = _arg2_1.Fields[0][1];
        return sy_1;
      });
      var scales_6 = [sxs.reduce(function (s1, s2) {
        return unionScales(s1, s2);
      }), sys.reduce(function (s1_1, s2_1) {
        return unionScales(s1_1, s2_1);
      })];
      var matchValue_4 = [shape.Fields[0], scales_6];
      var $var88 = matchValue_4[0].Case === "Vertical" ? matchValue_4[1][1].Case === "Continuous" ? [1] : [2] : matchValue_4[1][0].Case === "Continuous" ? [0] : [2];

      switch ($var88[0]) {
        case 0:
          throw new Error("Horizontal stacking of continuous axes is not supported");
          break;

        case 1:
          throw new Error("Vertical stacking of continuous axes is not supported");
          break;

        case 2:
          break;
      }

      return replaceScales(scales_6[0], scales_6[1], new ScaledShape("Scaled", [scales_6, scales_6, new ScaledShapeInner("ScaledStack", [shape.Fields[0], scaled])]));
    } else if (shape.Case === "Layered") {
      var shapes_2 = _Array$from(shape.Fields[0]);

      var scaled_1 = function (array_1) {
        return array_1.map(calculateScales_1);
      }(shapes_2);

      var sxs_1 = scaled_1.map(function (_arg3_1) {
        var sx_2 = _arg3_1.Fields[0][0];
        return sx_2;
      });
      var sys_1 = scaled_1.map(function (_arg4) {
        var sy_2 = _arg4.Fields[0][1];
        return sy_2;
      });
      var scales_7 = [sxs_1.reduce(function (s1_2, s2_2) {
        return unionScales(s1_2, s2_2);
      }), sys_1.reduce(function (s1_3, s2_3) {
        return unionScales(s1_3, s2_3);
      })];
      return replaceScales(scales_7[0], scales_7[1], new ScaledShape("Scaled", [scales_7, scales_7, new ScaledShapeInner("ScaledLayered", [scaled_1])]));
    } else if (shape.Case === "Interactive") {
      var patternInput_8 = calculateScales_1(shape.Fields[1]);
      return new ScaledShape("Scaled", [patternInput_8.Fields[0], patternInput_8.Fields[0], new ScaledShapeInner("ScaledInteractive", [shape.Fields[0], new ScaledShape("Scaled", [patternInput_8.Fields[0], patternInput_8.Fields[0], patternInput_8.Fields[2]])])]);
    } else {
      var scaled_2 = calculateScales_1(shape.Fields[2]);
      var osy = scaled_2.Fields[0][1];
      var osx = scaled_2.Fields[0][0];
      var scales_8 = [defaultArg(shape.Fields[0], osx), defaultArg(shape.Fields[1], osy)];
      return new ScaledShape("Scaled", [scales_8, scaled_2.Fields[1], new ScaledShapeInner("ScaledOuterScale", [shape.Fields[0], shape.Fields[1], scaled_2])]);
    }
  };

  return __exports;
}({});
export var Projections = function (__exports) {
  var Projection = __exports.Projection = function () {
    function Projection(caseName, fields) {
      _classCallCheck(this, Projection);

      this.Case = caseName;
      this.Fields = fields;
    }

    _createClass(Projection, [{
      key: _Symbol.reflection,
      value: function () {
        return {
          type: "TheGamma.Interactive.Compost.Projections.Projection",
          interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
          cases: {
            Padding: [Tuple(["number", "number", "number", "number"]), Tuple([makeGeneric(Value, {
              u: GenericParam("vx")
            }), makeGeneric(Value, {
              u: GenericParam("vx")
            }), makeGeneric(Value, {
              u: GenericParam("vy")
            }), makeGeneric(Value, {
              u: GenericParam("vy")
            })]), makeGeneric(Projection, {
              vx: GenericParam("vx"),
              vy: GenericParam("vy"),
              ux: GenericParam("ux"),
              uy: GenericParam("uy")
            })],
            Rescale: [Tuple(["number", "number"]), Tuple(["number", "number"]), makeGeneric(Projection, {
              vx: GenericParam("vx"),
              vy: GenericParam("vy"),
              ux: GenericParam("ux"),
              uy: GenericParam("uy")
            })],
            Scale: [Tuple(["number", "number"]), Tuple(["number", "number"])]
          }
        };
      }
    }, {
      key: "Equals",
      value: function (other) {
        return equalsUnions(this, other);
      }
    }, {
      key: "CompareTo",
      value: function (other) {
        return compareUnions(this, other);
      }
    }]);

    return Projection;
  }();

  setType("TheGamma.Interactive.Compost.Projections.Projection", Projection);

  var ProjectedShapeInner = __exports.ProjectedShapeInner = function () {
    function ProjectedShapeInner(caseName, fields) {
      _classCallCheck(this, ProjectedShapeInner);

      this.Case = caseName;
      this.Fields = fields;
    }

    _createClass(ProjectedShapeInner, [{
      key: _Symbol.reflection,
      value: function () {
        return {
          type: "TheGamma.Interactive.Compost.Projections.ProjectedShapeInner",
          interfaces: ["FSharpUnion"],
          cases: {
            ProjectedBubble: [makeGeneric(Value, {
              u: GenericParam("vx")
            }), makeGeneric(Value, {
              u: GenericParam("vy")
            }), "number", "number"],
            ProjectedInteractive: [Interface("System.Collections.Generic.IEnumerable"), makeGeneric(ProjectedShape, {
              vx: GenericParam("vx"),
              vy: GenericParam("vy")
            })],
            ProjectedLayered: [_Array(makeGeneric(ProjectedShape, {
              vx: GenericParam("vx"),
              vy: GenericParam("vy")
            }))],
            ProjectedLine: [_Array(Tuple([makeGeneric(Value, {
              u: GenericParam("vx")
            }), makeGeneric(Value, {
              u: GenericParam("vy")
            })]))],
            ProjectedOffset: [Tuple(["number", "number"]), makeGeneric(ProjectedShape, {
              vx: GenericParam("vx"),
              vy: GenericParam("vy")
            })],
            ProjectedShape: [_Array(Tuple([makeGeneric(Value, {
              u: GenericParam("vx")
            }), makeGeneric(Value, {
              u: GenericParam("vy")
            })]))],
            ProjectedStack: [Orientation, _Array(makeGeneric(ProjectedShape, {
              vx: GenericParam("vx"),
              vy: GenericParam("vy")
            }))],
            ProjectedStyle: ["function", makeGeneric(ProjectedShape, {
              vx: GenericParam("vx"),
              vy: GenericParam("vy")
            })],
            ProjectedText: [makeGeneric(Value, {
              u: GenericParam("vx")
            }), makeGeneric(Value, {
              u: GenericParam("vy")
            }), VerticalAlign, HorizontalAlign, "number", "string"]
          }
        };
      }
    }]);

    return ProjectedShapeInner;
  }();

  setType("TheGamma.Interactive.Compost.Projections.ProjectedShapeInner", ProjectedShapeInner);

  var ProjectedShape = __exports.ProjectedShape = function () {
    function ProjectedShape(caseName, fields) {
      _classCallCheck(this, ProjectedShape);

      this.Case = caseName;
      this.Fields = fields;
    }

    _createClass(ProjectedShape, [{
      key: _Symbol.reflection,
      value: function () {
        return {
          type: "TheGamma.Interactive.Compost.Projections.ProjectedShape",
          interfaces: ["FSharpUnion"],
          cases: {
            Projected: [makeGeneric(Projection, {
              vx: GenericParam("vx"),
              vy: GenericParam("vy"),
              ux: Any,
              uy: Any
            }), Tuple([makeGeneric(Scale, {
              v: GenericParam("vx")
            }), makeGeneric(Scale, {
              v: GenericParam("vy")
            })]), makeGeneric(ProjectedShapeInner, {
              vx: GenericParam("vx"),
              vy: GenericParam("vy")
            })]
          }
        };
      }
    }]);

    return ProjectedShape;
  }();

  setType("TheGamma.Interactive.Compost.Projections.ProjectedShape", ProjectedShape);

  var scaleOne = __exports.scaleOne = function (tlv, thv, scale, coord) {
    var matchValue = [scale, coord];

    if (matchValue[0].Case === "Continuous") {
      if (matchValue[1].Case === "CAR") {
        throw new Error("Cannot project categorical value on a continuous scale.");
      } else {
        return new continuous("CO", [(matchValue[1].Fields[0].Fields[0] - matchValue[0].Fields[0].Fields[0]) / (matchValue[0].Fields[1].Fields[0] - matchValue[0].Fields[0].Fields[0]) * (thv - tlv) + tlv]);
      }
    } else if (matchValue[1].Case === "COV") {
      throw new Error("Cannot project continuous value on a categorical scale.");
    } else {
      var size = (thv - tlv) / matchValue[0].Fields[0].length;
      var i = matchValue[0].Fields[0].findIndex(function (_arg1) {
        return matchValue[1].Fields[0].Fields[0] === _arg1.Fields[0];
      });
      var i_1 = i + matchValue[1].Fields[1];
      return new continuous("CO", [tlv + i_1 * size]);
    }
  };

  var project = __exports.project = function (sx, sy, point_0, point_1, projection) {
    var point = [point_0, point_1];
    var matchValue = [projection, point];

    if (matchValue[0].Case === "Rescale") {
      var rly = matchValue[0].Fields[1][0];
      var rlx = matchValue[0].Fields[0][0];
      var rhy = matchValue[0].Fields[1][1];
      var rhx = matchValue[0].Fields[0][1];
      var proj = matchValue[0].Fields[2];
      var patternInput = [Scales.getExtremes(sx), Scales.getExtremes(sy)];
      var ly = patternInput[1][0];
      var lx = patternInput[0][0];
      var hy = patternInput[1][1];
      var hx = patternInput[0][1];
      var patternInput_1 = [project(sx, sy, lx, ly, proj), project(sx, sy, hx, hy, proj)];
      var y2 = patternInput_1[1][1].Fields[0];
      var y1 = patternInput_1[0][1].Fields[0];
      var x2 = patternInput_1[1][0].Fields[0];
      var x1 = patternInput_1[0][0].Fields[0];
      var patternInput_2 = [x1 < x2 ? x1 : x2, x1 > x2 ? x1 : x2, y1 < y2 ? y1 : y2, y1 > y2 ? y1 : y2];
      var patternInput_3 = project(sx, sy, matchValue[1][0], matchValue[1][1], proj);
      var y = patternInput_3[1].Fields[0];
      var x = patternInput_3[0].Fields[0];
      var nx = patternInput_2[0] === patternInput_2[1] ? x : patternInput_2[0] + (patternInput_2[1] - patternInput_2[0]) * ((x - patternInput_2[0]) / (patternInput_2[1] - patternInput_2[0]) * (rhx - rlx) + rlx);
      var ny = patternInput_2[2] === patternInput_2[3] ? y : patternInput_2[2] + (patternInput_2[3] - patternInput_2[2]) * ((y - patternInput_2[2]) / (patternInput_2[3] - patternInput_2[2]) * (rhy - rly) + rly);
      return [new continuous("CO", [nx]), new continuous("CO", [ny])];
    } else if (matchValue[0].Case === "Padding") {
      var t = matchValue[0].Fields[0][0];
      var r = matchValue[0].Fields[0][1];
      var projection_1 = matchValue[0].Fields[2];
      var ly_1 = matchValue[0].Fields[1][2];
      var lx_1 = matchValue[0].Fields[1][0];
      var l = matchValue[0].Fields[0][3];
      var hy_1 = matchValue[0].Fields[1][3];
      var hx_1 = matchValue[0].Fields[1][1];
      var b = matchValue[0].Fields[0][2];
      var patternInput_4 = project(sx, sy, lx_1, ly_1, projection_1);
      var y1_1 = patternInput_4[1].Fields[0];
      var x1_1 = patternInput_4[0].Fields[0];
      var patternInput_5 = project(sx, sy, hx_1, hy_1, projection_1);
      var y2_1 = patternInput_5[1].Fields[0];
      var x2_1 = patternInput_5[0].Fields[0];
      var patternInput_6 = [x1_1 < x2_1 ? x1_1 : x2_1, x1_1 > x2_1 ? x1_1 : x2_1, y1_1 < y2_1 ? y1_1 : y2_1, y1_1 > y2_1 ? y1_1 : y2_1];
      var patternInput_7 = project(sx, sy, point[0], point[1], projection_1);
      var y_1 = patternInput_7[1].Fields[0];
      var x_1 = patternInput_7[0].Fields[0];
      var nx_1 = patternInput_6[0] === patternInput_6[1] ? x_1 : patternInput_6[0] + l + (patternInput_6[1] - patternInput_6[0] - l - r) / (patternInput_6[1] - patternInput_6[0]) * (x_1 - patternInput_6[0]);
      var ny_1 = patternInput_6[2] === patternInput_6[3] ? y_1 : patternInput_6[2] + t + (patternInput_6[3] - patternInput_6[2] - t - b) / (patternInput_6[3] - patternInput_6[2]) * (y_1 - patternInput_6[2]);
      return [new continuous("CO", [nx_1]), new continuous("CO", [ny_1])];
    } else {
      var y_2 = matchValue[1][1];
      var x_2 = matchValue[1][0];
      var ty = matchValue[0].Fields[1];
      var tx = matchValue[0].Fields[0];
      return [scaleOne(tx[0], tx[1], sx, x_2), scaleOne(ty[0], ty[1], sy, y_2)];
    }
  };

  var scaleOneInv = __exports.scaleOneInv = function (tlv, thv, scale, coord) {
    var matchValue = [scale, coord];

    if (matchValue[0].Case === "Categorical") {
      var v = matchValue[1].Fields[0];
      var cats = matchValue[0].Fields[0];
      var size = (thv - tlv) / cats.length;
      var i = Math.floor(v / size);
      var f = v / size - i;
      var i_1 = size < 0 ? cats.length + i : i;

      if (~~i_1 < 0 ? true : ~~i_1 >= cats.length) {
        return new Value("CAR", [new categorical("CA", ["<outside-of-range>"]), f]);
      } else {
        return new Value("CAR", [cats[~~i_1], f]);
      }
    } else {
      var v_1 = matchValue[1].Fields[0];
      var slv = matchValue[0].Fields[0].Fields[0];
      var shv = matchValue[0].Fields[1].Fields[0];
      return new Value("COV", [new continuous("CO", [(v_1 - tlv) / (thv - tlv) * (shv - slv) + slv])]);
    }
  };

  var invertProj = __exports.invertProj = function (proj) {
    var $var89 = proj.Case === "Rescale" ? proj.Fields[2].Case === "Padding" ? [0, proj.Fields[2].Fields[1], proj.Fields[2].Fields[0], proj.Fields[2].Fields[2], proj.Fields[0], proj.Fields[1]] : [2] : proj.Case === "Padding" ? proj.Fields[2].Case === "Rescale" ? [1, proj.Fields[1], proj.Fields[0], proj.Fields[2].Fields[2], proj.Fields[2].Fields[0], proj.Fields[2].Fields[1]] : [2] : [2];

    switch ($var89[0]) {
      case 0:
        return new Projection("Padding", [$var89[2], $var89[1], new Projection("Rescale", [$var89[4], $var89[5], $var89[3]])]);

      case 1:
        return new Projection("Rescale", [$var89[4], $var89[5], new Projection("Padding", [$var89[2], $var89[1], $var89[3]])]);

      case 2:
        return proj;
    }
  };

  var projectInv = __exports.projectInv = function (_arg1_0, _arg1_1, point_0, point_1, projection) {
    projectInv: while (true) {
      var _arg1 = [_arg1_0, _arg1_1];
      var point = [point_0, point_1];
      var matchValue = [projection, point];

      if (matchValue[0].Case === "Padding") {
        var y = matchValue[1][1].Fields[0];
        var x = matchValue[1][0].Fields[0];
        var t = matchValue[0].Fields[0][0];
        var r = matchValue[0].Fields[0][1];
        var projection_1 = matchValue[0].Fields[2];
        var ly = matchValue[0].Fields[1][2];
        var lx = matchValue[0].Fields[1][0];
        var l = matchValue[0].Fields[0][3];
        var hy = matchValue[0].Fields[1][3];
        var hx = matchValue[0].Fields[1][1];
        var b = matchValue[0].Fields[0][2];
        var patternInput = project(_arg1[0], _arg1[1], lx, ly, projection_1);
        var y1 = patternInput[1].Fields[0];
        var x1 = patternInput[0].Fields[0];
        var patternInput_1 = project(_arg1[0], _arg1[1], hx, hy, projection_1);
        var y2 = patternInput_1[1].Fields[0];
        var x2 = patternInput_1[0].Fields[0];
        var patternInput_2 = [x1 < x2 ? x1 : x2, x1 > x2 ? x1 : x2, y1 < y2 ? y1 : y2, y1 > y2 ? y1 : y2];
        var oy = point[1].Fields[0];
        var ox = point[0].Fields[0];
        var nx = (ox - patternInput_2[0] - l) / (patternInput_2[1] - patternInput_2[0] - l - r) * (patternInput_2[1] - patternInput_2[0]) + patternInput_2[0];
        var ny = (oy - patternInput_2[2] - t) / (patternInput_2[3] - patternInput_2[2] - t - b) * (patternInput_2[3] - patternInput_2[2]) + patternInput_2[2];
        _arg1_0 = _arg1[0];
        _arg1_1 = _arg1[1];
        point_0 = new continuous("CO", [nx]);
        point_1 = new continuous("CO", [ny]);
        projection = projection_1;
        continue projectInv;
      } else if (matchValue[0].Case === "Scale") {
        var y_1 = matchValue[1][1];
        var x_1 = matchValue[1][0];
        var ty = matchValue[0].Fields[1];
        var tx = matchValue[0].Fields[0];
        return [scaleOneInv(tx[0], tx[1], _arg1[0], x_1), scaleOneInv(ty[0], ty[1], _arg1[1], y_1)];
      } else {
        var y_2 = matchValue[1][1].Fields[0];
        var x_2 = matchValue[1][0].Fields[0];
        var rly = matchValue[0].Fields[1][0];
        var rlx = matchValue[0].Fields[0][0];
        var rhy = matchValue[0].Fields[1][1];
        var rhx = matchValue[0].Fields[0][1];
        var projection_2 = matchValue[0].Fields[2];
        var patternInput_3 = [Scales.getExtremes(_arg1[0]), Scales.getExtremes(_arg1[1])];
        var ly_1 = patternInput_3[1][0];
        var lx_1 = patternInput_3[0][0];
        var hy_1 = patternInput_3[1][1];
        var hx_1 = patternInput_3[0][1];
        var patternInput_4 = [project(_arg1[0], _arg1[1], lx_1, ly_1, projection_2), project(_arg1[0], _arg1[1], hx_1, hy_1, projection_2)];
        var y2_1 = patternInput_4[1][1].Fields[0];
        var y1_1 = patternInput_4[0][1].Fields[0];
        var x2_1 = patternInput_4[1][0].Fields[0];
        var x1_1 = patternInput_4[0][0].Fields[0];
        var patternInput_5 = [x1_1 < x2_1 ? x1_1 : x2_1, x1_1 > x2_1 ? x1_1 : x2_1, y1_1 < y2_1 ? y1_1 : y2_1, y1_1 > y2_1 ? y1_1 : y2_1];
        var oy_1 = point[1].Fields[0];
        var ox_1 = point[0].Fields[0];
        var nx_1 = patternInput_5[0] + ((ox_1 - patternInput_5[0]) / (patternInput_5[1] - patternInput_5[0]) - rlx) / (rhx - rlx) * (patternInput_5[1] - patternInput_5[0]);
        var ny_1 = patternInput_5[2] + ((oy_1 - patternInput_5[2]) / (patternInput_5[3] - patternInput_5[2]) - rly) / (rhy - rly) * (patternInput_5[3] - patternInput_5[2]);
        _arg1_0 = _arg1[0];
        _arg1_1 = _arg1[1];
        point_0 = new continuous("CO", [nx_1]);
        point_1 = new continuous("CO", [ny_1]);
        projection = projection_2;
        continue projectInv;
      }
    }
  };

  var calculateProjections = __exports.calculateProjections = function (shape, projection) {
    calculateProjections: while (true) {
      if (shape.Fields[2].Case === "ScaledStyle") {
        var style = shape.Fields[2].Fields[0];
        var shape_1 = shape.Fields[2].Fields[1];
        return new ProjectedShape("Projected", [projection, shape.Fields[0], new ProjectedShapeInner("ProjectedStyle", [style, calculateProjections(shape_1, projection)])]);
      } else if (shape.Fields[2].Case === "ScaledOuterScale") {
        var sy = shape.Fields[0][1];
        var sx = shape.Fields[0][0];
        var shape_2 = shape.Fields[2].Fields[2];
        var osy = shape.Fields[2].Fields[1];
        var osx = shape.Fields[2].Fields[0];

        var adaptProjection = function adaptProjection(os) {
          return function (s) {
            if (os != null) {
              var patternInput = Scales.getExtremes(s);
              var patternInput_1 = [scaleOne(0, 1, s, patternInput[0]), scaleOne(0, 1, s, patternInput[1])];
              var patternInput_2 = Scales.getExtremes(os);
              var patternInput_3 = [scaleOne(0, 1, s, patternInput_2[0]), scaleOne(0, 1, s, patternInput_2[1])];
              var lo_ = patternInput_3[0].Fields[0];
              var ho_ = patternInput_3[1].Fields[0];
              return [lo_, ho_];
            } else {
              return [0, 1];
            }
          };
        };

        var px = adaptProjection(osx)(sx);
        var py = adaptProjection(osy)(sy);
        var projection_1 = new Projection("Rescale", [px, py, projection]);
        var patternInput_4 = calculateProjections(shape_2, projection_1);
        return new ProjectedShape("Projected", [patternInput_4.Fields[0], patternInput_4.Fields[1], patternInput_4.Fields[2]]);
      } else if (shape.Fields[2].Case === "ScaledLine") {
        var line = shape.Fields[2].Fields[0];
        return new ProjectedShape("Projected", [projection, shape.Fields[0], new ProjectedShapeInner("ProjectedLine", [line])]);
      } else if (shape.Fields[2].Case === "ScaledText") {
        var y = shape.Fields[2].Fields[1];
        var x = shape.Fields[2].Fields[0];
        var va = shape.Fields[2].Fields[2];
        var t = shape.Fields[2].Fields[5];
        var r = shape.Fields[2].Fields[4];
        var ha = shape.Fields[2].Fields[3];
        return new ProjectedShape("Projected", [projection, shape.Fields[0], new ProjectedShapeInner("ProjectedText", [x, y, va, ha, r, t])]);
      } else if (shape.Fields[2].Case === "ScaledBubble") {
        var y_1 = shape.Fields[2].Fields[1];
        var x_1 = shape.Fields[2].Fields[0];
        var ry = shape.Fields[2].Fields[3];
        var rx = shape.Fields[2].Fields[2];
        return new ProjectedShape("Projected", [projection, shape.Fields[0], new ProjectedShapeInner("ProjectedBubble", [x_1, y_1, rx, ry])]);
      } else if (shape.Fields[2].Case === "ScaledShape") {
        var points = shape.Fields[2].Fields[0];
        return new ProjectedShape("Projected", [projection, shape.Fields[0], new ProjectedShapeInner("ProjectedShape", [points])]);
      } else if (shape.Fields[2].Case === "ScaledPadding") {
        var t_1 = shape.Fields[2].Fields[0][0];
        var shape_3 = shape.Fields[2].Fields[1];
        var r_1 = shape.Fields[2].Fields[0][1];
        var l = shape.Fields[2].Fields[0][3];
        var b = shape.Fields[2].Fields[0][2];
        var patternInput_5 = void 0;
        var syinner = shape_3.Fields[1][1];
        var sxinner = shape_3.Fields[1][0];
        patternInput_5 = [Scales.getExtremes(sxinner), Scales.getExtremes(syinner)];
        var ly = patternInput_5[1][0];
        var lx = patternInput_5[0][0];
        var hy = patternInput_5[1][1];
        var hx = patternInput_5[0][1];
        var ppad = new Projection("Padding", [[t_1, r_1, b, l], [lx, hx, ly, hy], projection]);
        shape = shape_3;
        projection = ppad;
        continue calculateProjections;
      } else if (shape.Fields[2].Case === "ScaledStack") {
        var shapes = shape.Fields[2].Fields[1];
        var orient = shape.Fields[2].Fields[0];
        return new ProjectedShape("Projected", [projection, shape.Fields[0], new ProjectedShapeInner("ProjectedStack", [orient, shapes.map(function (s_1) {
          return calculateProjections(s_1, projection);
        })])]);
      } else if (shape.Fields[2].Case === "ScaledLayered") {
        var shapes_1 = shape.Fields[2].Fields[0];
        return new ProjectedShape("Projected", [projection, shape.Fields[0], new ProjectedShapeInner("ProjectedLayered", [shapes_1.map(function (s_2) {
          return calculateProjections(s_2, projection);
        })])]);
      } else if (shape.Fields[2].Case === "ScaledInteractive") {
        var shape_4 = shape.Fields[2].Fields[1];
        var f = shape.Fields[2].Fields[0];
        return new ProjectedShape("Projected", [projection, shape.Fields[0], new ProjectedShapeInner("ProjectedInteractive", [f, calculateProjections(shape_4, projection)])]);
      } else {
        var shape_5 = shape.Fields[2].Fields[1];
        var offs = shape.Fields[2].Fields[0];
        return new ProjectedShape("Projected", [projection, shape.Fields[0], new ProjectedShapeInner("ProjectedOffset", [offs, calculateProjections(shape_5, projection)])]);
      }
    }
  };

  return __exports;
}({});
export var Drawing = function (__exports) {
  var DrawingContext = __exports.DrawingContext = function () {
    function DrawingContext(style, definitions) {
      _classCallCheck(this, DrawingContext);

      this.Style = style;
      this.Definitions = definitions;
    }

    _createClass(DrawingContext, [{
      key: _Symbol.reflection,
      value: function () {
        return {
          type: "TheGamma.Interactive.Compost.Drawing.DrawingContext",
          interfaces: ["FSharpRecord"],
          properties: {
            Style: Style,
            Definitions: _Array(DomNode)
          }
        };
      }
    }]);

    return DrawingContext;
  }();

  setType("TheGamma.Interactive.Compost.Drawing.DrawingContext", DrawingContext);

  var hideFill = __exports.hideFill = function (style) {
    var Fill = new FillStyle("Solid", [[0, new Color("RGB", [0, 0, 0])]]);
    var Animation = void 0;

    if (style.Animation != null) {
      var n = style.Animation[0];
      var f = style.Animation[2];
      var e = style.Animation[1];
      Animation = [n, e, function ($var90) {
        return function (style_1) {
          return hideFill(style_1);
        }(f($var90));
      }];
    } else {
      Animation = null;
    }

    return new Style(style.StrokeColor, style.StrokeWidth, style.StrokeDashArray, Fill, Animation, style.Font, style.Cursor, style.FormatAxisXLabel, style.FormatAxisYLabel);
  };

  var hideStroke = __exports.hideStroke = function (style) {
    var StrokeColor = [0, style.StrokeColor[1]];
    var Animation = void 0;

    if (style.Animation != null) {
      var n = style.Animation[0];
      var f = style.Animation[2];
      var e = style.Animation[1];
      Animation = [n, e, function ($var91) {
        return function (style_1) {
          return hideStroke(style_1);
        }(f($var91));
      }];
    } else {
      Animation = null;
    }

    return new Style(StrokeColor, style.StrokeWidth, style.StrokeDashArray, style.Fill, Animation, style.Font, style.Cursor, style.FormatAxisXLabel, style.FormatAxisYLabel);
  };

  var drawShape = __exports.drawShape = function (ctx, shape) {
    var _loop = function _loop() {
      var sy = shape.Fields[1][1];
      var sx = shape.Fields[1][0];

      var projectCont = function projectCont(tupledArg) {
        var matchValue = Projections.project(sx, sy, tupledArg[0], tupledArg[1], shape.Fields[0]);
        var y = matchValue[1].Fields[0];
        var x = matchValue[0].Fields[0];
        return [x, y];
      };

      var projectContCov = function projectContCov(tupledArg_1) {
        return projectCont([new Value("COV", [tupledArg_1[0]]), new Value("COV", [tupledArg_1[1]])]);
      };

      var matchValue_1 = [shape.Fields[2], [sx, sy]];

      if (matchValue_1[0].Case === "ProjectedStyle") {
        var shape_1 = matchValue_1[0].Fields[1];
        var sf = matchValue_1[0].Fields[0];
        ctx = new DrawingContext(sf(ctx.Style), ctx.Definitions);
        shape = shape_1;
        return "continue|drawShape";
      } else if (matchValue_1[0].Case === "ProjectedText") {
        var y_1 = matchValue_1[0].Fields[1];
        var x_1 = matchValue_1[0].Fields[0];
        var va = matchValue_1[0].Fields[2];
        var t = matchValue_1[0].Fields[5];
        var r = matchValue_1[0].Fields[4];
        var ha = matchValue_1[0].Fields[3];
        var va_1 = va.Case === "Hanging" ? "hanging" : va.Case === "Middle" ? "middle" : "baseline";
        var ha_1 = ha.Case === "Center" ? "middle" : ha.Case === "End" ? "end" : "start";
        var xy = projectCont([x_1, y_1]);
        return {
          v: new Svg.Svg("Text", [xy, t, r, fsFormat("alignment-baseline:%s; text-anchor:%s;")(function (x) {
            return x;
          })(va_1)(ha_1) + Svg.formatStyle(ctx.Definitions, ctx.Style)])
        };
      } else if (matchValue_1[0].Case === "ProjectedBubble") {
        var y_2 = matchValue_1[0].Fields[1];
        var x_2 = matchValue_1[0].Fields[0];
        var ry = matchValue_1[0].Fields[3];
        var rx = matchValue_1[0].Fields[2];
        return {
          v: new Svg.Svg("Ellipse", [projectCont([x_2, y_2]), [rx, ry], Svg.formatStyle(ctx.Definitions, ctx.Style)])
        };
      } else if (matchValue_1[0].Case === "ProjectedLine") {
        var line = matchValue_1[0].Fields[0];

        var path = _Array$from(toList(delay(function () {
          return append(singleton(new Svg.PathSegment("MoveTo", [projectCont(head(line))])), delay(function () {
            return map(function (pt) {
              return new Svg.PathSegment("LineTo", [projectCont(pt)]);
            }, skip(1, line));
          }));
        })));

        return {
          v: new Svg.Svg("Path", [path, Svg.formatStyle(ctx.Definitions, hideFill(ctx.Style))])
        };
      } else if (matchValue_1[0].Case === "ProjectedShape") {
        var points = matchValue_1[0].Fields[0];

        var path_1 = _Array$from(delay(function () {
          return append(singleton(new Svg.PathSegment("MoveTo", [projectCont(points[0])])), delay(function () {
            return append(map(function (pt_1) {
              return new Svg.PathSegment("LineTo", [projectCont(pt_1)]);
            }, skip(1, points)), delay(function () {
              return singleton(new Svg.PathSegment("LineTo", [projectCont(points[0])]));
            }));
          }));
        }));

        return {
          v: new Svg.Svg("Path", [path_1, Svg.formatStyle(ctx.Definitions, hideStroke(ctx.Style))])
        };
      } else if (matchValue_1[0].Case === "ProjectedLayered") {
        var shapes = matchValue_1[0].Fields[0];
        return {
          v: new Svg.Svg("Combine", [shapes.map(function (s) {
            return drawShape(ctx, s);
          })])
        };
      } else if (matchValue_1[0].Case === "ProjectedStack") {
        var shapes_1 = matchValue_1[0].Fields[1];
        return {
          v: new Svg.Svg("Combine", [shapes_1.map(function (s_1) {
            return drawShape(ctx, s_1);
          })])
        };
      } else if (matchValue_1[0].Case === "ProjectedInteractive") {
        var shape_2 = matchValue_1[0].Fields[1];
        var f = matchValue_1[0].Fields[0];
        ctx = ctx;
        shape = shape_2;
        return "continue|drawShape";
      } else {
        var shape_3 = matchValue_1[0].Fields[1];
        var dy = matchValue_1[0].Fields[0][1];
        var dx = matchValue_1[0].Fields[0][0];
        return {
          v: Svg.mapSvg(function (_arg1) {
            if (_arg1.Case === "Text") {
              var y_3 = _arg1.Fields[0][1];
              var x_3 = _arg1.Fields[0][0];
              return new Svg.Svg("Text", [[x_3 + dx, y_3 + dy], _arg1.Fields[1], _arg1.Fields[2], _arg1.Fields[3]]);
            } else if (_arg1.Case === "Path") {
              return new Svg.Svg("Path", [_arg1.Fields[0].map(function (_arg2) {
                if (_arg2.Case === "LineTo") {
                  var y_4 = _arg2.Fields[0][1];
                  var x_4 = _arg2.Fields[0][0];
                  return new Svg.PathSegment("LineTo", [[x_4 + dx, y_4 + dy]]);
                } else {
                  var y_5 = _arg2.Fields[0][1];
                  var x_5 = _arg2.Fields[0][0];
                  return new Svg.PathSegment("MoveTo", [[x_5 + dx, y_5 + dy]]);
                }
              }), _arg1.Fields[1]]);
            } else {
              return _arg1;
            }
          }, drawShape(ctx, shape_3))
        };
      }
    };

    drawShape: while (true) {
      var _ret = _loop();

      switch (_ret) {
        case "continue|drawShape":
          continue drawShape;

        default:
          if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;
      }
    }
  };

  return __exports;
}({});
export var Events = function (__exports) {
  var MouseEventKind = __exports.MouseEventKind = function () {
    function MouseEventKind(caseName, fields) {
      _classCallCheck(this, MouseEventKind);

      this.Case = caseName;
      this.Fields = fields;
    }

    _createClass(MouseEventKind, [{
      key: _Symbol.reflection,
      value: function () {
        return {
          type: "TheGamma.Interactive.Compost.Events.MouseEventKind",
          interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
          cases: {
            Click: [],
            Down: [],
            Move: [],
            Up: []
          }
        };
      }
    }, {
      key: "Equals",
      value: function (other) {
        return equalsUnions(this, other);
      }
    }, {
      key: "CompareTo",
      value: function (other) {
        return compareUnions(this, other);
      }
    }]);

    return MouseEventKind;
  }();

  setType("TheGamma.Interactive.Compost.Events.MouseEventKind", MouseEventKind);

  var TouchEventKind = __exports.TouchEventKind = function () {
    function TouchEventKind(caseName, fields) {
      _classCallCheck(this, TouchEventKind);

      this.Case = caseName;
      this.Fields = fields;
    }

    _createClass(TouchEventKind, [{
      key: _Symbol.reflection,
      value: function () {
        return {
          type: "TheGamma.Interactive.Compost.Events.TouchEventKind",
          interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
          cases: {
            Move: [],
            Start: []
          }
        };
      }
    }, {
      key: "Equals",
      value: function (other) {
        return equalsUnions(this, other);
      }
    }, {
      key: "CompareTo",
      value: function (other) {
        return compareUnions(this, other);
      }
    }]);

    return TouchEventKind;
  }();

  setType("TheGamma.Interactive.Compost.Events.TouchEventKind", TouchEventKind);

  var InteractiveEvent = __exports.InteractiveEvent = function () {
    function InteractiveEvent(caseName, fields) {
      _classCallCheck(this, InteractiveEvent);

      this.Case = caseName;
      this.Fields = fields;
    }

    _createClass(InteractiveEvent, [{
      key: _Symbol.reflection,
      value: function () {
        return {
          type: "TheGamma.Interactive.Compost.Events.InteractiveEvent",
          interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
          cases: {
            MouseEvent: [MouseEventKind, Tuple([makeGeneric(Value, {
              u: GenericParam("vx")
            }), makeGeneric(Value, {
              u: GenericParam("vy")
            })])],
            MouseLeave: [],
            TouchEnd: [],
            TouchEvent: [TouchEventKind, Tuple([makeGeneric(Value, {
              u: GenericParam("vx")
            }), makeGeneric(Value, {
              u: GenericParam("vy")
            })])]
          }
        };
      }
    }, {
      key: "Equals",
      value: function (other) {
        return equalsUnions(this, other);
      }
    }, {
      key: "CompareTo",
      value: function (other) {
        return compareUnions(this, other);
      }
    }]);

    return InteractiveEvent;
  }();

  setType("TheGamma.Interactive.Compost.Events.InteractiveEvent", InteractiveEvent);

  var projectEvent = __exports.projectEvent = function (scales_0, scales_1, projection, event) {
    var scales = [scales_0, scales_1];
    var $var92 = event.Case === "TouchEvent" ? event.Fields[1][0].Case === "COV" ? event.Fields[1][1].Case === "COV" ? [1, event.Fields[0], event.Fields[1][0].Fields[0], event.Fields[1][1].Fields[0]] : [2] : [2] : event.Case === "TouchEnd" ? [3] : event.Case === "MouseLeave" ? [4] : event.Fields[1][0].Case === "COV" ? event.Fields[1][1].Case === "COV" ? [0, event.Fields[0], event.Fields[1][0].Fields[0], event.Fields[1][1].Fields[0]] : [2] : [2];

    switch ($var92[0]) {
      case 0:
        return new InteractiveEvent("MouseEvent", [$var92[1], function () {
          var tupledArg = [$var92[2], $var92[3]];
          var projection_1 = Projections.invertProj(projection);
          return Projections.projectInv(scales[0], scales[1], tupledArg[0], tupledArg[1], projection_1);
        }()]);

      case 1:
        return new InteractiveEvent("TouchEvent", [$var92[1], function () {
          var tupledArg_1 = [$var92[2], $var92[3]];
          var projection_2 = Projections.invertProj(projection);
          return Projections.projectInv(scales[0], scales[1], tupledArg_1[0], tupledArg_1[1], projection_2);
        }()]);

      case 2:
        throw new Error("TODO: projectEvent - not continuous");

      case 3:
        return new InteractiveEvent("TouchEnd", []);

      case 4:
        return new InteractiveEvent("MouseLeave", []);
    }
  };

  var inScale = __exports.inScale = function (s, v) {
    var matchValue = [s, v];

    if (matchValue[0].Case === "Categorical") {
      if (matchValue[1].Case === "COV") {
        throw new Error("inScale: Cannot test if continuous value is in categorical scale");
      } else {
        return exists(function (y) {
          return matchValue[1].Fields[0].Equals(y);
        }, matchValue[0].Fields[0]);
      }
    } else if (matchValue[1].Case === "CAR") {
      throw new Error("inScale: Cannot test if categorical value is in continuous scale");
    } else if (matchValue[1].Fields[0].Fields[0] >= (matchValue[0].Fields[0].Fields[0] < matchValue[0].Fields[1].Fields[0] ? matchValue[0].Fields[0].Fields[0] : matchValue[0].Fields[1].Fields[0])) {
      return matchValue[1].Fields[0].Fields[0] <= (matchValue[0].Fields[0].Fields[0] > matchValue[0].Fields[1].Fields[0] ? matchValue[0].Fields[0].Fields[0] : matchValue[0].Fields[1].Fields[0]);
    } else {
      return false;
    }
  };

  var inScales = __exports.inScales = function (sx, sy, event) {
    var $var93 = event.Case === "TouchEnd" ? [1] : event.Case === "MouseEvent" ? [2, event.Fields[1][0], event.Fields[1][1]] : event.Case === "TouchEvent" ? [2, event.Fields[1][0], event.Fields[1][1]] : [0];

    switch ($var93[0]) {
      case 0:
        return true;

      case 1:
        return true;

      case 2:
        if (inScale(sx, $var93[1])) {
          return inScale(sy, $var93[2]);
        } else {
          return false;
        }

    }
  };

  var triggerEvent = __exports.triggerEvent = function (shape, jse, event) {
    var $var94 = shape.Fields[2].Case === "ProjectedText" ? [0] : shape.Fields[2].Case === "ProjectedBubble" ? [0] : shape.Fields[2].Case === "ProjectedShape" ? [0] : shape.Fields[2].Case === "ProjectedStyle" ? [1, shape.Fields[2].Fields[1]] : shape.Fields[2].Case === "ProjectedOffset" ? [1, shape.Fields[2].Fields[1]] : shape.Fields[2].Case === "ProjectedStack" ? [2, shape.Fields[2].Fields[1]] : shape.Fields[2].Case === "ProjectedLayered" ? [2, shape.Fields[2].Fields[0]] : shape.Fields[2].Case === "ProjectedInteractive" ? [3] : [0];

    switch ($var94[0]) {
      case 0:
        break;

      case 1:
        triggerEvent($var94[1], jse, event);
        break;

      case 2:
        for (var idx = 0; idx <= $var94[1].length - 1; idx++) {
          var shape_1 = $var94[1][idx];
          triggerEvent(shape_1, jse, event);
        }

        break;

      case 3:
        var localEvent = projectEvent(shape.Fields[1][0], shape.Fields[1][1], shape.Fields[0], event);

        if (inScales(shape.Fields[1][0], shape.Fields[1][1], localEvent)) {
          var _iteratorNormalCompletion2 = true;
          var _didIteratorError2 = false;
          var _iteratorError2 = undefined;

          try {
            for (var _iterator2 = _getIterator(shape.Fields[2].Fields[0]), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
              var handler = _step2.value;
              var matchValue = [localEvent, handler];
              var $var95 = matchValue[0].Case === "TouchEvent" ? matchValue[0].Fields[0].Case === "Start" ? matchValue[1].Case === "TouchStart" ? [1, matchValue[1].Fields[0], matchValue[0].Fields[1]] : [4] : matchValue[1].Case === "TouchMove" ? [1, matchValue[1].Fields[0], matchValue[0].Fields[1]] : [4] : matchValue[0].Case === "TouchEnd" ? matchValue[1].Case === "TouchEnd" ? [2, matchValue[1].Fields[0]] : [4] : matchValue[0].Case === "MouseLeave" ? matchValue[1].Case === "MouseLeave" ? [3, matchValue[1].Fields[0]] : [4] : matchValue[0].Fields[0].Case === "Move" ? matchValue[1].Case === "MouseMove" ? [0, matchValue[1].Fields[0], matchValue[0].Fields[1]] : [4] : matchValue[0].Fields[0].Case === "Up" ? matchValue[1].Case === "MouseUp" ? [0, matchValue[1].Fields[0], matchValue[0].Fields[1]] : [4] : matchValue[0].Fields[0].Case === "Down" ? matchValue[1].Case === "MouseDown" ? [0, matchValue[1].Fields[0], matchValue[0].Fields[1]] : [4] : matchValue[1].Case === "Click" ? [0, matchValue[1].Fields[0], matchValue[0].Fields[1]] : [4];

              switch ($var95[0]) {
                case 0:
                  if (jse != null) {
                    jse.preventDefault();
                  }

                  $var95[1](jse)($var95[2]);
                  break;

                case 1:
                  if (jse != null) {
                    jse.preventDefault();
                  }

                  $var95[1](jse)($var95[2]);
                  break;

                case 2:
                  $var95[1](jse);
                  break;

                case 3:
                  $var95[1](jse);
                  break;

                case 4:
                  break;
              }
            }
          } catch (err) {
            _didIteratorError2 = true;
            _iteratorError2 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion2 && _iterator2.return) {
                _iterator2.return();
              }
            } finally {
              if (_didIteratorError2) {
                throw _iteratorError2;
              }
            }
          }
        }

        triggerEvent(shape.Fields[2].Fields[1], jse, event);
        break;
    }
  };

  return __exports;
}({});
export var Derived = function (__exports) {
  var Area = __exports.Area = function (line) {
    return new Shape("Shape", [delay(function () {
      var line_1 = _Array$from(line);

      var patternInput = [line_1[0][0], line_1[line_1.length - 1][0]];
      return append(singleton([patternInput[0], new Value("COV", [new continuous("CO", [0])])]), delay(function () {
        return append(line_1, delay(function () {
          return append(singleton([patternInput[1], new Value("COV", [new continuous("CO", [0])])]), delay(function () {
            return singleton([patternInput[0], new Value("COV", [new continuous("CO", [0])])]);
          }));
        }));
      }));
    })]);
  };

  var VArea = __exports.VArea = function (line) {
    return new Shape("Shape", [delay(function () {
      var line_1 = _Array$from(line);

      var patternInput = [line_1[0][1], line_1[line_1.length - 1][1]];
      return append(singleton([new Value("COV", [new continuous("CO", [0])]), patternInput[0]]), delay(function () {
        return append(line_1, delay(function () {
          return append(singleton([new Value("COV", [new continuous("CO", [0])]), patternInput[1]]), delay(function () {
            return singleton([new Value("COV", [new continuous("CO", [0])]), patternInput[0]]);
          }));
        }));
      }));
    })]);
  };

  var VShiftedArea = __exports.VShiftedArea = function (offs, line) {
    return new Shape("Shape", [delay(function () {
      var line_1 = _Array$from(line);

      var patternInput = [line_1[0][1], line_1[line_1.length - 1][1]];
      return append(singleton([new Value("COV", [new continuous("CO", [offs])]), patternInput[0]]), delay(function () {
        return append(line_1, delay(function () {
          return append(singleton([new Value("COV", [new continuous("CO", [offs])]), patternInput[1]]), delay(function () {
            return singleton([new Value("COV", [new continuous("CO", [offs])]), patternInput[0]]);
          }));
        }));
      }));
    })]);
  };

  var Bar = __exports.Bar = function (x, y) {
    return new Shape("Shape", [delay(function () {
      return append(singleton([new Value("COV", [x]), new Value("CAR", [y, 0])]), delay(function () {
        return append(singleton([new Value("COV", [x]), new Value("CAR", [y, 1])]), delay(function () {
          return append(singleton([new Value("COV", [new continuous("CO", [0])]), new Value("CAR", [y, 1])]), delay(function () {
            return singleton([new Value("COV", [new continuous("CO", [0])]), new Value("CAR", [y, 0])]);
          }));
        }));
      }));
    })]);
  };

  var Column = __exports.Column = function (x, y) {
    return new Shape("Shape", [delay(function () {
      return append(singleton([new Value("CAR", [x, 0]), new Value("COV", [y])]), delay(function () {
        return append(singleton([new Value("CAR", [x, 1]), new Value("COV", [y])]), delay(function () {
          return append(singleton([new Value("CAR", [x, 1]), new Value("COV", [new continuous("CO", [0])])]), delay(function () {
            return singleton([new Value("CAR", [x, 0]), new Value("COV", [new continuous("CO", [0])])]);
          }));
        }));
      }));
    })]);
  };

  return __exports;
}({});
export var Compost = function (__exports) {
  var defaultFormat = __exports.defaultFormat = function (scale, value) {
    if (value.Case === "COV") {
      var v = value.Fields[0].Fields[0];
      var dec = void 0;

      if (scale.Case === "Continuous") {
        var l = scale.Fields[0].Fields[0];
        var h = scale.Fields[1].Fields[0];
        dec = Scales.decimalPoints(l, h);
      } else {
        dec = 0;
      }

      return niceNumber(round(v, ~~dec), ~~dec);
    } else {
      var s = value.Fields[0].Fields[0];
      return s;
    }
  };

  var defstyle = __exports.defstyle = function () {
    var Fill = new FillStyle("Solid", [[1, new Color("RGB", [196, 196, 196])]]);
    var StrokeColor = [1, new Color("RGB", [256, 0, 0])];
    var StrokeDashArray = new List();
    var StrokeWidth = new Width("Pixels", [2]);
    var Animation = null;
    var Cursor = "default";
    return new Style(StrokeColor, StrokeWidth, StrokeDashArray, Fill, Animation, "10pt sans-serif", Cursor, function (scale) {
      return function (value) {
        return defaultFormat(scale, value);
      };
    }, function (scale_1) {
      return function (value_1) {
        return defaultFormat(scale_1, value_1);
      };
    });
  }();

  var mapShape = __exports.mapShape = function (f, _arg1) {
    var s = void 0;
    var $var96 = _arg1.Fields[2].Case === "ProjectedStack" ? [1] : _arg1.Fields[2].Case === "ProjectedLayered" ? [2] : _arg1.Fields[2].Case === "ProjectedInteractive" ? [3] : _arg1.Fields[2].Case === "ProjectedOffset" ? [4] : _arg1.Fields[2].Case === "ProjectedBubble" ? [5, _arg1.Fields[2]] : _arg1.Fields[2].Case === "ProjectedLine" ? [5, _arg1.Fields[2]] : _arg1.Fields[2].Case === "ProjectedShape" ? [5, _arg1.Fields[2]] : _arg1.Fields[2].Case === "ProjectedText" ? [5, _arg1.Fields[2]] : [0];

    switch ($var96[0]) {
      case 0:
        s = new Projections.ProjectedShapeInner("ProjectedStyle", [_arg1.Fields[2].Fields[0], mapShape(f, _arg1.Fields[2].Fields[1])]);
        break;

      case 1:
        s = new Projections.ProjectedShapeInner("ProjectedStack", [_arg1.Fields[2].Fields[0], _arg1.Fields[2].Fields[1].map(function (arg10_) {
          return mapShape(f, arg10_);
        })]);
        break;

      case 2:
        s = new Projections.ProjectedShapeInner("ProjectedLayered", [_arg1.Fields[2].Fields[0].map(function (arg10__1) {
          return mapShape(f, arg10__1);
        })]);
        break;

      case 3:
        s = new Projections.ProjectedShapeInner("ProjectedInteractive", [_arg1.Fields[2].Fields[0], mapShape(f, _arg1.Fields[2].Fields[1])]);
        break;

      case 4:
        s = new Projections.ProjectedShapeInner("ProjectedOffset", [_arg1.Fields[2].Fields[0], mapShape(f, _arg1.Fields[2].Fields[1])]);
        break;

      case 5:
        s = $var96[1];
        break;
    }

    return new Projections.ProjectedShape("Projected", [_arg1.Fields[0], _arg1.Fields[1], f(s)]);
  };

  var createSvg = __exports.createSvg = function (revX, revY, width, height, viz) {
    var scaled = Scales.calculateScales(defstyle, viz);
    var master = new Projections.Projection("Scale", [revX ? [width, 0] : [0, width], revY ? [0, height] : [height, 0]]);
    var projected = Projections.calculateProjections(scaled, master);
    var projected_1 = (!revX ? !revY : false) ? projected : mapShape(function (s) {
      if (s.Case === "ProjectedText") {
        var v = void 0;
        var $var97 = s.Fields[2].Case === "Baseline" ? revY ? [0] : [1] : [1];

        switch ($var97[0]) {
          case 0:
            v = new VerticalAlign("Hanging", []);
            break;

          case 1:
            var $var98 = s.Fields[2].Case === "Hanging" ? revY ? [0] : [1] : [1];

            switch ($var98[0]) {
              case 0:
                v = new VerticalAlign("Baseline", []);
                break;

              case 1:
                v = s.Fields[2];
                break;
            }

            break;
        }

        var h = void 0;
        var $var99 = s.Fields[3].Case === "Start" ? revX ? [0] : [1] : [1];

        switch ($var99[0]) {
          case 0:
            h = new HorizontalAlign("End", []);
            break;

          case 1:
            var $var100 = s.Fields[3].Case === "End" ? revX ? [0] : [1] : [1];

            switch ($var100[0]) {
              case 0:
                h = new HorizontalAlign("Start", []);
                break;

              case 1:
                h = s.Fields[3];
                break;
            }

            break;
        }

        return new Projections.ProjectedShapeInner("ProjectedText", [s.Fields[0], s.Fields[1], v, h, s.Fields[4], s.Fields[5]]);
      } else if (s.Case === "ProjectedOffset") {
        var oy = s.Fields[0][1];
        var ox = s.Fields[0][0];
        return new Projections.ProjectedShapeInner("ProjectedOffset", [[revX ? -ox : ox, revY ? -oy : oy], s.Fields[1]]);
      } else {
        return s;
      }
    }, projected);
    var defs = [];
    var svg = Drawing.drawShape(new Drawing.DrawingContext(defstyle, defs), projected_1);

    var getRelativeLocation = function getRelativeLocation(el) {
      return function (x) {
        return function (y) {
          var getOffset = function getOffset(parent) {
            return function (tupledArg) {
              getOffset: while (true) {
                if (parent == null) {
                  return [tupledArg[0], tupledArg[1]];
                } else {
                  var $var116 = parent.offsetParent;
                  tupledArg = [tupledArg[0] - parent.offsetLeft, tupledArg[1] - parent.offsetTop];
                  parent = $var116;
                  continue getOffset;
                }
              }
            };
          };

          var getParent = function getParent(parent_1) {
            getParent: while (true) {
              if (parent_1.namespaceURI === "http://www.w3.org/2000/svg" ? parent_1.tagName !== "svg" : false) {
                if (parent_1.parentElement != null) {
                  parent_1 = parent_1.parentElement;
                  continue getParent;
                } else {
                  parent_1 = parent_1.parentNode;
                  continue getParent;
                }
              } else if (parent_1.offsetParent != null) {
                return parent_1;
              } else if (parent_1.parentElement != null) {
                parent_1 = parent_1.parentElement;
                continue getParent;
              } else {
                parent_1 = parent_1.parentNode;
                continue getParent;
              }
            }
          };

          return getOffset(getParent(el))([x, y]);
        };
      };
    };

    var mouseHandler = function mouseHandler(kind) {
      return function (el_1) {
        return function (evt) {
          var evt_1 = evt;
          var patternInput = getRelativeLocation(el_1)(evt_1.pageX)(evt_1.pageY);
          Events.triggerEvent(projected_1, evt_1, new Events.InteractiveEvent("MouseEvent", [kind, [new Value("COV", [new continuous("CO", [patternInput[0]])]), new Value("COV", [new continuous("CO", [patternInput[1]])])]]));
        };
      };
    };

    var touchHandler = function touchHandler(kind_1) {
      return function (el_2) {
        return function (evt_2) {
          var evt_3 = evt_2;
          var touch = evt_3.touches[0];
          var patternInput_1 = getRelativeLocation(el_2)(touch.pageX)(touch.pageY);
          Events.triggerEvent(projected_1, evt_3, new Events.InteractiveEvent("TouchEvent", [kind_1, [new Value("COV", [new continuous("CO", [patternInput_1[0]])]), new Value("COV", [new continuous("CO", [patternInput_1[1]])])]]));
        };
      };
    };

    var counter = {
      contents: 0
    };
    var renderCtx = new Svg.RenderingContext(defs);
    return function (arg0) {
      return function (arg1) {
        return El.op_Dynamic(arg0, arg1);
      };
    }(h_1)("div")(ofArray([op_EqualsGreater("style", fsFormat("width:%dpx;height:%dpx;margin:0px auto 0px auto")(function (x) {
      return x;
    })(~~width)(~~height))]))(ofArray([function (arg0_1) {
      return function (arg1_1) {
        return El.op_Dynamic(arg0_1, arg1_1);
      };
    }(s_3)("svg")(ofArray([op_EqualsGreater("width", String(~~width)), op_EqualsGreater("height", String(~~height)), op_EqualsBangGreater("click", mouseHandler(new Events.MouseEventKind("Click", []))), op_EqualsBangGreater("mousemove", mouseHandler(new Events.MouseEventKind("Move", []))), op_EqualsBangGreater("mousedown", mouseHandler(new Events.MouseEventKind("Down", []))), op_EqualsBangGreater("mouseup", mouseHandler(new Events.MouseEventKind("Up", []))), op_EqualsBangGreater("mouseleave", function (_arg1) {
      return function (evt_4) {
        Events.triggerEvent(projected_1, evt_4, new Events.InteractiveEvent("MouseLeave", []));
      };
    }), op_EqualsBangGreater("touchmove", touchHandler(new Events.TouchEventKind("Move", []))), op_EqualsBangGreater("touchstart", touchHandler(new Events.TouchEventKind("Start", []))), op_EqualsBangGreater("touchend", function (_arg2) {
      return function (evt_5) {
        Events.triggerEvent(projected_1, evt_5, new Events.InteractiveEvent("TouchEnd", []));
      };
    })]))(toList(delay(function () {
      var body = _Array$from(Svg.renderSvg(renderCtx, svg));

      return append(defs, delay(function () {
        return body;
      }));
    })))]));
  };

  return __exports;
}({});
//# sourceMappingURL=compost.js.map