import _Array$from from "babel-runtime/core-js/array/from";
import _classCallCheck from "babel-runtime/helpers/classCallCheck";
import _createClass from "babel-runtime/helpers/createClass";
import { setType } from "fable-core/Symbol";
import _Symbol from "fable-core/Symbol";
import { compareRecords, equalsRecords } from "fable-core/Util";
import { map } from "fable-core/Seq";
import { split } from "fable-core/String";
export var LineColumnRange = function () {
  function LineColumnRange(startLineNumber, startColumn, endLineNumber, endColumn) {
    _classCallCheck(this, LineColumnRange);

    this.StartLineNumber = startLineNumber;
    this.StartColumn = startColumn;
    this.EndLineNumber = endLineNumber;
    this.EndColumn = endColumn;
  }

  _createClass(LineColumnRange, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.LineColumnRange",
        interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
        properties: {
          StartLineNumber: "number",
          StartColumn: "number",
          EndLineNumber: "number",
          EndColumn: "number"
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsRecords(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return compareRecords(this, other);
    }
  }]);

  return LineColumnRange;
}();
setType("TheGamma.LineColumnRange", LineColumnRange);
export var LocationMapper = function () {
  _createClass(LocationMapper, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.LocationMapper",
        properties: {}
      };
    }
  }]);

  function LocationMapper(code) {
    _classCallCheck(this, LocationMapper);

    this.lengths = _Array$from(map(function (s) {
      return s.length;
    }, split(code, "\n")));
  }

  _createClass(LocationMapper, [{
    key: "AbsoluteToLineCol",
    value: function (offs) {
      var line = 0;
      var col = 0;
      var offs_1 = offs;

      while (line <= this.lengths.length ? offs_1 > this.lengths[line] : false) {
        offs_1 = offs_1 - this.lengths[line] - 1;
        line = line + 1;
      }

      return [line + 1, offs_1 + 1];
    }
  }, {
    key: "LineColToAbsolute",
    value: function (line, col) {
      var offs = 0;

      for (var l = 1; l <= line - 1; l++) {
        offs = offs + this.lengths[l - 1] + 1;
      }

      return offs + col - 1;
    }
  }]);

  return LocationMapper;
}();
setType("TheGamma.LocationMapper", LocationMapper);
//# sourceMappingURL=locations.js.map